#!/usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Password' => 'Password',
	   'Files' => 'Files',
	   'View' => 'View',
	   'Main' => 'Main',
	   'current stored term' => 'current stored term',
	   'Error' => 'Error',
	   );

use CGI;

my $authfiledir = "/etc/apache2/auth_users";

eval require "admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;
print $q->header( -charset, $charset );

my $title = "$lex{View} $lex{Password} $lex{Files}";
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">\n";
print "$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">$lex{Main}</a> ]\n";
print "<h2>$title</h2>\n";


# Load files from auth directory.
opendir( my $dh, $authfiledir ) || print  "Cannot open $authfiledir: $! \n";

# Read the files.
my @files = ();
while ( my $file = readdir $dh ) {
    if ( $file eq '.' or $file eq '..' ) { next; }
    push @files, $file;
}
@files = sort @files;


foreach my $file ( @files ) {

    print qq{<table cellpadding="3" cellspacing="0" border="1" style="margin:0.5em;float:left;">\n};
    print "<tr><th>$file</th></tr>\n";

    $file = $authfiledir. '/'. $file;

    open (FH, '<',$file ) || print "Cannot open: $file: $!\n";
    while (<FH>) {

	my ($userid, $pwd) = split(':', $_);
	print "<tr><td>$userid</td></tr>\n";
    }
    close FH;
    print "</table>\n";

}


print "</body></html>\n";
