#!/usr/bin/perl
#  Copyright 2001-2011 Leslie Richardson

#  This file is part of Open Admin for Schools.

# View Cat-3 Data


my %lex = ('Error' => 'Error',
	   'Main' => 'Main',
	   'View' => 'View',
	   'Grade' => 'Grade',
	   'Student' => 'Student',
	   'Birthdate' => 'Birthdate',
	   'Gender' => 'Gender',
	   'Level' => 'Level',
	   'TDate' => 'TDate',

	   'Start Date' => 'Start Date',
	   'End Date' => 'End Date',
	   'Continue' => 'Continue',

	   );

my %fields = ('totalmath' => 'Total Math',
	      'totalreading' => 'Total Reading',
	      'totallanguage' => 'Total Language'
    );


my $self = 'cat3view.pl';


use DBI;
use CGI;


eval require "admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval { require "$globdir/global.conf"; };
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

#@dbase = sort keys %alldbase; # global records.


my @time = localtime(time);
my $year = $time[5] + 1900;
my $month = $time[4] + 1;
my $currdate = "$year-$month-$time[3]";
my $schyear = $year;
if ( $month < 7 ){ $schyear = $schyear - 1; }
my $prevyear = $schyear - 1;

my $currstartdate = "$schyear-08-01"; # Aug 1 of this school year
my $prevstartdate = "$prevyear-08-01"; # August 1 of prev year.


my $q = CGI->new;
my %arr = $q->Vars;
print $q->header( -charset, $charset );

my ($dsn, $dbh );
my $database = 'cat3';
$dsn = "DBI:$dbtype:dbname=$database";
$dbh = DBI->connect($dsn,$guser,$gpassword);

#my $schoolname = $alldbase{"$arr{db}"};

# Script Heading Descriptor
my $scriptheading = "$lex{View} CAT-3";

# Print Page Heading
print "$doctype\n<html><head><title>$scriptheading</title>\n";
print "<link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">\n";

print "$chartype\n</head><body style=\"padding:0.4em 2em;\">\n";
print "[ <a class=\"alt\" href=\"$homepage\">$lex{Main}</a> ]\n";
print "<h1>$scriptheading</h1>\n";

#if ( not $arr{page} ) {
#    showStartPage();

#} elsif ( $arr{page} == 1 ) {
#    delete $arr{page};
    viewCat3();
#}



#-----------
sub viewCat3 {
#-----------

    my $sth = $dbh->prepare("select * from cat3_data order by lastname, firstname, tdate, level"); 
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    # Prepare Statment
    my $sth1 = $dbh->prepare("select startcol, endcol from cat3_key where ident1 = ?
      and ident2 = 'GE' and level = ?");

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    
    print "<tr><th>$lex{Level}</th><th>$lex{TDate}</th><th>$lex{Student}</th>";
    print "<th>$lex{Grade}</th><th>$lex{Birthdate}</th>\n";
    print "<th>$lex{Gender}</th><th>Math</th><th>Reading</th><th>Lang</th></tr>\n";


    while ( my $ref = $sth->fetchrow_hashref ) {

	# Get other scores
	my $line = $ref->{datarow};
	my $level = $ref->{level};
	my %data = ();

	foreach my $key (keys %fields ) {
	    
	    # get start and end columns
	    $sth1->execute( $fields{$key}, $level);
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    my ( $startcol, $endcol ) = $sth1->fetchrow;

	    my $offset = $startcol - 1;
	    my $length = $endcol - $offset;

	    $data{$key} = substr($line, $offset, $length);
	    $data{$key} =~ s/\s+$//; # strip trailing spaces

	    # print "K:$key V:$data{$key}:\n";
    
	} # keys loop


	print "<tr><td>$ref->{level}</td><td>$ref->{tdate}</td>";
	print "<td><b>$ref->{lastname}</b>, $ref->{firstname}</td><td>$ref->{grade}</td>\n";
	print "<td>$ref->{birthdate}</td><td>$ref->{gender}</td>";

	print "<td>$data{totalmath}</td><td>$data{totalreading}</td><td>$data{totallanguage}</td>";

	print "</tr>\n";

    }

    print "</table>\n";
    print "</body></html>\n";

    exit;

}


#----------------
sub showStartPage {
#----------------

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\" ";
    print "style=\"padding:0.5em;border:1px solid gray;\">\n";

    print "<tr><td class=\"bra\">$lex{School} $lex{Database}</td><td class=\"la\">";
    print "<select name=\"db\"><option></option>\n";
    foreach my $db ( @dbase ) { print "<option>$db</option>"; }
    print "</select></td></tr>\n";


    print "<tr><td class=\"bra\">$lex{'Start Date'}</td><td class=\"la\"><input type=\"text\" ";
    print "name=\"startdate\" id=\"sdate\" size=\"10\" value=\"$prevstartdate\">";
    print "<button type=\"reset\" id=\"start_trigger\">...</button>\n";
    print "</td></tr>\n";

    print "<tr><td class=\"bra\">$lex{Split} $lex{Date}</td><td class=\"la\"><input type=\"text\" ";
    print "name=\"splitdate\" id=\"splitdate\" size=\"10\" value=\"$currstartdate\">";
    print "<button type=\"reset\" id=\"split_trigger\">...</button>\n";
    print "</td></tr>\n";

    print "<tr><td class=\"bra\">$lex{'End Date'}</td><td class=\"la\"><input type=\"text\" ";
    print "name=\"enddate\" id=\"edate\" size=\"10\" value=\"$currdate\">";
    print "<button type=\"reset\" id=\"end_trigger\">...</button></td></tr>\n";

    print "<tr><td></td><td class=\"la\"><input type=\"submit\" value=\"$lex{Continue}\"></td></tr>\n";
    print "</form>\n";

    print "<script type=\"text/javascript\">
     Calendar.setup({
        inputField     :    \"sdate\", 
        ifFormat       :    \"%Y-%m-%d\",
        button         :    \"start_trigger\",
        singleClick    :    false,
        step           :    1
    });

     Calendar.setup({
        inputField     :    \"splitdate\", 
        ifFormat       :    \"%Y-%m-%d\",
        button         :    \"split_trigger\",
        singleClick    :    false,
        step           :    1
    });

    Calendar.setup({
        inputField     :    \"edate\",
        ifFormat       :    \"%Y-%m-%d\",
        button         :    \"end_trigger\",
        singleClick    :    false,
        step           :    1
    });
    </script>\n";

    print "</body></html>\n";

    exit;

} # end of showStartPage
