#!/usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

#  You should have received a copy of the GNU General Public License
#  along with Open Admin; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

my %lex = ('View Students' => 'View Students',

	   );


use DBI;
use CGI;

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;


# Read config variables
eval require "../admin.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}


eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}


my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $iddst) = localtime(time);
$year = $year + 1900;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";


# HTML Heading
print "$doctype\n<html><head><title>". $lex{'View Students'};
print "</title><link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">\n";
print "<style type=\"text/css\">th.h {background-color:#99F;}</style>\n";
print "$chartype\n</head><body style=\"padding:1em 2em;\">\n";


print "<center><h1>". $lex{'View Students'}. "</h1><h3>$currdate</h3>\n";


foreach $database (keys %alldbase) { #defined in global config file.

    $dsn = "DBI:mysql:$database";
    $dbh = DBI->connect($dsn,$guser,$gpassword);

    my $select;
    if ( $arr{grade} ) {
	my $grade = $dbh->quote( $arr{grade} );
	$select = " where grade = $grade ";
    }

    my $sortorder = "lastname, firstname";
    if ( $arr{sortorder} eq "birthdate" ) {
	$sortorder = "birthdate";
    }


    my $sth = $dbh->prepare("select * from studentwd $select order by $sortorder");
    $sth->execute;
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $rows = $sth->rows;

    print "<h2>$alldbase{$database}</h2><table border=\"2\">\n";
    print "<tr><th>Name</th><th>Number</th><th>Grade</th><th>Sex</th>\n";
    print "<th>Birthdate</th><th>Prov \#</th></tr>\n";

    foreach  ( my $i=1; $i <= $rows; ++$i) {
	@arr = $sth->fetchrow;

	print "<tr><td><b>$arr[1], $arr[2] $arr[3]</b></td>\n";
	print "<td>$arr[4]</td><td>$arr[5]</td><td>$arr[7]</td><td>$arr[8]</td><td>$arr[57]</td>\n";
	print "</tr>\n\n";
    }
  
    print "</table>\n";

}  # End of Database reading Loop.

print "</center></body></html>";

