#!/usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

#  ===  View Special Needs Students in a particular school.

use DBI;
use CGI;


my $q = new CGI;
print $q->header;
my %arr = $q->Vars;

# Read config variables
require "../admin.conf" or die "Cannot open admin.conf!";


my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $iddst) = localtime(time);
my $year = $year + 1900;
$mon++;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";


my $database = 'iep2015';
my $dsn = "DBI:mysql:$database";
my $dbh = DBI->connect($dsn,$user,$password);



my $title = "View Special Needs Students";
print qq{$doctype\n};
print qq{<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="/division.css" type="text/css">\n};
print qq{</head><body>\n};

print qq{[ <a href="/index.shtml">Main</a> ]\n};
print qq{<h1>$title</h1><h3>$currdate</h3>\n};

my $sth = $dbh->prepare("select * from special where school = ? order by lastname, firstname");

print qq{<a name="top"></a>\n};
print qq{<div>\n};
foreach my $dbase ( sort keys %alldbase ) {
    print qq{<a href="#$dbase">$alldbase{$dbase}</a> |\n};
}
print qq{</div>\n};


foreach my $dbase ( sort keys %alldbase ) {

    my $first = 1;
    print qq{<a name="$dbase"></a><h2>$alldbase{$dbase}</h2>\n}; # school name


    # Get the students
    $sth->execute($dbase);
    if ($DBI::errstr){ print $DBI::errstr;  die $DBI::errstr; }
    while ( my $ref = $sth->fetchrow_hashref ) {
	my %r = %$ref;

	$first = 0;

	print qq{<table border="1" cellpadding="3" cellspacing="0">\n};
	# print qq{<tr><th>Name/ID</th><th>Description</th></tr>\n};
	print qq{<tr><td style="vertical-align:top;">\n};

	# Left Side Table
	print qq{<table>\n};
	print qq{<tr><td colspan="2" class="cn">\n};
	print qq{<div style="font-size:130%;font-weight:bold;">$r{firstname} $r{lastname}</div></td></tr>\n};
	print qq{<tr><td class="bra"><em>BDate</em></td><td>$r{birthdate}</td></tr>\n};
	print qq{<tr><td class="bra"><em>Grade</em></td><td>$r{grade}</td></tr>\n};
	print qq{<tr><td class="bra"><em>Gender</em></td><td>$r{sex}</td></tr>\n};
	print qq{<tr><td class="bra"><em>Studnum</em></td><td>$r{studnum}</td></tr>\n};
	print qq{<tr><td class="bra"><em>ProvNum</em></td><td>$r{provnum}</td></tr>\n};

	print qq{<tr><td class="cn" colspan="2">\n};
	print qq{<form action="/cgi-bin/iep/rptsummht.pl" method="post">\n};
	print qq{<input type="hidden" name="studnum" value="$r{studnum}">\n};
	print qq{<input type="hidden" name="school" value="$r{school}">\n};
	print qq{<input type="submit" value="View Detailed Report"></form>\n};
	print qq{</td></tr>\n};
	print qq{</table></td>\n};

	# Right Side Table
	print qq{<td style="align-vertical:top;"><table>\n};

	print qq{<tr><td class="bra">Designation</td><td>$r{designation}</td></tr>\n};
	print qq{<tr><td class="bra">Medical</td><td>$r{medical}</td></tr>\n};
	print qq{<tr><td class="bra">Medication</td><td>$r{medication}</td></tr>\n}; 
	print qq{<tr><td class="bra">Equipment</td><td>$r{equip}</td></tr>\n};
	print qq{<tr><td class="bra">Adaptations</td><td>$r{adapt}</td></tr>\n};
	print qq{<tr><td class="bra">History</td><td>$r{history}</td></tr>\n};

	print qq{<tr><td class="bra">Strengths</td><td> $r{strengths}</td></tr>\n};
	print qq{<tr><td class="bra">Challenges</td><td> $r{challenges}</td></tr>\n};
	print qq{<tr><td class="bra">Assessments</td><td> $r{assessments}</td></tr>\n};
	print qq{<tr><td class="bra">Additional</td><td> $r{additional}</td></tr>\n};
	# print qq{<tr><td class="bra"></td><td> $r{}</td></tr>\n};
	print qq{</table></td></tr>\n</table><p></p>\n};

    } # end of record loop

    if ( $first ) {
	print qq{<h3>No Students found.</h3>\n};
    } 

    print qq{<div>[ <a href="#top">Top</a> ]</div>\n};


} # end of database loop


print qq{</body></html>\n};
