#!/usr/bin/perl
#  Copyright 2001-2013 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Error' => 'Error',
	   'Add' => 'Add',
	   'Scores' => 'Scores',
	   'Student' => 'Student',
	   'Raw Score' => 'Raw Score',
	   'Continue' => 'Continue',
	   'Standard Score' => 'Standard Score',
	   'Percentile' => 'Percentile',
	   'Age' => 'Age',
	   'Equivalent' => 'Equivalent',
	   'Record(s) Stored' => 'Record(s) Stored',
	   'Save' => 'Save',
	   'Test Date' => 'Test Date',
	   'No User Id' => 'No User Id',
	   'No Password' => 'No Password',
	   'Please Log In' => 'Please Log In',
	   'Grade' => 'Grade',
	   'Select' => 'Select',
	   'No Blanks Allowed' => 'No Blanks Allowed',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Select' => 'Select',
	   'Students' => 'Students',
	   'No Students Found' => 'No Students Found',
	   'Enrol' => 'Enrol',
	   'Group' => 'Group',
	   'Blank=All' => 'Blank=All',
	   'Students' => 'Students',
	   'Added' => 'Added',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Yes' => 'Yes',
	   'Confirm' => 'Confirm',
	   'Start Date' => 'Start Date',
	   'End Date' => 'End Date',
	   'Hours' => 'Hours',
	   'Record(s) Deleted' => 'Record(s) Deleted',
	   'More' => 'More',
	   'Record(s) Updated' => 'Record(s) Updated',
	   'Update' => 'Update',
	   'Program' => 'Program',
	   'Comment' => 'Comment',
	   'Dropped' => 'Dropped',
	   'Attendance' => 'Attendance',
	   'Kit' => 'Kit',
	   'Lesson' => 'Lesson',
	   'Number' => 'Number',
	   'Initial' => 'Initial',
	   'Progress' => 'Progress',
	   'Report' => 'Report',
	   'Pre-test' => 'Pre-test',
	   'Post-test' => 'Post-test',
	   'Data' => 'Data',
	   'Gain' => 'Gain',
	   'Loss' => 'Loss',
	   'Total Hours' => 'Total Hours',
	   'Percentage' => 'Percentage',
	   'Attendance' => 'Attendance',
	   'Name' => 'Name',
	   'Instructor' => 'Instructor',
	   'Years' => 'Years',
	   'Date' => 'Date',

	   );

use DBI;
use CGI;
use CGI::Session;
use Number::Format qw(:all);

my $self = 'lintRptProgress.pl';

my $q = new CGI;
my %arr = $q->Vars;

my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $day = $tim[3];
if ( length( $month) == 1 ) { $month = '0'. $month; }
if ( length( $day) == 1 ) { $day = '0'. $day; }
my $currdate = "$year-$month-$day";


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Session Setup Here
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

my ( $userid, $duration);
# Get/Set  Session Values (a defined userid means it was passed)
if ( $arr{userid} ){ # we want to login, passed userid/password pair.

    # Check password/userid against database (-1 no user, -2 wrong password);
    my $error = checkPassword($arr{userid}, $arr{password});
    if ($error == -1){ print $q->header( -charset, $charset ); login($lex{'No User Id'}); }
    if ($error == -2){ print $q->header( -charset, $charset ); login($lex{'No Password'}); }

    $cookietime = checkCookieTime( $arr{duration} );

    # Set values for userid and logged_in in session
    $session->param( 'logged_in','1');
    $session->expire( 'logged_in', $cookietime );
    $session->param( 'userid',$arr{userid} );
    $session->param( 'duration',$cookietime );

    $userid = $arr{userid};


} else { # check logged_in value in session

    if ( not $session->param('logged_in') ){
	$userid = $session->param('userid');
        print $q->header( -charset, $charset );
	print "<p>[ <a href=\"$tchpage\">$lex{Main}</a> ]</p>\n";
        print "<h3>$lex{'Please Log In'}</h3></body></html>\n"; 
        exit;
    }
    # Ok, we have a login. Values below we have in environment.

    $userid = $session->param('userid');
    $duration = $session->param('duration');

    if ( not ($duration =~ /\+/)) { # if not in +20m format, do so.
	$duration = checkCookieTime( $duration );
    }

    $session->expire('logged_in', $duration );


} # End of check for logged_in value

print $session->header( -charset, $charset );
# Session Setup End


# Page Header
my $title = "$lex{Student} $lex{Progress} $lex{Report}";

print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";

print "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" ";
print "href=\"/js/calendar-blue.css\" title=\"blue\">\n";
print "<script type=\"text/javascript\" src=\"/js/calendar.js\"></script>\n";
print "<script type=\"text/javascript\" src=\"/js/lang/calendar-en.js\"></script>\n";
print "<script type=\"text/javascript\" src=\"/js/calendar-setup.js\"></script>\n";
print "<style type=\"text/css\">div.head { font-weight:bold;font-size:120%; }</style>\n";

print "$chartype\n</head><body style=\"padding:1em 2em;\">\n";
print "<p>[ <a href=\"$tchpage\">$lex{Main}</a> ]</p>\n";


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    mkHTMLReport();
} 


#----------------
sub showStartPage {
#----------------

    print "<h1>$title</h1>\n"; # both edit and delete

    print "<form action=\"$self\" method=\"post\"> \n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    print "<tr><td class=\"bra\">$lex{Select} $lex{Group}</td>\n";
    print "<td class=\"la\"><select name=\"program\"><option></option>\n";

    # Get Staff Name
    my $sth1 = $dbh->prepare("select lastname, firstname from staff where userid = ?");

    # Select Program
    my $sth = $dbh->prepare("select * from lint_program order by userid, startdate");
    $sth->execute;
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

    while ( my $ref = $sth->fetchrow_hashref ) {

	my %lr = %$ref;

=head
	# Get Names
	$sth1->execute( $ref->{userid} );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	my ( $lastname, $firstname ) = $sth1->fetchrow;
=cut

	# print qq{<option value="$lr{id}">$lastname, $firstname ($ref->{userid}) $ref->{startdate} ";
	print qq{<option value="$lr{id}">$lr{groupdesc} $lr{startdate}/$lr{userid}</option>\n};
	# print "$ref->{enddate} $ref->{groupdesc}</option>\n";
    }

    print "</select></td></tr>\n";


    # Continue
    print qq{<tr><td></td><td><input type=\"submit\" value="$lex{Continue}"></td></tr>\n};

    print "</table></form>\n";
    print "</body></html>\n";

    exit;

} # end of showStartPage



#---------------
sub mkHTMLReport {
#---------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $fulltitle = "Primary, Intermediate &amp; Middle Years<br>Literacy Intervention<br>$title";

    print qq{<h1 style="text-align:center;">$fulltitle</h1>\n};
    print qq{<div class="head">$schoolname</div>\n};


    # Get the Program Information
    my $sth = $dbh->prepare("select * from lint_program where id = ?");
    $sth->execute( $arr{program} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $progref = $sth->fetchrow_hashref;
    my %pr = %$progref;


    # Get the LLI Instructor
    $sth = $dbh->prepare("select lastname, firstname from staff where userid = ?");
    $sth->execute( $pr{userid} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth->fetchrow;

    print qq{<div class="head"> $firstname $lastname &ndash; $pr{groupdesc}</div>\n};
    print qq{<div class="head">}. formatDate($pr{startdate}). q{ &ndash; }. formatDate($pr{enddate}). qq{</div>\n};


    # Start Table and Headings.
    print qq{<table cellpadding="3" cellspacing="0" border="1" style="text-align:center;">\n};
    print qq{<tr><th>$lex{Name}</th><th>$lex{Grade}</th>\n};
    print qq{<th colspan="4">$lex{'Pre-test'} $lex{Data}</th>\n};
    print qq{<th>$lex{Initial} $lex{Kit}<br>/$lex{Lesson}</th>\n};
    print qq{<th colspan="4">$lex{'Post-test'} $lex{Data}</th>\n};
    print qq{<th>$lex{Gain}/$lex{Loss}<br>($lex{Years})</th><th>$lex{'Total Hours'}</th>\n};
    print qq{<th>$lex{Percentage}<br>$lex{Attendance}</th></tr>\n};

    print qq{<tr><th colspan="2"></th><th>$lex{Date}</th><th>DRA</th><th>Tot<br>Sc</th><th>Gr<br>Eq</th><th></th>\n};
    print qq{<th>$lex{Date}</th><th>DRA</th><th>Tot<br>Sc</th><th>Gr<br>Eq</th><th colspan="3"></th></tr>\n};


    # Get the students in program and names, studnum
    $sth = $dbh->prepare("select l.*,s.lastname,s.firstname, s.grade from lint_student l, studentall s
      where s.studnum = l.studnum and progid = ? order by s.lastname, s.firstname, l.id");

    # Get this test score and grade level
    my $sth2 = $dbh->prepare("select sum(score), count(*) from read_test_score 
      where testid = ?");


    $sth->execute( $arr{program} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    while ( my $ref = $sth->fetchrow_hashref ) {

	my %sr = %$ref; # sr = Student Record

	# Find the Pretest.
	my $sth1 = $dbh->prepare("select * from read_test where studnum = ? and
         to_days( tdate ) <= to_days('$pr{startdate}') order by tdate desc ");
	$sth1->execute( $sr{studnum} );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my $pretest_ref = $sth1->fetchrow_hashref;
	my %pretest = %$pretest_ref;

#	 foreach my $key ( sort keys %pretest ) { print "K:$key V:$pretest{$key}<br>\n"; }	

	# Get the pretest Scores
	$sth2->execute( $pretest{id} );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my ( $prescoretotal, $prescorecount ) = $sth2->fetchrow;
	my $prepossibletotal = $prescorecount * 4;

	my $equivgrade = scoreToGrade( $prescoretotal, $pretest{readlevel} );

	print qq{<tr><td class="la"><b>$sr{lastname}</b>, $sr{firstname} };
	if ( $sr{startdate} ) { print qq{<br><b>Late Entry</b> $sr{startdate}}; }
	print qq{</td><td>$sr{grade}</td>\n};
	print qq{<td>$pretest{tdate}</td>};
	print qq{<td>$pretest{readlevel}</td>};
	if ( $pretest{readlevel} < 40 ) {
	    print qq{<td>$prescoretotal</td>\n};
	} else {
	    print qq{<td>$prescoretotal / $prepossibletotal</td>\n};
	}
	print qq{<td>$equivgrade</td>\n};


	# Now the Kit info
	print qq{<td>$sr{initialkit} / $sr{initiallesson}</td>\n};

	if ( $sr{dropped} ) { # dropped course
	    print qq{<td>$sr{enddate}</td><td colspan="3"><b>Dropped</b></td>};
	    print qq{<td></td><td></td><td></td></tr>\n};

	} else {

	    # Find the Posttest.
	    $sth1 = $dbh->prepare("select * from read_test where studnum = ? and
              to_days( tdate ) >= to_days( '$pr{enddate}' ) ");
	    $sth1->execute( $sr{studnum} );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    my $posttest_ref = $sth1->fetchrow_hashref;
	    my %posttest = %$posttest_ref;

#	print "<div>Post Test</div>\n";
#	foreach my $key ( sort keys %posttest ) { print "K:$key V:$posttest{$key}<br>\n"; }	

	    # Get the posttest Scores
	    $sth2->execute( $posttest{id} );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    my ( $postscoretotal, $postscorecount ) = $sth2->fetchrow;
	    my $postpossibletotal = $postscorecount * 4;

	    my $postequivgrade = scoreToGrade( $postscoretotal, $posttest{readlevel} );

	    print qq{<td>$posttest{tdate}</td>\n};
	    print qq{<td>$posttest{readlevel}</td>\n};
	    if ( $posttest{readlevel} < 40 ) {
		print qq{<td>$postscoretotal</td>\n};
	    } else {
		print qq{<td>$postscoretotal / $postpossibletotal</td>\n};
	    }
	    print qq{<td>$postequivgrade</td>\n};

	    # Loss/Gain.
	    my $delta;
	    if ( $postequivgrade ) {
		$delta = $postequivgrade - $equivgrade;
	    }
	    print qq{<td>$delta</td>};

	    # Hours Taught / Percent Attendance. 
	    # Hours taught is entered by teacher, attendance is calculated.
	    print qq{<td>$sr{programhours}</td>};

	    my $attendance;
	    if ( not $pr{programhours} ) { 
		print "<h3>$lex{Error}: Program Hours not defined</h3>\n";
		print "</body></html>\n";
		exit;
	    } else {
		$attendance = format_number( ($sr{programhours} / $pr{programhours}) * 100, 2);
	    }

	    print qq{<td>$attendance %</td></tr>\n};
	} # end of else: (ie. not dropped)

    } # end of student loop.

    if ( $first ) {
	print "</table></form><h1>$lex{'No Students Found'}</h1>\n";
	print "</body></html>\n";
	exit;
    }

    print "</table>";
    print "</body></html>\n";

    exit;

} # end of mkHTMLReport



#-------------
sub formatDate {
#-------------

    my ( $year, $mon, $day ) = split /-/, shift;
    return "$year-$s_month[$mon]-$day";
}



#---------------
sub scoreToGrade {
#---------------

    my ($score, $readinglevel) = @_;

    my %rd_LevelToGrade = ( '0' => 0.1, 1 => 0.3, 2 => 0.6, 3 => 1.0, 4 => 1.2,
			    6 => 1.4, 8 => 1.5, 10 => 1.5, 12 => 1.6, 14 => 1.7,
			    16 => 1.9, 18 => '2.0', 20 => 2.2, 24 => 2.5, 28 => 2.9,
			    30 => 3.3, 34 => 3.6, 38 => 3.9);


    my %rd_ScoreToGrade = (
	50 => 1.9, 51 => 1.9, 52 => 1.9, 53 => 1.9, 54 => '2.0',
	55 => 2.1, 56 => 2.2, 57 => 2.3, 58 => 2.4,
	59 => 2.5, 60 => 2.6, 
	61 => 2.7, 62 => 2.8, 63 => 2.9, 64 => '3.0', 
	65 => 3.1, 66 => 3.2, 67 => 3.3, 68 => 3.4,
	69 => 3.5, 70 => 3.6, 71 => 3.7, 72 => 3.8, 73 => 3.9, 
	74 => '4.0', 75 => 4.1, 76 => 4.2, 77 => 4.3, 78 => 4.4, 79 => 4.5,
	80 => 4.6, 81 => 4.7, 82 => 4.8, 83 => 4.9, 84 => '5.0', 85 => 5.1, 86 => 5.6, 
	87 => 5.3, 88 => 5.4, 89 => 5.5, 90 => 5.6, 91 => 5.7, 92 => 5.8, 93 => 5.9, 
	94 => '6.0', 95 => 6.1, 96 => 6.2, 97 => 6.3, 98 => 6.4, 99 => 6.5, '100' => '6.6',
	101 => 6.6, 102 => 6.8, 103 => 6.9, 
	104 => '7.0', 105 => 7.1, 106 => 7.2, 107 => 7.3, 108 => 7.4, 109 => 7.5, '110' => '7.6',
	111 => 7.7, 112 => 7.8, 113 => 7.9, 114 => '8.0', 115 => 8.1, 116 => 8.2, 117 => 8.3, 118 => 8.4, 
	119 => 8.5, 120 => 8.6, 121 => 8.7, 122 => 8.8, 123 => 8.9, 124 => 8.9, 125 => 8.9, 126 => 8.9,
	127 => 8.9, 128 => 8.9 );

    #foreach my $key ( sort {$a <=> $b} keys %rd_LevelToGrade ) { print "K:$key V:$rd_LevelToGrade{$key}<br>\n"; }

    if ( not $score ) { return undef; }

    if ( $readinglevel < 40 ) {

	foreach my $key ( sort { $b <=> $a } keys %rd_LevelToGrade ) {
	    # print "K:$key ";
	    if ( $readinglevel >= $key ) {
		# print "<br><b>Match: K:$key RL:$readinglevel</b><br>\n";
		return $rd_LevelToGrade{ $key };
	    }
	}

    } else { # else reading level >= 40

	$score += $readinglevel; # add both together for this 

	foreach my $key ( sort { $b <=> $a } keys %rd_ScoreToGrade ) {
	    # print "K:$key ";
	    if ( $score >= $key ) {
		# print "<b>Match: S:$score K:$key V:$rd_ScoreToGrade{$key}</b><br>\n";
		return $rd_ScoreToGrade{ $key };
	    }
	}

    }

    return 'NA';
}
