#!/usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Mark View global - looks for Mark Entries for each term


use DBI;
use CGI;
#use Time::JulianDay;

my %lex = ('View' => 'View',
	   'Main' => 'Main',
	   'Mark' => 'Mark',
	   'Entry' => 'Entry',
	   'Term' => 'Term',
	   'Error' => 'Error',
	   'Continue' => 'Continue',
	   'Count' => 'Count',
	   'No Records Found' => 'No Records Found',
	   'Check All' => 'Check All',
	   'Total' => 'Total',
	   'Filled' => 'Filled',

	   );


# Read Config
eval require "admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my @dbase = sort keys %alldbase; # global records.


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my $title = "$lex{View} $lex{Mark} $lex{Entry}";
print "$doctype\n<html><head><title>$title</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body style=\"padding:1em;\">\n";

print "[ <a href=\"$homepage\">$lex{Main}</a> ]\n";

print "<h1>$title</h1>\n";

if ( not $arr{page} ) {
    showStartPage();

} else {
    delete $arr{page};
}


foreach my $dbase ( sort keys %arr ) {

    print qq{<h2>$alldbase{$dbase}</h2>\n};
    print qq{<div>\n}; # school section


    my $dsn = "DBI:$dbtype:dbname=$dbase";
    my $dbh = DBI->connect($dsn,$guser,$gpassword);
    $dbh->{mysql_enable_utf8} = 1;

    my $sth1 = $dbh->prepare("select count(a1) from eval where term = ?");

    my $sth = $dbh->prepare("select distinct term, count(*) from eval 
      where term is not NULL and term != '' group by term");
    $sth->execute;

    my $first = 1;

    while ( my ($term, $markcount) = $sth->fetchrow ) {
	if ( $first ) {
	    print qq{<table cellpadding="3" border="0" cellspacing="0" };
	    print qq{style="border:1px solid gray;padding:0.5em;">\n};
	    print qq{<tr><th>$lex{Term}</th><th>$lex{Total}</th><th>$lex{Filled}</th></tr>\n};
	    $first = 0;
	}

	$sth1->execute($term);
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $filledcount = $sth1->fetchrow;

	print qq{<tr><td>$term</td><td>$markcount</td><td>$filledcount</td></tr>\n};
    }

    if ( $first ) {
	print qq{<h3>$lex{'No Records Found'}</h3>\n};

    } else {
	print qq{</table><p></p>\n};
    }

} # next school

print qq{</body></html>\n};

exit;


#----------------
sub showStartPage { # Entry Values for Custom Script
#----------------

    my $checked;
    if ( $arr{checked} ) {
	$checked = qq{checked="checked"};
    }

    print qq{<form action="$self" method="post" style="display:inline;margin:1em;">\n};
    print qq{<input type="hidden" name="checked" value="1">\n};
    print qq{<input type="submit" value="$lex{'Check All'} $lex{Schools}" style="display:inline;"></form>\n};


    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="1">\n};

    print qq{<h3>$lex{Select} $lex{Schools}</h3>\n};
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
    
    foreach my $db ( @dbase ) { 
	print qq{<tr><td class="la">};
	print qq{<input type="checkbox" name="$db" value="1" $checked></td>\n};
	print qq{<td class="la">$alldbase{$db} ($db)</td></tr>\n};
    }

    print qq{<tr><td class="la" colspan="2"><input type="submit" value="$lex{Continue}"></td></tr>\n};
    print qq{</table>\n};
    print qq{</form></body></html>\n};

    exit;

}
