#!/usr/bin/perl

use DBI;
$dbtype = 'mysql';
$dbase = 'cat3';
$user = 'root';
$password = 'PWD';


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;


# Outline: This script parses in Cat-3 student data.


my $file = $ARGV[0];
if (not $file) {
    print "No file entered\n";
    exit;
}

my ($name, $ext) = split(/\./, $file);
my @vals = split(/_/, $name);

#for my $i ( 0 .. $#vals) {
#    print "$i: $vals[$i]\n";
#}

#my @date = unpack "A2A2A4A*", $tmp;
#for my $i ( 0 .. $#date) {
#    print "$i: $date[$i]\n";
#}

my $tmp = $vals[3];
my ($month, $day, $year, $dud) = unpack "A2A2A4A*", $tmp;
my $tdate = "$year-$month-$day";

my $level = $vals[4];
print " Level:$level Date:$tdate\n";

open (FH, "<$file");

my $sth = $dbh->prepare("select startcol, endcol from cat3_key where ident1 =  ?and level = ?");
my $sth1 = $dbh->prepare("insert into cat3_data (level, tdate, firstname, lastname, birthdate, gender, grade, datarow ) 
 values (?,?,?,?,?,?,?,?)");

my %fields = ('firstname' => 'First Name',
	      'lastname' => 'Last Name',
	      'birthdate' => 'Birth Date',
	      'gender' => 'Gender',
	      'grade' => 'Grade',
    );

my %monthlookup = ('JAN' => 1, 'FEB' => 2, 'MAR' => 3, 'APR' => 4, 'MAY' => 5, 
		   'JUN' => 6, 'JUL' => 7, 'AUG' => 8, 'SEP' => 9, 'OCT' => 10,
		   'NOV' => 11, 'DEC' => 12);


while ( my $line = <FH>) {
    chomp $line;
    if ( not $line ) { next; } # skip blanks
    my %data = ();

    foreach my $key (keys %fields ) {

	# get start and end columns
	$sth->execute( $fields{$key}, $level);
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my ( $startcol, $endcol ) = $sth->fetchrow;

	my $offset = $startcol - 1;
	my $length = $endcol - $offset;

	$data{$key} = substr($line, $offset, $length);
	$data{$key} =~ s/\s+$//; # strip trailing spaces

	print "K:$key V:$data{$key}:\n";
    
    } # keys loop

    # Fix Birthdate
    my @vals = ();
    @vals = unpack("A3A2A2", $data{birthdate});
    my $month = $monthlookup{ $vals[0] };
    my $day = $vals[1];
    my $year = $vals[2];
    if ( $year < 60 ) { 
	$year = '20'. $year;
    } else { 
	$year = '19'. $year; 
    }
    

    my $birthdate = "$year-$month-$day";
    my $lastname = $data{'lastname'};
    my $firstname = $data{'firstname'};

    $lastname = ucfirst lc $lastname;
    $firstname = ucfirst lc $firstname;

    print "New:$firstname $lastname  $birthdate (OLD:$data{birthdate})\n";

    $sth1->execute($level, $tdate, $firstname, $lastname, 
		   $birthdate, $data{gender}, $data{grade}, $line); 
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	

} # end of student loop

print "Done!\n";
