#!/usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Password' => 'Password',
	   'Error' => 'Error',
	   'Main' => 'Main',
	   'Teacher' => 'Teacher',
	   'Report' => 'Report',

	   );

my $self = 'passwordview.pl';

use DBI;
use CGI;
use Time::JulianDay;
use Number::Format qw(:all);

eval require "admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

# Loadl Global values for databases
eval { require "$globdir/global.conf"; };
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


# Set Date
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
my $currdate = "$year-$month-$day";

my $title = "$lex{Teacher} $lex{Password} $lex{Report}";
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">\n";
print "$chartype\n</head><body style=\"padding:1em;\">\n";

print "[ <a href=\"$homepage\">$lex{Main}</a> ]\n";
print "<h1>$title</h1>\n";


showReport();


#-------------
sub showReport {
#-------------

    my @dbase = sort keys %alldbase; # global records.

    foreach my $dbase ( @dbase ) {

	my $dsn = "DBI:$dbtype:dbname=$dbase";
	my $dbh = DBI->connect($dsn,$guser,$gpassword);
	my $schoolname = $alldbase{"$dbase"};
	$dbh->{mysql_enable_utf8} = 1;

	# Find current teachers that do attendance, sort by name
	my (@teachers, %teachers, %passwords );
	my $sth = $dbh->prepare("select lastname, firstname, userid, password from staff order by lastname, firstname");
	$sth->execute;
	if ( DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	while ( my ($lastname, $firstname, $userid, $password ) = $sth->fetchrow ) {
	    push @teachers, $userid;
	    $teachers{$userid} = "$lastname, $firstname";
	    $passwords{$userid} = $password;
	}

	# Setup Table to Display
	print qq{<table cellspacing="0" border="1" cellpadding="3" style="display:inline;margin:0.5em;">\n};
	print qq{<tr><th colspan="2">$schoolname</th></tr>\n};
	print "<tr><th>$lex{Teacher}</th><th>$lex{Password}</th></tr>\n";

	foreach my $userid ( @teachers ) {
	    print "<tr><td>$teachers{$userid}</td><td>$passwords{$userid}</td></tr>\n";
	}
	print "</table>\n";
    }

    print "</body></html>\n";

    exit;

} # end of showReport
