#!/usr/bin/perl
# Copyright Leslie Richardson 2001-2014

use File::Find;
use Digest::MD5 qw(md5_base64 md5 md5_hex);
use CGI;

my @colors = ( '#CCF', '#CFC', '#FCC', '#FFC', '#FCF', '#CFF', '#6CC', '#C6C', '#CC6' );
my %colorsused; # coloruser{checksum} = colorcode


# Read config variables
eval require "../admin.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;

my @dirs;

my %options;
$options{wanted} = \&showFiles;
$options{preprocess} = \&preproc;

my $checkfile; # file to check for.

# HTML Heading
my $title = "Find/Compare Files";
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">\n";
print "<style type=\"text/css\">th.h {background-color:#99F;}</style>\n";
print "$chartype\n";
print qq{</head><body onload="document.forms[0].elements[1].focus()" style="padding:1em 2em;">\n};
print "[ <a href=\"$homepage\">Main</a> ]\n";

print "<h1>$title</h1>\n";

if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    checkFiles();
}


#-------------
sub checkFiles {
#-------------

    find(\%options, '/opt/openadmin');

    my $color;

    my $first = 1;
    foreach my $dir ( @dirs ) {

	my $fullpath = $dir. '/'. $filename;
	my $size = -s $fullpath;
	# $size = int( $size / 1000 ). 'k';

	my $filedata;
	{
	    local $/ = undef;
	    open($fh,'<',$fullpath) or die "Cannot open $fullpath: $!\n";
	    binmode $fh;
	    $filedata = <$fh>;
	    close $fh;
	}
	# my $md5 = md5_base64($filedata);
	my $md5 = md5_hex($filedata);

	if ( not $colorsused{$md5} ) {
	    $color = shift @colors;
	    $colorsused{$md5} = $color;

	} else { # use an existing value
	    $color = $colorsused{$md5};
	}


	if ( $first ) {
	    print qq{<table cellpadding="3" cellspacing="0" border="1">\n};
	    print qq{<tr><th>Size</th><th>Checksum</th><th>Directory</th></tr>\n};
	    $first = 0;
	}

	print qq{<tr style="background-color:$color;"><td>$size</td><td>$md5</td><td>$fullpath</td></tr>\n};

    }

    print qq{</table>\n};

    # Put in Search Form Again.
    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="1">\n};
    print qq{<p>File to Check <input type="text" name="checkfile" size="20"></p>\n};
    print qq{<p><input type="submit" value="Continue"></p>\n};
    print qq{</form>\n};

    print qq{</body></html>\n};

    exit;

}


#------------
sub showFiles {
#------------

    $filename = $arr{checkfile};

    my $file = $_;
    my $path = $File::Find::dir;
    if ( $file eq $filename ) {
	push @dirs, $path;
    }

    return;

};


#----------
sub preproc {
#----------

    my @vals = @_;
    my @newvals;

    my %skippers = qw( download 1 backup 1 updatesALL 1 updatebatc 1 updatesNNEC 1 );

    foreach my $v ( @vals ) {
	if ( $skippers{$v} ) { next; }
	push @newvals, $v;
    }

    return @newvals;

}


#----------------
sub showStartPage {
#----------------

    print "<form action=\"$self\" method=\"post\"> \n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    print "<tr><td class=\"bra\">File to Check</td>\n";
    print qq{<td class="la"><input type="text" name="checkfile" size="20"></td></tr>\n};


    # Continue
    print qq{<tr><td></td><td><input type="submit" value="Continue"></td></tr>\n};

    print "</table></form>\n";
    print "</body></html>\n";

    exit;

} # end of showStartPage
