#!/usr/bin/perl
#  Copyright 2001-2013 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Error' => 'Error',
	   'Continue' => 'Continue',
	   'Search' => 'Search',
	   'Configuration System' => 'Configuration System',
	   'Variable' => 'Variable',
	   'Not Found' => 'Not Found',

	   );


use DBI;
use CGI;

my $self = 'searchvars.pl';


# Read config variables
eval require "../admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

#eval { require "$globdir/global.conf"; };
#if ( $@ ) {
#    print $lex{Error}. " $self: $@<br>\n";
#    die $lex{Error}. "$self: $@\n";
#}

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;


# Page Header
my $title = "$lex{Search} $lex{'Configuration System'}";
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">\n";
print "$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">$lex{Main}</a> ]\n";
print "<h1>$title</h1>\n";


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    searchConf();
} 



#----------------
sub showStartPage {
#----------------

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\" ";
    print "style=\"padding:0.5em;border:1px solid gray;\">\n";


    print "<tr><td class=\"bra\">$lex{Search} $lex{Variable}</td><td class=\"la\">";
    print qq{<input type="text" size="30" name="variable"></td></tr>\n};

    print "<tr><td></td><td><input type=\"submit\" value=\"$lex{Continue}\"></td></tr>\n";

    print "</table></form>\n";
    print "</body></html>\n";

    exit;

}



#-------------
sub searchConf {
#-------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    # exit;

    print "<h3>$lex{Search} $arr{variable}</h3>\n";

    my $first = 1;

    foreach my $db ( sort keys %alldbase ) { # hash now found in admin.conf

	my ($dsn, $dbh, $schoolname );
	my $database = $db;
	$dsn = "DBI:$dbtype:dbname=$database";
	$dbh = DBI->connect($dsn,$user,$password);

	$schoolname = $alldbase{$db};

	my $sth = $dbh->prepare("select * from conf_system where dataname = ?");
	$sth->execute( $arr{variable} );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	my $ref = $sth->fetchrow_hashref;
	my %r = %$ref;

	if ( $first ) {
	    print qq{<table cellpadding="3" cellspacing="0" border="1">\n};
	    print qq{<tr><th>School</th>};
	    if ( $ref ) {
		foreach my $key ( sort keys %r ) {
		    print qq{<th>$key</th>};
		}
	    } else {
		print qq{<th colspan="10"></th>\n};
	    }
	    print qq{</tr>\n};
	    $first = 0;
	}



	print qq{<tr><td class="bra">$schoolname</td>};
	if ( not %r ) { 
	    print qq{<td colspan="10">$lex{'Not Found'}</td></tr>\n}; 

	} else { # we have a value
	    foreach my $key ( sort keys %r ) {
		print qq{<td>$r{$key}</td>}
	    }
	    print qq{</tr>\n};
	}
    }

    print qq{</table>\n};
    print "</body></html>\n";

    exit;


}
