#!/usr/bin/perl
#  Copyright 2001-2012 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Error' => 'Error',
	   'Add' => 'Add',
	   'Scores' => 'Scores',
	   'Student' => 'Student',
	   'Raw Score' => 'Raw Score',
	   'Continue' => 'Continue',
	   'Standard Score' => 'Standard Score',
	   'Confidence' => 'Confidence',
	   'Interval' => 'Interval',
	   'Percentile' => 'Percentile',
	   'Normal Curve Equivalent' => 'Normal Curve Equivalent',
	   'Stanine' => 'Stanine',
	   'Growth Scale Value' => 'Growth Scale Value',
	   'Age' => 'Age',
	   'Equivalent' => 'Equivalent',
	   'Confirmation' => 'Confirmation',
	   'Birthdate' => 'Birthdate',
	   'Record(s) Stored' => 'Record(s) Stored',
	   'Name' => 'Name',
	   'Save' => 'Save',
	   'Score' => 'Score',
	   'Test Date' => 'Test Date',
	   'No User Id' => 'No User Id',
	   'No Password' => 'No Password',
	   'Please Log In' => 'Please Log In',
	   'Grade' => 'Grade',
	   'Select' => 'Select',
	   'Record Exists' => 'Record Exists',
	   'Edit Record' => 'Edit Record',
	   'Required' => 'Required',
	   'Only' => 'Only',
	   'No Blanks Allowed' => 'No Blanks Allowed',
	   'Skipping' => 'Skipping',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Select' => 'Select',
	   'Students' => 'Students',
	   'No Students Found' => 'No Students Found',
	   'School' => 'School',
	   'Database' => 'Database',
	   
	   );

use DBI;
use CGI;
use CGI::Session;


my $self = 'pvAddCen.pl';

my $q = new CGI;
my %arr = $q->Vars;
print $q->header;


my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $day = $tim[3];
if ( length( $month) == 1 ) { $month = '0'. $month; }
if ( length( $day) == 1 ) { $day = '0'. $day; }
my $currdate = "$year-$month-$day";


eval require "../admin.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

eval { require "$globdir/global.conf"; };
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}


#my $dsn = "DBI:$dbtype:dbname=$dbase";
#my $dbh = DBI->connect($dsn,$user,$password);



# Page Header
my $title = "$lex{Add} PPVT $lex{Scores}";
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">\n";

print "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" ";
print "href=\"/js/calendar-blue.css\" title=\"blue\">\n";
print "<script type=\"text/javascript\" src=\"/js/calendar.js\"></script>\n";
print "<script type=\"text/javascript\" src=\"/js/lang/calendar-en.js\"></script>\n";
print "<script type=\"text/javascript\" src=\"/js/calendar-setup.js\"></script>\n";
print "<style type=\"text/css\">td.ra { text-align:right; }
td.bcn { text-align:center;font-weight:bold;font-size:120%; }
</style>\n";

if ( not $arr{page} ) { # load jQuery
    print "<script src=\"https://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js\"></script>\n";
}

print "$chartype\n</head><body style=\"padding:1em 2em;\">\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";
print "<h1>$title</h1>\n";


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    enterScores();

}  elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    writeRecords();
}


#----------------
sub showStartPage {
#----------------


    print "<form action=\"$self\" method=\"post\"> \n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    # Database
    print "<tr><td class=\"bra\">$lex{School} $lex{Database}</td><td class=\"la\">";
    print "<select name=\"dbase\" id=\"dbase\"><option></option>\n";

    foreach my $key ( sort keys %alldbase ) { print "<option value=\"$key\">$alldbase{$key}</option>"; }
    print "</select></td></tr>\n";

    # Date - default.
    print "<tr><td class=\"bra\">$lex{'Test Date'}</td>\n";
    print "<td class=\"la\"><input type=\"text\" name=\"date\" id=\"date\" size=\"10\" value=\"$currdate\">\n";
    print "<button type=\"reset\" id=\"start_trigger\">...</button>\n";
    print "</td></tr>\n";

    # Select Grade
    print "<tr><td class=\"bra\">$lex{Select} $lex{Grade}\n";
    print "</td><td><select name=\"grade\" id=\"gradeselect\"><option></option></select> ";
    print "</td></tr>\n";

    # Continue to next page
    print "<tr><td></td><td><input type=\"submit\" value=\"$lex{Continue}\"></td></tr>\n";

    print "</table></form>\n";

    print "<script type=\"text/javascript\">
     Calendar.setup({
        inputField     :    \"date\", // id of the input field
        ifFormat       :    \"%Y-%m-%d\", // format of the input field
        button         :    \"start_trigger\", // trigger for the calendar (button ID)
        singleClick    :    false,        // double-click mode
        step           :    1             // show all years in drop-down boxes 
    });

    \$('#dbase').change( function(e){
      var choice = \$(this).val();
      \$('#gradeselect').load('/cgi-bin/ppvt/showgrade.pl', { school:choice } );
    });

   </script>\n";

    print "</body></html>\n";

    exit;

} # end of showStartPage



#--------------
sub enterScores {
#--------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }    

    my $dbase = $arr{dbase};
    delete $arr{dbase};

    my $dsn = "DBI:$dbtype:dbname=$dbase";
    my $dbh = DBI->connect($dsn,$user,$password);

    my $grade = $arr{grade};
    delete $arr{grade};

    my $date = $arr{date};
    delete $arr{date};

    my $sth1 = $dbh->prepare("select tdate from ppvt_test where studnum = ?");


    my $sth = $dbh->prepare("select lastname, firstname, studnum from studentall 
      where grade = ? order by lastname, firstname");
    $sth->execute( $grade );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }


#    print "<h3>$lex{'Test Date'} $date</h3>\n";

    print "<form action=\"$self\" method=\"post\"> \n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";
    print "<input type=\"hidden\" name=\"dbase\" value=\"$dbase\">\n";
 
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
    print "<tr><td class=\"la\" colspan=\"4\"><input type=\"submit\" value=\"$lex{Save}\"></td></tr>\n";

    print "<tr><th>$lex{Student}</th><th>Raw</th><th>Date</th><th>Existing</th></tr>\n";
    print "<tr><td class=\"la\" colspan=\"4\" style=\"color:green;\">Any Blank Raw Scores will be ignored</td></tr>\n";

    while ( my ( $lastname, $firstname, $studnum ) = $sth->fetchrow ) {

	# Find any existing values
	$sth1->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

	print "<tr><td class=\"la\"><b>$lastname</b>, $firstname</td>\n";
	print "<td class=\"la\"><input type=\"text\" name=\"R:$studnum\" size=\"6\"></td>\n";
    	print "<td class=\"la\"><input type=\"text\" name=\"D:$studnum\" size=\"12\" value=\"$date\"></td>\n";
	print "<td class=\"la\">";
	while ( my $tdate = $sth1->fetchrow ) { print "$tdate "; }
	print "</td></tr>\n";
    }

    print "<tr><td class=\"la\" colspan=\"5\" style=\"font-size:80%;\">Raw = $lex{'Raw Score'}</td></tr>\n";
    #,&nbsp;&nbsp;Std = $lex{'Standard Score'},\n";
    # print "Per = $lex{Percentile},&nbsp;&nbsp;AgeE = $lex{Age} $lex{Equivalent}</td></tr>\n";

    print "<tr><td class=\"la\"><input type=\"submit\" value=\"$lex{Save}\" colspan=\"4\"></td></tr>\n";
    print "</table></form>\n";
    print "</body></html>\n";

    exit;


} # end of enterScores



#---------------
sub writeRecords {
#---------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $dbase = $arr{dbase};
    delete $arr{dbase};

    my $dsn = "DBI:$dbtype:dbname=$dbase";
    my $dbh = DBI->connect($dsn,$user,$password);


    my $sth = $dbh->prepare("insert into ppvt_test ( studnum, tdate,
      tauthor, tgrade, tstamp, rawscore )
      values ( ?,?,?,?,now(),? )"); 

    my $sth1 = $dbh->prepare("select grade 
     from studentall where studnum = ?");

    my $sth2 = $dbh->prepare("select id from ppvt_test where studnum = ? and tdate = ?");
    my $sth3 = $dbh->prepare("update ppvt_test set rawscore = ? where id = ?");

    foreach my $key ( keys %arr ) {

	my ( $code, $studnum ) = split(/:/, $key);
	if ( $code ne 'R' ){ next; } # skip all but R (raw) fields.

	my $rawscore = $arr{$key};
	if ( not $rawscore ) { next; } # skip blank raw scores

	# Get Date
	my $dkey = 'D:'. $studnum;
	my $date = $arr{$dkey};

	# Get student grade
	$sth1->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my $grade = $sth1->fetchrow;

	# Check for existing record; same tdate, studnum
	$sth2->execute( $studnum, $date);
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my $id = $sth2->fetchrow;

	if ( $id ) { # update the record
	    $sth3->execute( $rawscore, $id );
#	    print "Update: $rawscore - $date<br>\n";
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

	} else { # add a new record
	    # Write the test record 
#	    print "Add: $rawscore - $date<br>\n";
	    $sth->execute( $studnum, $date, 'central', $grade, $rawscore ); 
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	}
    }
    

    print "<h3>$lex{'Record(s) Stored'}</h3>\n";

    print "<p>[ <a href=\"$self\">$title</a> |\n";
    print "<a href=\"$homepage\">$lex{Main}</a> ]</p></body></html>\n";

    exit;

}
