#!/usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Error' => 'Error',
	   'View' => 'View',
	   'PPVT Scores' => 'PPVT Scores',
	   'Name' => 'Name',
	   'Date' => 'Date',
	   'Author' => 'Author',
	   'Score' => 'Score',
	   'Raw Score' => 'Raw Score',
	   'Standard Score' => 'Standard Score',
	   'Confidence' => 'Confidence',
	   'Percentile' => 'Percentile',
	   'Stanine' => 'Stanine',
	   'Normal Curve Equivalent' => 'Normal Curve Equivalent',
	   'Growth Scale Value' => 'Growth Scale Value',
	   'Equivalent' => 'Equivalent',
	   'Age' => 'Age',
	   'Grade' => 'Grade',

	   'No Records Found' => 'No Records Found',
	   'Continue' => 'Continue',
	   'Select' => 'Select',
	   'Student' => 'Student',
	   'Chk' => 'Chk',
	   'Homeroom' => 'Homeroom',
	   'Grade' => 'Grade',
	   'Blank=All' => 'Blank=All',
	   'Edit' => 'Edit',
	   'Tests' => 'Tests',
	   'Delete' => 'Delete',
	   'Start Date' => 'Start Date',
	   'End Date' => 'End Date',
	   'Equivalent' => 'Equivalent',
	   'Next Page' => 'Next Page',
	   'No Blanks Allowed' => 'No Blanks Allowed',
	   'School' => 'School',
	   'Database' => 'Database',

	   );

use DBI;
use CGI;

my $self = 'pvViewCen.pl';

my $editscript = 'pvTestEdit.pl';
my $deletescript = 'pvTestDelete.pl';

eval require "../admin.conf";
if ( $@ ) {
    print "$lex{Error}: $self: $@<br>\n";
    die "$lex{Error}: $self: $@\n";
}

eval { require "$globdir/global.conf"; };
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}


my $q = new CGI;
print $q->header;
my %arr = $q->Vars;

my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $day = $tim[3];
if ( length( $month) == 1 ) { $month = '0'. $month; }
if ( length( $day) == 1 ) { $day = '0'. $day; }
my $currdate = "$year-$month-$day";

my ( $dsn, $dbh);
if ( $arr{dbase} ) {
    my $dbase = $arr{dbase};
    $dsn = "DBI:$dbtype:dbname=$dbase";
    $dbh = DBI->connect($dsn,$user,$password);
}


# Page Header
print "$doctype\n<html><head><title>$lex{View} $lex{'PPVT Scores'}";
print "</title><link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">\n";

if ( not $arr{page} ) { # calendar popup.
    print "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" ";
    print "href=\"/js/calendar-blue.css\" title=\"blue\">\n";
    print "<script type=\"text/javascript\" src=\"/js/calendar.js\"></script>\n";
    print "<script type=\"text/javascript\" src=\"/js/lang/calendar-en.js\"></script>\n";
    print "<script type=\"text/javascript\" src=\"/js/calendar-setup.js\"></script>\n";
}

if ( not $arr{page} ) { # load jQuery
    print "<script src=\"https://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js\"></script>\n";
}

print "$chartype\n</head><body style=\"padding:1em 2em;\">\n";

print "[ <a href=\"$homepage\">$lex{Main}</a> ]\n";
print "<h1>$lex{View} $lex{'PPVT Scores'}</h1>\n";


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    showGradeTests();
}


#----------------
sub showStartPage {
#----------------

    print "<form action=\"$self\" method=\"post\"> \n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    # Database
    print "<tr><td class=\"bra\">$lex{School} $lex{Database}</td><td class=\"la\">";
    print "<select name=\"dbase\" id=\"dbase\"><option></option>\n";

    foreach my $key ( sort keys %alldbase ) { print "<option value=\"$key\">$alldbase{$key}</option>"; }
    print "</select></td></tr>\n";

    # Date - default.
#    print "<tr><td class=\"bra\">$lex{'Test Date'}</td>\n";
#    print "<td class=\"la\"><input type=\"text\" name=\"date\" id=\"date\" size=\"10\" value=\"$currdate\">\n";
#    print "<button type=\"reset\" id=\"start_trigger\">...</button>\n";
#    print "</td></tr>\n";

    # Select Grade
    print "<tr><td class=\"bra\">$lex{Select} $lex{Grade}\n";
    print "</td><td><select name=\"grade\" id=\"gradeselect\"><option></option></select> ";
    print "</td></tr>\n";

    # Continue to next page
    print "<tr><td></td><td><input type=\"submit\" value=\"$lex{Continue}\"></td></tr>\n";

    print "</table></form>\n";

=head
    print "<script type=\"text/javascript\">
     Calendar.setup({
        inputField     :    \"date\", // id of the input field
        ifFormat       :    \"%Y-%m-%d\", // format of the input field
        button         :    \"start_trigger\", // trigger for the calendar (button ID)
        singleClick    :    false,        // double-click mode
        step           :    1             // show all years in drop-down boxes 
    });\n";
    print "</script>\n";
=cut

    print "<script type=\"text/javascript\">
    \$('#dbase').change( function(e){
      var choice = \$(this).val();
      \$('#gradeselect').load('/cgi-bin/ppvt/showgrade.pl', { school:choice } );
    });
    </script>\n";

    print "</body></html>\n";

    exit;

} # end of showStartPage

#----------------
sub showGradeTests {
#----------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }    

    my $sth1 = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");

    my $sth = $dbh->prepare("select * from ppvt_test where tgrade = ?");
    $sth->execute( $arr{grade} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }



    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
    print "<tr><th>$lex{Student}</th><th>Date</th><th>Raw</th></tr>\n";

    while ( my $ref = $sth->fetchrow_hashref ) {
	
	my $studnum = $ref->{studnum};
	$sth1->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my ($lastname, $firstname) = $sth1->fetchrow;

	print "<tr><td class=\"la\"><b>$lastname</b>, $firstname ($studnum)</td>\n";
	print "<td>$ref->{tdate}</td><td>$ref->{rawscore}</td>$ref->{author}</td>";
	print "</tr>\n";
    }

    print "</table></body></html>\n";

    exit;

} # end of showGradeTests





#----------------
sub selectStudents {
#----------------

    foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }    

    my $chk;
    if ( $arr{chk} ) {
	$chk = 'CHECKED';
    }
    delete $arr{chk};


    my $sth = $dbh->prepare("select lastname, firstname, studnum from studentall
      where grade = ? order by lastname, firstname");
    $sth->execute( $arr{grade} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }


    # Form Header
    print "<form action=\"$self\" method=\"post\"> \n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    print "<tr><td class=\"ra\"><input type=\"submit\" value=\"$lex{Continue}\">";
    print "</td><td></td></tr>\n";

    my $sth1 = $dbh->prepare("select count(*) from ppvt_test where studnum = ?");
    
    print "<tr><th>$lex{Student}</th><th>$lex{Tests}</th><th></th></tr>\n";

    while ( my ( $lastname, $firstname, $studnum ) = $sth->fetchrow ) {
	
	$sth1->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my $count = $sth1->fetchrow;

	print "<tr><td class=\"ra\">$lastname, $firstname ($studnum)</td>\n";
	print "<td style=\"text-align:center;\">$count</td><td>";
	if ( $count ) {
	    print "<input type=\"checkbox\" name=\"$studnum\" value=\"1\" $chk>";
	}
	print "</td></tr>\n";
    }

    print "<tr><td class=\"ra\"><input type=\"submit\" value=\"$lex{Continue}\">";
    print "</td><td></td></tr>\n";

    print "</table></form></body></html>\n";

    exit;

} # end of selectStudents



#------------
sub showTests {
#------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $startdate = $arr{startdate};
    my $enddate = $arr{enddate};
    delete $arr{startdate};
    delete $arr{enddate};


    # Searching by Student Number

    my $sth1 = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");
    my $first = 1;

    foreach my $studnum ( sort keys %arr ) {

	# Get Student Name
	$sth1->execute( $studnum );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my ( $lastname, $firstname ) = $sth1->fetchrow;


	# Display Existing Tests (if any)
	my $sth = $dbh->prepare("select * from ppvt_test 
         where studnum = ? and to_days( tdate ) >= to_days( '$startdate' ) 
         and to_days( tdate ) <= to_days( '$enddate') order by tdate, id");

	$sth->execute( $studnum );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	while ( my $ref = $sth->fetchrow_hashref ) {

		$first = 0;

		print "<div style=\"font-size:100%; font-weight:bold;\">$firstname $lastname<div>\n";
		print "<div style=\"font-weight:normal;\">$ref->{tauthor} / $ref->{tdate}\n";

		# Edit Button
		print "<form action=\"$editscript\" method=\"post\" target=\"_blank\" ";
		print "style=\"display:inline;\">\n";
		print "<input type=\"hidden\" name=\"testid\" value=\"$ref->{id}\">\n";
		print "<input type=\"submit\" value=\"$lex{Edit}\">\n";
		print "</form>\n";

		# Delete Button
		print "<form action=\"$deletescript\" method=\"post\" target=\"_blank\" ";
		print "style=\"display:inline;\">\n";
		print "<input type=\"hidden\" name=\"testid\" value=\"$ref->{id}\">\n";
		print "<input type=\"submit\" value=\"$lex{Delete}\">\n";
		print "</form></div>\n";

		print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
		print "<tr><th>$lex{Name}</th><th>$lex{Score}</th></tr>\n";

		print "<tr><td class=\"bra\">$lex{'Raw Score'}</td><td class=\"la\">$ref->{rawscore}</td></tr>\n";
		print "<tr><td class=\"bra\">$lex{'Standard Score'}</td><td class=\"la\">$ref->{stdscore}</td></tr>\n";
#		print "<tr><td class=\"bra\">$lex{Confidence}</td><td class=\"la\">$ref->{confstart} &ndash; $ref->{confend}</td></tr>\n";
		print "<tr><td class=\"bra\">$lex{Percentile}</td><td class=\"la\">$ref->{percentile}</td></tr>\n";
#		print "<tr><td class=\"bra\">$lex{'Normal Curve Equivalent'}</td><td class=\"la\">$ref->{normalce}</td></tr>\n";
#		print "<tr><td class=\"bra\">$lex{Stanine}</td><td class=\"la\">$ref->{stanine}</td></tr>\n";
#		print "<tr><td class=\"bra\">$lex{'Growth Scale Value'}</td><td class=\"la\">$ref->{growthsv}</td></tr>\n";
		print "<tr><td class=\"bra\">$lex{Age} $lex{Equivalent}</td><td class=\"la\">$ref->{equivage}</td></tr>\n";
#		print "<tr><td class=\"bra\">$lex{Grade} $lex{Equivalent}</td><td class=\"la\">$ref->{equivgrade}</td></tr>\n";


		print "</table><p></p>\n";

	} # end of student loop.

	if ( $first ) {
	    print "<div style=\"font-weight:bold;\">";
	    print $lex{'No Records Found'}. "</div>\n";
	}

    } # end of student number loop

    print "</body></html>\n";
    
    exit;

}
