#!/usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

# Principal Walkthrough Counter


my %lex = ('Error' => 'Error',
	   'Main' => 'Main',
	   'Principal Walkthrough' => 'Principal Walkthrough',

	   'Continue' => 'Continue',
	   'Name' => 'Name',
	   'Title' => 'Title',
	   'Area' => 'Area',
	   'Date' => 'Date',
	   'Description' => 'Description',


	   );


my $self = 'pwalkcounter.pl';

use DBI;
use CGI;

eval require "../admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval { require "$globdir/global.conf"; };
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}


#@dbase = sort keys %alldbase; # global records.

my $q = CGI->new;
my %arr = $q->Vars;
print $q->header( -charset, $charset );


# Script Heading Descriptor
my $title = "$lex{'Principal Walkthrough'} $lex{Counter}";

# Print Page Heading
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">\n";

print "$chartype\n</head><body style=\"padding:0.4em 2em;\">\n";
print "[ <a class=\"alt\" href=\"$homepage\">$lex{Main}</a> ]\n";
print "<h1>$title</h1>\n";

#if ( not $arr{page} ) {
#    showStartPage();
#
#} 


foreach my $db ( sort keys %alldbase ) {

	my $database = $db;
	my $dsn = "DBI:$dbtype:dbname=$database";
	my $dbh = DBI->connect($dsn,$guser,$gpassword);
	my $schoolname = $alldbase{"$db"};

	print "<h2>$schoolname</h2>\n";

	my $sth = $dbh->prepare("select * from pwalk_eval");
	$sth->execute;
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	my $first = 1;
	while ( my $ref = $sth->fetchrow_hashref ) {
	    my %r = %$ref;

	    if ( $first ) {
		print qq{<table cellspacing="0" cellpadding="3" border="1">\n};
		print qq{<tr><th>$lex{Name}</th><th>$lex{Title}</th><th>$lex{Description}</th>};
		print qq{<th>$lex{Area}</th><th>$lex{Date}</th></tr>\n};
		$first = 0;
	    }

	    print qq{<tr><td>$r{tfirstname} $r{tlastname}</td><td>$r{title}</td><td>$r{description}</td>};
	    print qq{<td>$r{subject}</td><td>$r{adatetime}</td></tr>\n};

	}

	if ( $first ) {
	    print "<h3>No Walkthroughs Found</h3>\n";
	} else {
	    print qq{</table>\n};
	}

}


print qq{</body></html>\n};




#----------------
sub showStartPage {
#----------------

    my $checked;
    if ( $arr{checked} ) {
	$checked = qq{checked="checked"};
    }

    print qq{<form action="$self" method="post" style="display:inline;margin:1em;">\n};
    print qq{<input type="hidden" name="checked" value="1">\n};
    print qq{<input type="submit" value="$lex{'Check All'} $lex{Schools}" style="display:inline;"></form>\n};


    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\" ";
    print "style=\"padding:0.5em;border:1px solid gray;\">\n";

    print qq{<tr><td class=\"bra\">$lex{Select} $lex{Schools}</td><td></td></tr>\n};
    foreach my $db ( @dbase ) { 
	print qq{<tr><td></td><td class=\"la\">};
	print qq{<input type="checkbox" name="$db" value="1" $checked>\n};
	print qq{$alldbase{$db} ($db)</td></tr>\n};
    }

    # Start Date
    print "<tr><td class=\"bra\">$lex{'Start Date'}</td><td class=\"la\"><input type=\"text\" ";
    print "name=\"startdate\" id=\"sdate\" size=\"10\" value=\"$currstartdate\">";
    print "<button type=\"reset\" id=\"start_trigger\">...</button>\n";
    print "</td></tr>\n";


    # End Date
    print "<tr><td class=\"bra\">$lex{'End Date'}</td><td class=\"la\"><input type=\"text\" ";
    print "name=\"enddate\" id=\"edate\" size=\"10\" value=\"$currdate\">";
    print "<button type=\"reset\" id=\"end_trigger\">...</button></td></tr>\n";

    # Grouping 
    print "<tr><td class=\"bra\">$lex{Group}</td><td class=\"la\">";
    print "<select name=\"grouping\"><option value=\"division\">$lex{Division}</option>\n";
    print "<option value=\"grade\">$lex{Grade}</option>";
    print "</select></td></tr>\n";

    # Output Type
    print "<tr><td class=\"bra\">$lex{Output}</td><td class=\"la\">";
    print "<select name=\"output\"><option value=\"html\">HTML</option>\n";
    print "<option value=\"pdf\">PDF</option>";
    print "<option value=\"csv\">CSV</option>";
    print "</select></td></tr>\n";

    # Paper Size, if doing PDF.
    print "<tr><td class=\"bra\">$lex{'Paper Size'}</td>\n<td>";
    print "<select name=\"papersize\"><option value=\"letter\">$lex{Letter}</option>\n";
    print "<option value=\"a4\">$lex{A4}</option><option value=\"legal\">$lex{Legal}</option>";
    print "</select></td></tr>\n ";


    print "<tr><td></td><td class=\"la\"><input type=\"submit\" value=\"$lex{Continue}\"></td></tr>\n";
    print "</form>\n";

    print "<script type=\"text/javascript\">
     Calendar.setup({
        inputField     :    \"sdate\", 
        ifFormat       :    \"%Y-%m-%d\",
        button         :    \"start_trigger\",
        singleClick    :    false,
        step           :    1
    });

    Calendar.setup({
        inputField     :    \"edate\",
        ifFormat       :    \"%Y-%m-%d\",
        button         :    \"end_trigger\",
        singleClick    :    false,
        step           :    1
    });
    </script>\n";

    print "</body></html>\n";

    exit;

} # end of showStartPage


