#! /usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


my %lex = ('Main' => 'Main',
	   'Walkthrough' => 'Walkthrough',
	   'Creator' => 'Creator',
	   'Description' => 'Description',
	   'Type' => 'Type',
	   'Select' => 'Select',
	   'Fields' => 'Fields',
	   'Error' => 'Error',
	   'Continue' => 'Continue',
	   'Column' => 'Column',
	   'Number' => 'Number',
	   'Width' => 'Width',
	   'Order' => 'Order',
	   'Tabular' => 'Tabular',
	   'Multicolumn' => 'Multicolumn',
	   'Reorder' => 'Reorder',
	   'Student Roster' => 'Student Roster',
	   'Report' => 'Report',
	   'Created' => 'Created',
	   'Delete' => 'Delete',
	   'Select' => 'Select',
	   'Deleted' => 'Deleted',
	   'Save' => 'Save',
	   'Drag' => 'Drag',
	   'Change' => 'Change',
	   'Order' => 'Order',
	   'View' => 'View',
	   'New' => 'New',
	   'Missing' => 'Missing',
	   
	   'Category' => 'Category',
	   'Sequence' => 'Sequence',
	   'Template' => 'Template',
	   'Edit' => 'Edit',
	   'Updated' => 'Updated',
	   'Title' => 'Title',
	   'Password' => 'Password',
	   'Wrong' => 'Wrong',

	   );

my $self = 'pwalkcreator.pl';
my $pass = 'Merk2405!!';



use DBI;
use CGI;
use Data::UUID;


# Current Date
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
if (length($month) == 1) { $month = '0'.$month; }
if (length($day) == 1) { $day = '0'.$day; }
my $currdate = "$year-$month-$day";


# Read database access
eval require "../admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dbtype = 'mysql';
my $dbase = 'central';
# Setup Database access
my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

=head
# my @fieldnames = qw( g_jquery_url g_jquery_ui_url ); 
my $sth = $dbh->prepare("select datavalue from conf_system where dataname = ?");
foreach my $var qw( g_jquery_url g_jquery_ui_url css homepage doctype chartype) {
    $sth->execute( $var );
    my $datavalue = $sth->fetchrow;
    eval $datavalue;
    if ( $@ ) {
	print "$lex{Error}: $@<br>\n";
	die "$lex{Error}: $@\n";
    }
}
=cut


my $q = new CGI;
my %arr = $q->Vars;
print $q->header( -charset, $charset );


# Page Header
my $title = "$lex{Walkthrough} $lex{Creator}";

print "$doctype\n<html><head><title>$title</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";

=head; drag and drop not used.
if ( $arr{page} == 1 ) { # load jQuery libs
    print qq{<script type="text/javascript" src="$g_jquery_url">};
    print "</script>\n";

    print qq{<script type="text/javascript" src="$g_jquery_ui_url">};
    print "</script>\n";
}
=cut


print "$chartype\n</head><body style=\"padding:1em 3em;\">\n";
print "<div>[ <a href=\"$homepage\">$lex{Main}</a> ]\n";

if ( not $arr{page} or $arr{page} == 1 or $arr{page} == 2 ) {
    print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"3\">\n";
    print "<input type=\"submit\" value=\"$lex{Edit}/$lex{Delete} $lex{Template}\">\n";
    print "</form>\n";
}
print "</div>\n";

print "<h1>$title</h1>\n";


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    createTemplate();

} elsif ( $arr{page} == 3 ) {
    delete $arr{page};

    if ( not $arr{password} ) {
	checkPassword();
    } else {
	selectTemplate();
    }

} elsif ( $arr{page} == 4 ) {
    delete $arr{page};
    deleteTemplate();

} elsif ( $arr{page} == 5 ) {
    delete $arr{page};
    editTemplate();

} elsif ( $arr{page} == 6 ) {
    delete $arr{page};
    updateTemplate();
}



#-----------------
sub createTemplate {
#-----------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $description = $arr{description};
    delete $arr{description};

    my $title = $arr{title};
    delete $arr{title};

    my $category = $arr{category};
    delete $arr{category};

    my $sequence = $arr{sequence};
    delete $arr{sequence};

    # Create Message ID
    my $ug    = new Data::UUID;
    my $uuid = $ug->create();
    my $messageid  = $ug->to_string( $uuid );

    # Insert Master Record
    my $sth = $dbh->prepare("insert into pwalk_mst (title, description,category, sequence, cdate, identcode ) values ( ?,?,?,?,?,? ) ");
    $sth->execute( $title, $description, $category, $sequence, $currdate, $messageid );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


    # Get Master Record ID
    my $sth = $dbh->prepare("select id, identcode from pwalk_mst where identcode = ?");
    $sth->execute( $messageid );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ($mstid,$identcode) = $sth->fetchrow;

    # Loop through all template records
    my $sth = $dbh->prepare("insert into pwalk_tpl (description,category, sequence, mstid ) values ( ?,?,?,$mstid )");

    for my $idx (1..12) {
	my ($didx, $sidx,$cidx) = ("desc$idx","seq$idx","cat$idx");
	if ( $arr{$didx} and $arr{$sidx} and $arr{$cidx} ) { # we have all 3 values, add a record
	    $sth->execute( $arr{$didx},  $arr{$cidx}, $arr{$sidx} );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	}
    }


    print "<h3>$lex{Template}: $title $lex{Created}</h3>\n";

    print "<p>[ <a href=\"pwalkviewer.pl?page=1&id=$identcode\">$lex{View} $lex{New} $lex{Template}</a> |\n";

    print qq{ <a href=\"$homepage\">$lex{Main}</a> |\n};
    print qq{<a href="$self">Start</a> ]</p>\n};
    print qq{</body></html>\n};

    exit;

}


#----------------
sub editTemplate {
#----------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    # Get Master Record
    my $sth = $dbh->prepare("select * from pwalk_mst where id = ?");
    $sth->execute( $arr{id} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $mref = $sth->fetchrow_hashref;
    my %mst = %$mref;
    

    # Start Form
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"6\">\n";
    print "<input type=\"hidden\" name=\"id\" value=\"$mst{id}\">\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    # Continue Button
    print "<tr><td class=\"cn\" colspan=\"2\">\n";
    print "<input type=\"submit\" value=\"$lex{Continue}\"></td></tr>\n";

    # Title
    print "<tr><td class=\"bra\">$lex{Title}</td>\n";
    print qq{<td><input type="text" name=\"title" size="60" value="$mst{title}"></td></tr>\n};

    # Description
    print "<tr><td class=\"bra\">$lex{Description}</td>\n";
    print qq{<td><textarea name="description" cols="60" roww="4">$mst{description}</textarea></td></tr>\n};

    # Category
    print qq{<tr><td class="bra">$lex{Category}</td>\n};
    print qq{<td class="la"><input type="text" name="category" size="30" value="$mst{category}"></td></tr>\n};

    # Identcode field
#    print qq{<tr><td class="bra">Ident Code</td>\n};
#    print qq{<td class="la"><input type="text" name="identcode" size="15"></td></tr>\n};

    # Sequence
    print qq{<tr><td class="bra">$lex{Sequence}</td>\n};
    print qq{<td class="la"><input type="text" name="sequence" size="5" value="$mst{sequence}"> among templates</td></tr>\n};

    print "</table>\n";


    # Get Template Values
    my $sth = $dbh->prepare("select * from pwalk_tpl where mstid = ? order by category, sequence");
    $sth->execute( $mst{id} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    # Now add template items 
    print qq{<table cellpadding="3" cellspacing="0" border="1" style="background-color:#DDD">\n};

    for my $idx ( 1..12 ) {

	my $tref = $sth->fetchrow_hashref;
	my %r = %$tref;

	my $dname = "desc$idx";
	my $sname = "seq$idx";
	my $cname = "cat$idx";

	if ( $tref ) { # we have a record
	    $dname = "description:$r{id}";
	    $sname = "sequence:$r{id}";
	    $cname = "category:$r{id}";
	}

	print qq{<tr><td class="bra">$lex{Description} $idx</td>\n};
	print qq{<td class="la"><input type="text" name="$dname" size="60" value="$r{description}"></td></tr>\n};

	print qq{<tr><td class="ra">$lex{Category}</td>\n};
	print qq{<td class="la"><input type="text" name="$cname" size="30" value="$r{category}"></td></tr>\n};

	print qq{<tr><td class="ra">$lex{Sequence}</td>\n};
	print qq{<td class="la"><input type="text" name="$sname" size="5" value="$r{sequence}"></td></tr>\n};

    }

    print "</table>\n";

    # Continue Button
    print "<p><input type=\"submit\" value=\"$lex{Continue}\"></p>\n";
    print "</form>\n";

    print "</body></html>\n";

    exit;

} # end of editTemplate


#-----------------
sub updateTemplate {
#-----------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $mstid = $arr{id};

    my $description = $arr{description};
    delete $arr{description};

    my $title = $arr{title};
    delete $arr{title};

    my $category = $arr{category};
    delete $arr{category};

    my $sequence = $arr{sequence};
    delete $arr{sequence};


    # Update Master Record
    my $sth = $dbh->prepare("update pwalk_mst set title = ?, description = ?, category = ?, sequence = ? where id = ?");
    $sth->execute( $title, $description, $category, $sequence, $arr{id} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


    # Loop through all template records, update existing records
    foreach my $key ( keys %arr ) { # split and use to update
	my ($type, $recid ) = split(':', $key);
	if ( $recid ) { # we have an existing record to update
	    my $sth = $dbh->prepare("update pwalk_tpl set $type = ? where id = ?");
	    $sth->execute( $arr{$key}, $recid );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	}
    }

    # Insert any new records
    my $sth = $dbh->prepare("insert into pwalk_tpl (description,category, sequence, mstid ) values ( ?,?,?,$mstid )");
    for my $idx (1..12) {
	my ($didx, $sidx,$cidx) = ("desc$idx","seq$idx","cat$idx");
	if ( $arr{$didx} and $arr{$sidx} and $arr{$cidx} ) { # we have all 3 values, add a record
	    $sth->execute( $arr{$didx},  $arr{$cidx}, $arr{$sidx} );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	}
    }

    print "<h3>$lex{Template}: $title $lex{Updated}</h3>\n";

    print qq{<p>[ <a href=\"$homepage\">$lex{Main}</a> |\n};
    print qq{<a href="$self">Start</a> ]</p>\n};
    print qq{</body></html>\n};

    exit;

} # end of updateTemplate


#----------------
sub showStartPage {
#----------------

    # Start Form
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    # Continue Button
    print "<tr><td class=\"cn\" colspan=\"2\">\n";
    print "<input type=\"submit\" value=\"$lex{Continue}\"></td></tr>\n";

    # Title
    print "<tr><td class=\"bra\">$lex{Title}</td>\n";
    print "<td><input type=\"text\" name=\"title\" size=\"60\"></td></tr>\n";

    # Description
    print "<tr><td class=\"bra\">$lex{Description}</td>\n";
    print "<td><textarea name=\"description\" cols=\"60\" rows=\"4\"></textarea></td></tr>\n";

    # Category
    print qq{<tr><td class="bra">$lex{Category}</td>\n};
    print qq{<td class="la"><input type="text" name="category" size="30"></td></tr>\n};

    # Identcode field
#    print qq{<tr><td class="bra">Ident Code</td>\n};
#    print qq{<td class="la"><input type="text" name="identcode" size="15"></td></tr>\n};

    # Sequence
    print qq{<tr><td class="bra">$lex{Sequence}</td>\n};
    print qq{<td class="la"><input type="text" name="sequence" size="5"> among templates</td></tr>\n};

    print "</table>\n";


    # Now add template items 
    print qq{<table cellpadding="3" cellspacing="0" border="1" style="background-color:#DDD">\n};

    for my $idx ( 1..12 ) {
	print qq{<tr><td class="bra">$lex{Description} $idx</td>\n};
	print qq{<td class="la"><input type="text" name="desc$idx" size="60"></td></tr>\n};

	print qq{<tr><td class="ra">$lex{Category}</td>\n};
	print qq{<td class="la"><input type="text" name="cat$idx" size="30"></td></tr>\n};

	print qq{<tr><td class="ra">$lex{Sequence}</td>\n};
	print qq{<td class="la"><input type="text" name="seq$idx" size="5"></td></tr>\n};

    }

    print "</table>\n";

    # Continue Button
    print "<p><input type=\"submit\" value=\"$lex{Continue}\"></p>\n";
    print "</form>\n";

    print "</body></html>\n";

    exit;

}



#-----------------
sub deleteTemplate {
#-----------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    # Get the Template Master
    my $sth = $dbh->prepare("select * from pwalk_mst where id = ?");
    $sth->execute( $arr{id} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $mref = $sth->fetchrow_hashref;
    my %mst = %$mref;
    my $mstid = $arr{id}; # same thing.


    # Delete Template Records
    my $sth = $dbh->prepare("delete from pwalk_tpl where mstid = ?");
    $sth->execute( $mstid );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    # Delete Master Record
    my $sth = $dbh->prepare("delete from pwalk_mst where id = ?");
    $sth->execute( $arr{id} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    print qq{<h3>$mst{title} $lex{Deleted}</h3>\n};

    print qq{<p>[ <a href=\"$homepage\">$lex{Main}</a> |\n};
    print qq{<a href="$self">Start</a> ]</p>\n};
    print qq{</body></html>\n};

    print "</body></html>\n";

    exit;

}


#-----------------
sub selectTemplate {
#-----------------


    print "<h3>$lex{Edit}/$lex{Delete} $lex{Template}</h3>\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>$lex{Template}</th><th></th><th></th></tr>\n";


    # Check Password
    if ( $arr{password} ne $pass ) { # fail
	print qq{<h3>$lex{Wrong} $lex{Password}</h3>\n};
	print qq{</body></html>\n};
	exit;
    }


    # Get the Template Masters
    my $sth = $dbh->prepare("select * from pwalk_mst order by sequence");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


    while ( my $ref = $sth->fetchrow_hashref ) {
	my %r = %$ref;

	#print qq{<option value="$r{identcode}">$r{description} - $r{category}</option>\n};
	print qq{<tr><td class="bla">$r{title}</td><td>\n};
	
	print qq{<form action="$self" method="post" style="display:inline;">\n};
	print qq{<input type="hidden" name="page" value="5">\n};
	print qq{<input type="hidden" name="id" value="$r{id}">\n};
	print qq{<input type="submit" value="$lex{Edit}"></form>\n};

	print qq{</td><td>\n};

	print qq{<form action="$self" method="post" style="display:inline;">\n};
	print qq{<input type="hidden" name="page" value="4">\n};
	print qq{<input type="hidden" name="id" value="$r{id}">\n};
	print qq{<input type="submit" value="$lex{Delete}"></form>\n};

	print qq{</td></tr>\n};

    }

    print qq{</table>\n};
    print "</body></html>\n";

    exit;
}



#----------------
sub checkPassword {
#----------------

    # Start Form
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"3\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    # Continue Button
    #print "<tr><td class=\"cn\" colspan=\"2\">\n";
    #print "<input type=\"submit\" value=\"$lex{Continue}\"></td></tr>\n";

    # Password
    print qq{<tr><td class="bra">$lex{Password}</td>\n};
    print qq{<td><input type="password" name="password" size="12"></td></tr>\n};


    print "</table>\n";

    # Continue Button
    print "<p><input type=\"submit\" value=\"$lex{Continue}\"></p>\n";
    print "</form>\n";

    print "</body></html>\n";

    exit;

} # end of checkPassword


