#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Error' => 'Error',
	   'Add Reading Objectives' => 'Add Reading Objectives',
	   'Save Record' => 'Save Record',
	   'Category' => 'Category',
	   'Evaluation Level' => 'Evaluation Level',
	   'Intervention' => 'Intervention',
	   'Instructional' => 'Instructional',
	   'Independent' => 'Independent',
	   'Advanced' => 'Advanced',
	   'Description' => 'Description',
	   'Name' => 'Name',
	   'The record is now stored' => 'The record is now stored',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Contact' => 'Contact',
	   'Add Another Objective' => 'Add Another Objective',


	   );

use DBI;
use CGI;

my $self = 'readobjadd.pl';

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;

eval require "../admin.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

# Page Header
print "$doctype\n<html><head><title>". $lex{'Add Reading Objectives'};
print "</title><link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">
$chartype\n</head><body style=\"padding:1em 2em;\">\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";
print "<h1>". $lex{'Add Reading Objectives'}. "</h1>\n";


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

if ( not $arr{page} ) {
    showStartPage();
} else {
    delete $arr{page};
    writeRecord();
}



#----------------
sub showStartPage {
#----------------

    my @evals = ();
    $evals[1] = $lex{Intervention};
    $evals[2] = $lex{Instructional};
    $evals[3] = $lex{Independent};
    $evals[4] = $lex{Advanced};


    print "<form action=\"$self\" method=\"post\"> \n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    print "<tr><td></td><td>";
    print "<input type=\"submit\" value=\"". $lex{'Save Record'}. "\"></td></tr>\n";

    print "<tr><td align=\"right\">". $lex{'Category'}. "</td>\n";
    print "<td><input type=\"text\" name=\"category\" size=\"25\"> like 'Engagement'</td></tr>\n";

    print "<tr><td align=\"right\">". $lex{Name}. "</td>\n<td>";
    print "<input type=\"text\" name=\"name\" size=\"25\"> like 'Wide Reading'</td></tr>\n";

    print "<tr><td></td><th>". $lex{Description};
    print " like: 'Limited Reading Experiences, Titles generally below grade level'\n";
    print "</th></tr>\n";

    for my $idx ( 1 .. 4 ) {

	print "<tr><td align=\"right\">$evals[$idx]\n";
	print "<input type=\"hidden\" name=\"eval_level$idx\" value=\"$evals[$idx]\"></td>\n";

	print "<td align=\"left\">\n";
	print "<input type=\"text\" name=\"description$idx\" size=\"80\">\n";
	print "</td></tr>\n";

    }

    print "<tr><td></td><td>\n<input type=\"submit\" value=\"". $lex{'Save Record'};
    print "\"></td></tr>\n";

    print "</table></center>\n";
    print "</form></center></body></html>\n";

}


#--------------
sub writeRecord {
#--------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    #die;

    my $category = $arr{category};
    my $name = $arr{name};

    for my $idx ( 1 .. 4 ) {

	my %rec = ();

	$rec{category} = $category;
	$rec{name} = $name;
	$rec{eval_level} = $arr{"eval_level$idx"};
	$rec{description} = $arr{"description$idx"};

    
	my @keys = keys %rec;
	my $keys = join(',', @keys);
	
	foreach my $k ( keys %rec ) {
	    if ( not $rec{$k} ) { 
		$rec{$k} = $sql{default};
	    } else {
		$rec{$k} = $dbh->quote( $rec{$k} );
	    }
	}
	my $values = join(',', ( values %rec ));

	$sth = $dbh->prepare("insert into read_objectives ( $keys ) values ( $values )");
	$sth->execute;

	if ( not $DBI::errstr ) {
	    print '<h3>'. $lex{'The record is now stored'}. ".</h3>\n";
	} else { 
	    print '<h3>'. $lex{'There was an error storing your data'}. ". \n";
	    print $lex{'Contact'}. " $adminname ";
	    print "(<a href=\"mailto:$adminemail\">$adminemail</a>)<br>\n";
	    print " $DBI::errstr</h3>\n";
	}


    } # End of 1..4

    
    print "<p>[ <a href=\"$self\">". $lex{'Add Another Objective'}. "</a> |\n";
    print "<a href=\"$homepage\">". $lex{Main};
    print "</a> ]</p></center></body></html>\n";

    exit;

}
