#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'View Reading Objectives' => 'View Reading Objectives',
	   'Continue' => 'Continue',
	   'View Objectives' => 'View Objectives',
	   'Contact' => 'Contact',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'No Records Found' => 'No Records Found',
	   'Error' => 'Error',
	   'Intervention' => 'Intervention',
	   'Instructional' => 'Instructional',
	   'Independent' => 'Independent',
	   'Advanced' => 'Advanced',

	   );

$evals[1] = $lex{Intervention};
$evals[2] = $lex{Instructional};
$evals[3] = $lex{Independent};
$evals[4] = $lex{Advanced};


use DBI;
use CGI;

my $self = 'readobjview.pl';

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;

eval require "../admin.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

# Page Header
print "$doctype\n<html><head><title>". $lex{'View Reading Objectives'};
print "</title><link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">
$chartype\n</head><body style=\"padding:1em 2em;\">\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";

print "<h2>". $lex{'View Reading Objectives'}. "</h2>\n";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


if ( not $arr{page} ) {
    showStartPage();
} 


#----------------
sub showStartPage {  # select the subject and # of objectives to add.
#----------------

    print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";

    # Display all subjects for selection
    my $sth = $dbh->prepare("select distinct category from read_objectives 
      order by category");
    $sth->execute;
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    
    my $sth1 = $dbh->prepare("select distinct name from read_objectives 
      where category = ?");

    my $sth2 = $dbh->prepare("select id, eval_level, description from read_objectives
      where name = ?");
    
    while ( my $category = $sth->fetchrow ) {

	# Get Objectives for this category
	$sth1->execute( $category );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

	my %objectives = ();
	while ( my $objective  = $sth1->fetchrow ) {

	    # Get records for this objective
	    $sth2->execute( $objective );
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

	    while ( my ( $id, $eval_level, $description ) = $sth2->fetchrow ) {
		$objectives{$eval_level} = $description;
	    }

	    print "<tr>";
	    for my $idx ( 1 .. 4 ) { print "<td>$objectives{$evals[$idx]}</td>\n"; }
	    print "</tr>\n";

	}


    }

    print "</table>\n";
    print "</body></html>\n";

    exit;

}


#----------------
sub addChoices {
#----------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    # Passed: objid - objid of an objective, to add to.

    # Display the Subject and the Objective, List existing objectives for this subject,
    my $sth = $dbh->prepare("select description, subjsec from rc_objective where id = ?");
    $sth->execute( $arr{objid} );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my ($objectiveDescription, $subjsec) = $sth->fetchrow;

    my $sth = $dbh->prepare("select description from rc_subject where subjsec = ?");
    $sth->execute( $subjsec );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my $subjectDescription = $sth->fetchrow;
    
    print "<h1>$subjectDescription ($subjsec) - $objectiveDescription</h1>\n";

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"3\">\n";
    print "<input type=\"hidden\" name=\"objid\" value=\"$arr{objid}\">\n";

    # Now print existing choices from this subject.
    print "<h3>". $lex{'Existing Choices'}. "</h3>\n";

    # New Stuff
    print "<div style=\"background-color:#DDD;border:1px solid gray;\"><ul>\n";
    my $sth = $dbh->prepare("select id, choice from rc_obj_choice where objid = ?");
    $sth->execute( $arr{objid} );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    while ( my ($id, $choice) = $sth->fetchrow ) {
	print "<li>$choice</li>\n";
    }
    print "</ul></div>\n";

    print "<h3>". $lex{'New Choices'}. "</h3>\n";
    
    # Get Choices from other objectives.
    my $sth1 = $dbh->prepare("select id, choice from rc_obj_choice where objid = ?");

    my $sth = $dbh->prepare("select id from rc_objective where subjsec = ?");
    $sth->execute( $subjsec );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    while ( my $id = $sth->fetchrow ) {
	$sth1->execute( $id );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	while ( my ( $choiceid, $choice ) = $sth1->fetchrow ) {
	    print "<div><input type=\"checkbox\" name=\"$choiceid\" value=\"1\"> $choice</div>\n";
	}
    }

    # Now print empty fields for new choices (up to 6?)

    for my $i (1..6) {
	my $choice = 'ch'. $i;
	print "<div style=\"padding:0.3em;\">". $lex{Choice};
	print " $i <input type=\"text\" name=\"$choice\" size=\"40\"></div>\n";
    }

    print "<input type=\"submit\" value=\"". $lex{'Save Choices'}. "\">\n";
    print "</form></center></body></html>\n";

    exit;
}


#----------------
sub writeChoices {
#----------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $objid = $arr{objid};
    delete $arr{objid};

    for my $i (1..6) {
	my $idx = 'ch'. $i;
	if ( $arr{$idx} ) {
	    $sth = $dbh->prepare("insert into rc_obj_choice ( objid, choice ) values ( ?, ? )");
	    $sth->execute( $objid, $arr{$idx} );
	    if ( $DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	}
	delete $arr{$idx};
    }

    # Insert existing choices.
    my $sth = $dbh->prepare("select choice from rc_obj_choice where id = ?");    
    foreach my $key ( sort keys %arr ) { 
	$sth->execute( $key );
	if ( $DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my $choice = $sth->fetchrow;

	# now insert the choice.
	$sth1 = $dbh->prepare("insert into rc_obj_choice ( objid, choice ) values ( ?, ? )");
	$sth1->execute( $objid, $choice );
	if ( $DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    }


    if ( not $DBI::errstr ) {
	print "<h3>". $lex{'The Records are Stored'}. ".</h3>\n";
    } else { 
	print '<h3>'. $lex{'There was an error storing your data'}. ". \n";
	print $lex{'Contact'}. " $adminname ";
	print "(<a href=\"mailto:$adminemail\">$adminemail</a>)<br>\n";
	print " $DBI::errstr</h3>\n";
    }


    print "<p>[ <a href=\"$self\">". $lex{'Add More Choices'}.' - ';
    print $lex{'Different Subject'}. "</a> |\n";

    #print "[ <a href=\"$self?subjsec=$subjsec&page=2\">". $lex{'More Objectives'}.' - ';
    #print $lex{'Same Subject'}. "</a> |\n";

    print "<a href=\"$reppage\">". $lex{'PK Report Card'}. "</a> ]</p>\n";
    print "</center></body></html>\n";

    exit;

}


#---------------
sub deledChoices  {  # edit or delete choices or delete the objective (and all it's choices.
#---------------

    # expect objid, and mode (delall, delsel, or edit)
    my ( $objid, $mode ) = @_;

    if ( $mode eq 'delall' ) {  # remove this objective and all choices; get confirmation

	# Load Objective Name and ask for deletion confirm
	print "<center><h1>". $lex{'Delete Objective'}. "</h1>\n";

	print "<form action=\"$self\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"page\" value=\"5\">\n";
	print "<input type=\"hidden\" name=\"mode\" value=\"delall\">\n";
	print "<input type=\"hidden\" name=\"objid\" value=\"$objid\">\n";

	my $sth = $dbh->prepare("select groupname, subjsec, description from rc_objective 
          where id = ?");
	$sth->execute( $objid );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my ( $groupname, $subjsec, $description ) = $sth->fetchrow;

	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
	print "<tr><td align=\"center\">$description ($groupname)</td></tr>\n";
	print "<tr><td align=\"center\"><input type=\"submit\" value=\"";
	print $lex{'Delete Objective'}. "\"></td></tr>\n";
	print "</table></form></center>\n";
	print "</body></html>\n";


    } elsif ( $mode eq 'delsel' ) { # show all choices and select those to remove.

	print "<center><h1>". $lex{'Delete Choices'}. "</h1>\n";

	print "<form action=\"$self\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"page\" value=\"5\">\n";
	print "<input type=\"hidden\" name=\"mode\" value=\"delsel\">\n";

	# Get the Objective Description
	my $sth = $dbh->prepare("select groupname, subjsec, description from rc_objective 
          where id = ?");
	$sth->execute( $objid );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my ( $groupname, $subjsec, $description ) = $sth->fetchrow;

	# Loop through all Choices for this Objective
	$sth = $dbh->prepare("select id, choice from rc_obj_choice where objid = ?");
	$sth->execute( $objid );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $rows = $sth->rows; 
	if ( $rows < 1 ) {
	    print "<b>". $lex{'No Records Found'}. "</b>\n";
	    print "</form></body></html>\n";
	    exit;
	}

	print "<h3>$description</h3>\n"; 
	print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"1\">\n";

	while ( my  ( $id, $choice ) = $sth->fetchrow ) {
	    print "<tr><td><input type=\"checkbox\" name=\"$id\" value=\"1\"></td>\n";
	    print "<td align=\"left\">$choice</td></tr>\n";
	}

	print "<tr><td></td><td align=\"left\"><input type=\"submit\" value=\"";
	print $lex{'Delete Choices'}. "\"></td></tr>\n";
	print "</table></form></center>\n";
	print "</body></html>\n";


    } elsif ( $mode eq 'edit' ) {  # show all choices with input box for editing

	print "<center><h1>". $lex{'Edit Choices'}. "</h1>\n";

	print "<form action=\"$self\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"page\" value=\"5\">\n";
	print "<input type=\"hidden\" name=\"mode\" value=\"edit\">\n";

	# Get the Objective Description
	my $sth = $dbh->prepare("select groupname, subjsec, description from rc_objective
          where id = ?");
	$sth->execute( $objid );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my ( $groupname, $subjsec, $description ) = $sth->fetchrow;

	# Loop through all Choices for this Objective
	$sth = $dbh->prepare("select id, choice from rc_obj_choice where objid = ?");
	$sth->execute( $objid );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $rows = $sth->rows; 
	if ( $rows < 1 ) {
	    print "<b>". $lex{'No Records Found'}. "</b>\n";
	    print "</form></body></html>\n";
	    exit;
	}

	print "<h3>$description</h3>\n"; 
	print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"1\">\n";

	while ( my  ( $id, $choice ) = $sth->fetchrow ) {
	    print "<tr><td><textarea rows=\"3\" cols=\"70\" name=\"$id\">$choice";
	    print "</textarea></td></tr>\n";
	}

	print "<tr><td align=\"center\"><input type=\"submit\" value=\"";
	print $lex{'Save Choices'}. "\"></td></tr>\n";
	print "</table></form></center>\n";
	print "</body></html>\n";

    }

    exit;


}



#----------------
sub updateRecords {
#----------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }


    if ( $arr{mode} eq 'delall' ) {

	# delete the choices for the objective and then the objective itself; 

	my $sth = $dbh->prepare("delete from rc_obj_choice where objid = ?");
	$sth->execute( $arr{objid} ); 
	if ( $DBI::errstr) { print $DBI::errstr; die $DBI::errstr; } 

	# now delete the objective
	my $sth = $dbh->prepare("delete from rc_objective where id = ?");
	$sth->execute( $arr{objid} ); 
	if ( $DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

	print "<center><h3>". $lex{'Record(s) deleted'}. "</h3>\n";
    

    } elsif ( $arr{mode} eq 'delsel' ) { # Delete Selected Choices
	delete $arr{mode};

	my $sth = $dbh->prepare("delete from rc_obj_choice where id = ?");
	foreach my $key ( keys %arr ) {
	    $sth->execute( $key ); 
	    if ( $DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	}
	print "<center><h3>". $lex{'Record(s) deleted'}. "</h3>\n";


    } elsif ( $arr{mode} eq 'edit' ) { # Update the records
	delete $arr{mode};

	my $sth = $dbh->prepare("update rc_obj_choice set choice = ? where id = ?");
	foreach my $key ( keys %arr ) {
	    $sth->execute( $arr{$key}, $key ); 
	    if ( $DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	}
	print "<center><h3>". $lex{'Record(s) updated'}. "</h3>\n";

    }

    print "<p>[ <a href=\"$self\">". $lex{'Add More Choices'}. "</a> |\n";

    print "<a href=\"$reppage\">". $lex{'PK Report Card'}. "</a> ]</p>\n";
    print "</center></body></html>\n";

    exit;


}
