#!/usr/bin/perl
#  Copyright 2001-2010 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Edit/Delete Reading Levels' => 'Edit/Delete Reading Levels',
	   'Main' => 'Main',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Error' => 'Error',
	   'Level' => 'Level',
	   'Category' => 'Category',
	   'Name' => 'Name',
	   'Seq' => 'Seq',

	   );

use DBI;
use CGI;


eval require "../admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = CGI->new;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


my $sortorder;
if ($arr{sortorder} eq $lex{Subject} ){
    $sortorder = 'readlevel, seq';
} else {
    $sortorder = 'description,grade,teacher';
    $arr{sortorder} = $lex{Subject};
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

my $sth = $dbh->prepare("select id, readlevel, category, name, seq 
  from read_level order by $sortorder");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
$rows = $sth->rows;

# Print HTML Head
print "$doctype\n<html><head><title>". $lex{'Edit/Delete Reading Levels'}. "</title>
<link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">
$chartype\n</head><body style=\"padding:1em;\">\n";


print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";


# print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">
# <input type=\"submit\" value=\"". $lex{'Sort by'}. "\">\n";
# print "<select name=\"sortorder\">\n";
# if ( $arr{sortorder} ) { print "<option>$arr{sortorder}</option>\n"; }
# print "<option>". $lex{Subject}. "</option><option>". $lex{Teacher};
# print "</option><option>". $lex{Grade}. "</option><option>". $lex{Term};
# print "</option></select></form></td></tr></table>\n";


print "<center><h1>". $lex{'Edit/Delete Reading Levels'}. "</h1>\n";

print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">";
print "<tr><th>". $lex{Level}. '</th><th>'. $lex{Category};
print '</th><th>'. $lex{Name}. '</th><th>'. $lex{Seq};
print '</th><th>'. $lex{Edit}. "</th><th>\n";
print $lex{Delete}. "</th></tr>\n";

while ( my ($id, $readlevel, $category, $name, $seq ) = $sth->fetchrow ) {
    
    print "<tr><td>$readlevel</td><td>$category</td><td>$name</td><td>$seq</td>\n";
    print "<td><a href=\"readed.pl?id=$id\">". $lex{Edit}. "</a></td>\n";
    print "<td><a href=\"readdel.pl?id=$id\">". $lex{Delete}. "</a></td></tr>\n";

}

print "</table></center></body></html>\n";
