#!/usr/bin/perl
#  Copyright 2001-2015 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


my %lex = ('Dump Reading Data' => 'Dump Reading Data',
	   'Combine failed on input' => 'Combine failed on input',
	   'Download CSV File' => 'Download CSV File',
	   'Main' => 'Main',

	   );


use DBI;
use CGI;
use Text::CSV_XS;


my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;


# Read config variables
eval require "../admin.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}


eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}


my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $iddst) = localtime(time);
$year = $year + 1900;
$wday++;
$mon++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $csv = Text::CSV_XS->new( {binary => 1} );


# HTML Heading
print "$doctype\n<html><head><title>". $lex{'Dump Reading Data'};
print "</title><link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">\n";
print "<style type=\"text/css\">th.h {background-color:#99F;}</style>\n";
print "$chartype\n</head><body style=\"padding:1em 2em;\">\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";

print "<center><h1>". $lex{'Dump Reading Data'}. "</h1><h3>$currdate</h3>\n";

print "<p><a href=\"$webdownloaddir/$filename\">
<span style=\"font-size:130%\">". $lex{'Download CSV File'}. "</span></a></p>\n";

# Open output file
my $filename = "readdump$$.csv";
open (EX,">$filename") || die "Can't open Export file $filename";

foreach $database ( keys %alldbase ) { #defined in global config file.

    my $dsn = "DBI:mysql:$database";
    my $dbh = DBI->connect($dsn,$guser,$gpassword);

    # Read each test and then scores in turn.
    my $sth = $dbh->prepare("select id, studnum, readlevel, tdate, tauthor, tgrade, tstamp from read_test"); 
    $sth->execute;
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

    my $sth1 = $dbh->prepare("select seq, score from read_test_score where testid = ? order by seq");

    my $sth2 = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");



    while ( my ( @fields ) = $sth->fetchrow ) {
	
	#my $id = unshift @fields; # pull out the record id.
	my $id = $fields[0]; # pull out the record id.
	
	# Get Student Name
	my $studnum = $fields[1];
	$sth2->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my ( $lastname,$firstname ) = $sth2->fetchrow;

	# Put in Name
	unshift @fields, $lastname;
	unshift @fields, $firstname;

	# Put in School database
	unshift @fields, $database;

	# Get the scores for this test.
	$sth1->execute( $id );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	while ( my ( $seq, $score ) = $sth1->fetchrow ) {
	    # add scores
	    push @fields, $score;
	}

	# convert record to csv
	if ( $csv->combine(@fields) ) {
	    my $record = $csv->string;
	    print EX $record, "\r\n";
	} else {
	    my $err = $csv->error_input;
	    print $lex{'Combine failed on input'}. ":$err\n\n";
	}
	
    } # End of Database reading Loop.

}

close EX;
system("mv $filename $downloaddir");

print "<p><a href=\"$webdownloaddir/$filename\">
<span style=\"font-size:130%\">". $lex{'Download CSV File'}. "</span></a></p>\n";

print "</center></body></html>\n";
