#!/usr/bin/perl
#  Copyright 2001-2010 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Error' => 'Error',
	   'Add Reading Levels' => 'Add Reading Levels',
	   'Save Record' => 'Save Record',
	   'Save' => 'Save',
	   'Reading Level' => 'Reading Level',
	   'Printed Language Concepts' => 'Printed Language Concepts',
	   'Oral Fluency' => 'Oral Fluency',
	   'Reading Engagement' => 'Reading Engagement',
	   'Comprehension' => 'Comprehension',
	   'Category' => 'Category',
	   'Name' => 'Name',
	   'No Records Found' => 'No Records Found',
	   'Existing Records' => 'Existing Records',
	   'Separate by 10s' => 'Separate by 10s',
	   'Sequence Number' => 'Sequence Number',
	   'Sequence' => 'Sequence',
	   'Continue' => 'Continue',

	   'The record is now stored' => 'The record is now stored',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Contact' => 'Contact',

	   );

use DBI;
use CGI;

my $self = 'readlvladd.pl';


my @category = ();
$category[0] = $lex{'Reading Engagement'};
$catseq{ $lex{'Reading Engagement'} } = 10;

$category[1] = $lex{'Oral Fluency'};
$catseq{ $lex{'Oral Fluency'} } = 20;

$category[2] = $lex{'Printed Language Concepts'};
$catseq{ $lex{'Printed Language Concepts'} } = 30;

$category[3] = $lex{'Comprehension'};
$catseq{ $lex{'Comprehension'} } = 40;

#$category[4] = $lex{};


my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;

eval require "../admin.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

# Page Header
print "$doctype\n<html><head><title>". $lex{'Add Reading Levels'};
print "</title><link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">
$chartype\n</head><body style=\"padding:1em 2em;\">\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";
print "<h1>". $lex{'Add Reading Levels'}. "</h1>\n";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

if ( not $arr{page} ) {
    showStartPage();
} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    showEntryPage();
}  elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    writeRecord();
}



#----------------
sub showStartPage {
#----------------


    print "<form action=\"$self\" method=\"post\"> \n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    #print "<tr><td></td><td>";
    #print "<input type=\"submit\" value=\"". $lex{'Save Record'}. "\"></td></tr>\n";

    print "<tr><td align=\"right\">". $lex{'Reading Level'}. "</td>\n";
    print "<td><input type=\"text\" name=\"readlevel\" size=\"5\"></td></tr>\n";

    print "<tr><td></td><td>\n<input type=\"submit\" value=\"". $lex{Continue};
    print "\"></td></tr>\n";

    print "</table></center>\n";
    print "</form></center></body></html>\n";


} # end of showStartPage


#----------------
sub showEntryPage {
#----------------

    my $readlevel = $arr{readlevel};
    if ( $readlevel eq 'A' ) { $readlevel = '0'; }

    print "<p style=\"font-size:150%;font-weight:bold\">". $lex{'Reading Level'}. " $readlevel</p>\n";

    # Display Existing Values (if any)
    $sth = $dbh->prepare("select * from read_level where readlevel = ? order by seq");
    $sth->execute( $readlevel );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    print "<div><b>". $lex{'Existing Records'}. "</b></div>\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    my $first = 1;

    while ( my ( $id, $rlevel, $category, $name, $seq ) = $sth->fetchrow ) {
	if ( $first ) {
	    print "<tr><th>". $lex{Category}. "</th><th>". $lex{Name}. "</th><th>". $lex{Sequence}. "</th></tr>\n";
	    $first = 0;
	}
	print "<tr><td>$category</td><td>$name</td><td>$seq</td></tr>\n";
    }
	    
    if ( $first ) { print "<tr><td>". $lex{'No Records Found'}. "</td></tr>\n"; }
    print "</table><p></p>\n";


    print "<form action=\"$self\" method=\"post\"> \n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";
    print "<input type=\"hidden\" name=\"readlevel\" value=\"$readlevel\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    print "<tr><td></td><td>\n<input type=\"submit\" value=\"". $lex{Save};
    print "\"></td></tr>\n";

    # print Table Header.
    print "<tr><th>". $lex{Category}. "</th>\n";
    print "<th>". $lex{Name}. "</th><th>". $lex{'Sequence Number'}. "<br>";
    print $lex{'Separate by 10s'}. "</th></tr>\n";

    for my $idx ( 1 .. 16 ) {

	print "<tr><td><select name=\"category$idx\"><option></option>\n";
	foreach my $cat ( @category ) {
	    print "<option>$cat</option>\n";
	}

	print "</td><td>";
	print "<input type=\"text\" name=\"name$idx\" size=\"35\"></td>\n<td>";
	print "<input type=\"text\" name=\"seq$idx\" size=\"6\"></td></tr>\n";

    }

    print "<tr><td></td><td>\n<input type=\"submit\" value=\"". $lex{Save};
    print "\"></td></tr>\n";

    print "</table></form></center></body></html>\n";

    exit;

}


#--------------
sub writeRecord {
#--------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    #foreach my $key ( sort keys %catseq ) { print "K:$key V:$catseq{$key}<br>\n"; }


    my $readlevel = $arr{readlevel};
    # no need to delete %arr elements since just using counted # to index.

    for my $idx ( 1 .. 16 ) {

	if ( not $arr{ "name$idx" } ) { next; } # skip blanks.

	my %rec = ();

	$rec{readlevel} = $readlevel;
	$rec{category} = $arr{"category$idx"};
	$rec{name} = $arr{"name$idx"};
	$rec{seq} = $arr{ "seq$idx" };

	#print "Name: $rec{name} Category: $rec{category} Seq: $rec{seq}<br>\n";
    
	my @keys = keys %rec;
	my $keys = join(',', @keys);
	
	foreach my $k ( keys %rec ) {
	    if ( not $rec{$k} ) { 
		$rec{$k} = $sql{default};
	    } else {
		$rec{$k} = $dbh->quote( $rec{$k} );
	    }
	}
	my $values = join(',', ( values %rec ));

	$sth = $dbh->prepare("insert into read_level ( $keys ) values ( $values )");
	$sth->execute;

	if ( not $DBI::errstr ) {
	    print '<h3>'. $lex{'The record is now stored'}. ".</h3>\n";
	} else { 
	    print '<h3>'. $lex{'There was an error storing your data'}. ". \n";
	    print $lex{Contact}. " $adminname ";
	    print "(<a href=\"mailto:$adminemail\">$adminemail</a>)<br>\n";
	    print " $DBI::errstr</h3>\n";
	}


    } # End of 1..16

    
    print "<p>[ <a href=\"$self\">". $lex{'Add Reading Levels'}. "</a> |\n";
    print "<a href=\"$homepage\">". $lex{Main};
    print "</a> ]</p></center></body></html>\n";

    exit;

}
