#!/usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

# Values found in Nominal Roll records - all schools

my %lex = ('Error' => 'Error',
	   'Main' => 'Main',
	   'Nominal Roll' => 'Nominal Roll',
	   'Staff' => 'Staff',
	   'Report' => 'Report',
	   'Values' => 'Values',

	   );


my $self = 'rptNomrollStaff.pl';

use DBI;
use CGI;
use URI::Escape;

eval require "admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval { require "$globdir/global.conf"; };
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

@dbase = sort keys %alldbase; # global records.


my $q = CGI->new;
my %arr = $q->Vars;
print $q->header( -charset, $charset );

# Get student NR field names.
my $dsn = "DBI:mysql:information_schema";
my $dbh = DBI->connect($dsn,$guser,$gpassword);

my $sth = $dbh->prepare("select column_name from COLUMNS where table_schema = ? and table_name = ?");
$sth->execute($dbase[0], 'staff');
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my $ref = $sth->fetchall_hashref(column_name);


delete $ref->{id};
delete $ref->{userid};
delete $ref->{lastname};
delete $ref->{firstname};
delete $ref->{sal};
delete $ref->{password};
delete $ref->{'alt_city'};
delete $ref->{'alt_prov'};
delete $ref->{'alt_country'};
delete $ref->{'alt_email'};
delete $ref->{'alt_phone'};
delete $ref->{'alt_pcode'};
delete $ref->{'alt_street'};
delete $ref->{'cell_phone'};
delete $ref->{certification1};
delete $ref->{certification2};
delete $ref->{certification3};
delete $ref->{certification4};
delete $ref->{certification5};
delete $ref->{certification6};
delete $ref->{certification7};
delete $ref->{certification8};
delete $ref->{birthdate};
delete $ref->{citizenship};
delete $ref->{city};
delete $ref->{doatt};
delete $ref->{driver_class};
delete $ref->{driver_license};
delete $ref->{home_phone};
delete $ref->{ldap_gidnumber};
delete $ref->{ldap_uidnumber};
delete $ref->{ldap_uid};
delete $ref->{middlename};
delete $ref->{nrskip};
delete $ref->{prov};
delete $ref->{pcode};
delete $ref->{passport};
delete $ref->{vehicle_plate};
delete $ref->{vehicle_reg};
delete $ref->{emergency_contact_name};
delete $ref->{emergency_contact_phone};
delete $ref->{street};
delete $ref->{tdate};
delete $ref->{email};


# fields of this 
my @fields = sort keys %$ref;
my $fields = join(',',@fields );


# Script Heading Descriptor
my $title = "$lex{'Nominal Roll'} $lex{Staff} $lex{Report}";

# Print Page Heading
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">\n";

print "$chartype\n</head><body style=\"padding:0.4em 2em;\">\n";
print "[ <a class=\"alt\" href=\"$homepage\">$lex{Main}</a> ]\n";
print "<h1>$title</h1>\n";

if ( not $arr{page} ) {

    showValues();
} elsif ( $arr{page} == 3 ){

    delete $arr{page};
    showRecords();
}

#-------------
sub showValues {
#-------------


    foreach my $db ( @dbase ) {

	my $database = $db;
	my $dsn = "DBI:$dbtype:dbname=$database";
	my $dbh = DBI->connect($dsn,$guser,$gpassword);
	my $schoolname = $alldbase{"$db"};

	print "<h2>$schoolname</h2>\n";

	print qq{<table cellspacing="0" cellpadding="3" border="1">\n};
	foreach my $field ( @fields ) {

	    print "<tr><td>$field</td><td>";

	    my $sth = $dbh->prepare("select distinct $field from staff 
              where $field is not NULL and $field != ''");
	    $sth->execute;
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    if ( $field eq 'occupations') {
		while ( my $occfield = $sth->fetchrow ) {

		    eval $occfield;
		    if ( $@ ) {
			print $lex{Error}. " $@<br>\n";
			die $lex{Error}. " $@\n";
		    }
		    foreach my $key ( sort keys %occ ) {
			
			my %rec = %{$occ{$key} };
			print "Type:$rec{type} ";
			print "Percent: $rec{percent} ";
			print "Grades: ";
			my %gr = %{ $rec{grade} };
			foreach my $gkey ( keys %gr ) {
			    print "$gr{$gkey} ";
			}
		    }
		    print "<br>\n";

		}

	    } else {
		while ( my $val = $sth->fetchrow ) {
		    # use $field and $val to provide hyperlink;
		    my $urival = uri_escape( $val );
		    print qq{<a href="$self?page=3&fld=$field&val=$urival&db=$db" target="_blank">};
		    print "$val</a>&nbsp;&nbsp;";
		}
	    }
	    
	    print "</td></tr>\n";

	}

	print "</table><p></p>\n";


    } # db loop


} # end of showValues()



#--------------
sub showRecords {
#--------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $database = $arr{db};
    my $dsn = "DBI:$dbtype:dbname=$database";
    my $dbh = DBI->connect($dsn,$guser,$gpassword);
    my $schoolname = $alldbase{"$database"};

    print qq{<table cellpadding="3" cellspacing="0" border="1">\n};

    print "<tr><td><b>School:</b> $schoolname</td></tr>\n";
    print "<tr><td><b>Field:</b> $arr{fld}</td></tr>\n";
    print "<tr><td><b>Value</b> $arr{val}</td></tr>\n";
    print qq{<tr style="background-color:#DDD;font-weight:bold;text-align:center;"><td>Staff</td></tr>\n};

    my $sth = $dbh->prepare("select lastname, firstname, userid from staff 
       where $arr{fld} = ?");
    $sth->execute( $arr{val} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }



    while ( my ( $lastname, $firstname, $userid ) = $sth->fetchrow ) {
	print "<tr><td><b>$lastname</b>, $firstname ($userid)</td></tr>\n";
    }
    print "</table>\n";

    print "</body></html>\n";
    exit;

}
