#!/usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

# Values found in Nominal Roll records - all schools

my %lex = ('Error' => 'Error',
	   'Main' => 'Main',
	   'Nominal Roll' => 'Nominal Roll',
	   'Report' => 'Report',
	   'Values' => 'Values',

	   );


my $self = 'rdRptProgress.pl';

use DBI;
use CGI;

eval require "admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval { require "$globdir/global.conf"; };
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

@dbase = sort keys %alldbase; # global records.


my $q = CGI->new;
my %arr = $q->Vars;
print $q->header( -charset, $charset );

# Get student NR field names.
my $dsn = "DBI:mysql:information_schema";
my $dbh = DBI->connect($dsn,$guser,$gpassword);

my $sth = $dbh->prepare("select column_name from COLUMNS where table_schema = ? and table_name = ?");
$sth->execute($dbase[0], 'student_inac');
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my $ref = $sth->fetchall_hashref(column_name);


delete $ref->{id};
delete $ref->{studnum};

# fields of this 
my @fields = sort keys %$ref;
my $fields = join(',',@fields );


# Script Heading Descriptor
my $title = "$lex{'Nominal Roll'} $lex{Values} $lex{Report}";

# Print Page Heading
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">\n";

print "$chartype\n</head><body style=\"padding:0.4em 2em;\">\n";
print "[ <a class=\"alt\" href=\"$homepage\">$lex{Main}</a> ]\n";
print "<h1>$title</h1>\n";


showValues();


#-------------
sub showValues {
#-------------


    foreach my $db ( @dbase ) {

	my $database = $db;
	my $dsn = "DBI:$dbtype:dbname=$database";
	my $dbh = DBI->connect($dsn,$guser,$gpassword);
	my $schoolname = $alldbase{"$db"};

	print "<h2>$schoolname</h2>\n";

	print qq{<table cellspacing="0" cellpadding="3" border="1">\n};
	foreach my $field ( @fields ) {

	    print "<tr><td>$field</td><td>";

	    my $sth = $dbh->prepare("select distinct $field from student_inac 
              where $field is not NULL and $field != ''");
	    $sth->execute;
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    while ( my $val = $sth->fetchrow ) {
		print $val, "&nbsp;&nbsp;";
	    }
	    
	    print "</td></tr>\n";

	}

	print "</table><p></p>\n";


    } # db loop


} # end of showValues()
