#!/usr/bin/perl
#  Copyright 2001-2016 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

use DBI;
use CGI;
use Time::JulianDay;

my %lex = ('Graduation Requirements' => 'Graduation Requirements',
	   'Credits' => 'Credits',
	   'Check' => 'Check', 
	   'Main' => 'Main',
	   'Provincial Number' => 'Provincial Number',
	   'Duplicate' => 'Duplicate',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Continue' => 'Continue',
	   'Check All' => 'Check All',
	   'Schools' => 'Schools',
	   'Select' => 'Select',

	   );


my $self = 'checkgrad.pl';


# Read Config
eval require "../admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

foreach my $val ( qw(cws chieftaylor aca willowcree moosomin saulteaux sweetgrass pewasenakwan mosquito khwc)) {
    delete $alldbase{$val};
}

my @dbase = sort keys %alldbase; # global records.


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my (%saskedgrade, %saskedname);

my $title = "$lex{Check} $lex{Credits}";
print "$doctype\n<html><head><title>$title</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
<style>td.v { vertical-align:top;align:center; }</style>
$chartype\n</head><body style=\"padding:1em;\">\n";

print "[ <a href=\"$homepage\">$lex{Main}</a> ]\n";

print "<h1>$title</h1>\n";


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    checkSchools();

}  elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    viewStudentCredits();
}


#---------------
sub checkSchools {
#---------------

    # foreach my $key ( sort keys %arr ) { print qq{K:$key V:$arr{$key}<br>\n}; }

    if ( not $arr{grade} ) {
	print qq{<h3>$lex{Missing} $lex{Grade}</h3>\n};
	print qq{</body></html>\n};
	exit;
    }

    my $grade = $arr{grade};
    delete $arr{grade};

    # load the sasked ed courses with grade;
    my $dbname = 'central';
    my $dsn = "DBI:$dbtype:dbname=$dbname";
    my $dbh = DBI->connect($dsn,$guser,$gpassword);
    $dbh->{mysql_enable_utf8} = 1;

    my $sth = $dbh->prepare("select * from sasked_courses");
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
    while ( $ref = $sth->fetchrow_hashref ) {
	my %r = %$ref;
	$saskedgrade{$r{code}} = $r{grade};
	$saskedname{$r{code}} = $r{title};
    }


    foreach my $dbase ( sort keys %arr ) {
	
	print qq{<h2>$alldbase{$dbase}</h2>\n};


	my $dsn = "DBI:$dbtype:dbname=$dbase";
	my $dbh = DBI->connect($dsn,$guser,$gpassword);
	$dbh->{mysql_enable_utf8} = 1;

	my $sth = $dbh->prepare("select studnum, lastname, firstname, provnum from student where grade = ? 
           order by lastname, firstname");
	$sth->execute( $grade );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}

	my $first = 1;

	while ( $ref = $sth->fetchrow_hashref ) {
	    my %r = %$ref;

	    if ( $first ) {
		print qq{<table cellpadding="3" cellspacing="0" border="1">\n};
		print qq{<tr><th>Student</th><th>Missing<br>Gr 10 Req</th><th>Missing<br>Gr 11 Req</th>};
		print qq{<th>Missing<br>Gr 12 Req</th><th>Grade<br>Credits</th></tr>\n};
		$first = 0;
	    }

	    print qq{<tr><td class="v"><b>$r{lastname}</b>, $r{firstname}<br>$r{provnum} };


	    if ( $r{provnum} ) {
		print qq{<form action="$self" method="post" style="display:inline;">\n};
		print qq{<input type="hidden" name="page" value="2">\n};
		print qq{<input type="hidden" name="provnum" value="$r{provnum}">\n};
		print qq{<input type="hidden" name="dbase" value="$dbase">\n};
		print qq{<input type="submit" value="View"></form>\n};
	    }
	    print qq{</td>};


	    if ( $r{provnum} ) {
		my @result = checkCredit10( $r{provnum}, $dbh );
		print q{<td class="v">};
		if ( not @result ) {
		    print qq{<b>Complete</b>}; 
		} else { #print incompletes
		    foreach my $res ( @result ) { 
			print qq{$res<br>\n}; 
		    }
		}

		print q{</td><td class="v">};

		my @result11 = checkCredit11( $r{provnum}, $dbh );
		if ( not @result11 ) { 

		    print qq{<b>Complete</b>}; 
		} else { #print incompletes
		    foreach my $res ( @result11 ) { 
			print qq{$res<br>\n}; 
		    }
		}


		print q{</td><td class="v">};

		my @result12 = checkCredit12( $r{provnum}, $dbh );
		if ( not @result12 ) { 
		    print qq{<b>Complete</b>}; 

		} else { #print incompletes
		    foreach my $res ( @result12 ) { 
			print qq{$res<br>\n}; 
		    }
		}
		print qq{</td>\n};


		# Print completed Credits
		my $cref = getCredits( $r{provnum}, $dbh );
		my %credits = %$cref;
		my %gcred; 
		foreach my $cid ( keys %credits ) {
		    $gcred{ $credits{$cid} }++;
		}
		print q{<td class="v">};
		my $csum = '0';
		foreach my $grade ( sort keys %gcred ) {
		    print qq{Gr $grade: $gcred{$grade}<br>\n};
		    $csum += $gcred{$grade};
		}
		print qq{<b>Total $csum</b></td></tr>\n};


	    } else {
		print qq{<td colspan="2">Missing Provincial Number</td></tr>\n};
	    }

	} # end student loop 

	print qq{</table>\n};

    } # end school loop


} # end of checkSchools


#-------------
sub getCredits { 
#-------------

    # foreach my $key ( sort keys %arr ) { print qq{K:$key V:$arr{$key}<br>\n}; }

    my ($provnum, $dbh) = @_; # passed provincial number, dbh

    # Load their completed courses
    my $sth = $dbh->prepare("select courseid from sasked_completedcourses where provnum = $provnum and creditsearned = '1'");
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}

    my %completed;
    while ( my $courseid = $sth->fetchrow ) {
	$completed{$courseid} = $saskedgrade{$courseid};
    }

    return \%completed;

} # end of getCredits



#----------------
sub checkCredit10 { # check grade 10 completion list; return any errors (missing requirements)
#----------------

    # foreach my $key ( sort keys %arr ) { print qq{K:$key V:$arr{$key}<br>\n}; }

    my ($provnum, $dbh) = @_; # passed provincial number, dbh

    # Load their completed courses
    my $sth = $dbh->prepare("select courseid from sasked_completedcourses where provnum = $provnum and creditsearned = '1'");
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}

    my %completed;
    while ( my $courseid = $sth->fetchrow ) {
	$completed{$courseid} = 1;
    }

    my @incomplete; # return text based codes

    my %ignore = qw(4017 4018 4214 4424 4423 4307 4306 4309); # courses required to skip in finding electives.

    # Go through the completion requirements;

    # 1. ELA A10 (4017)
    if ( not $completed{4017} ) {
	push @incomplete, 'ELA A10';
    }

    # 2. ELA B10 (4018)
    if ( not $completed{4018} ) {
	push @incomplete, 'ELA B10';
    }

    # 3. Science 10 (4214)
    if ( not $completed{4214} ) {
	push @incomplete, 'Science 10';
    }


    # 4. A Math (4424 (Foundations), or 4423 (Workplace))
    if ( not $completed{4424} and not $completed{4423} ) { # haven't done either math
	push @incomplete, '10 Math';
    }

    # 5. A Social Science  SS10 (4307) ,Hist10 (4306) , Native Stud 10 (4309)
    if ( not $completed{4307} and not $completed{4306} and not $completed{4309} ) { # haven't done any social
	push @incomplete, '10 Social';
    }

    # 6. 3 more electives at 10 level or higher.
    # Loop over completed courses
    my @electives;
    foreach my $courseid ( keys %completed ) { 
	my $grade = $saskedgrade{$courseid};

	if ( $ignore{$courseid} ) { next; } # these don't count, done above.
	if ( $grade < 10 ) { next; } # lower grade level

	push @electives, $courseid;
    }

    if ( @electives < 3 ) { # error
	push @incomplete, '10 Electives';
    }

    return @incomplete;

} # end of checkCredit10



#----------------
sub checkCredit11 { # check grade 11 completion list; return any errors (missing requirements)
#----------------

    # foreach my $key ( sort keys %arr ) { print qq{K:$key V:$arr{$key}<br>\n}; }

    my ($provnum,$dbh) = @_;

    # Load their completed courses
    my $sth = $dbh->prepare("select courseid from sasked_completedcourses where provnum = $provnum and creditsearned = '1'");
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}

    my %completed;
#    print qq{<b>Credit 11:$provnum</b><br>\n};
    while ( my $courseid = $sth->fetchrow ) {
#	print "$saskedname{$courseid} ($courseid)/ ";
	$completed{$courseid} = 1;
    }


    my @incomplete; # return text based codes
    my %ignore; # codes to ignore (since credit already given)


    # Go through the completion requirements;

    # 1. ELA 20 (6017)
    if ( not $completed{4017} ) {
	push @incomplete, 'ELA 20';
    } else {
	$ignore{4017};
    }

    # 2. Sciences ( Enviro 6246, Physical 6247, Health 6245, Computer 6702 ) (#physics 20 (6213) and chem 20 (6212) no longer allowed
    my $incompleteflag = 1; # assume incomplete unless we find a completed course;
    foreach my $cid ( qw(6245 6246 6247 6702 6212 6213)) {  
	if ( $completed{$cid} ) { 
	    $incompleteflag = 0; 
	    $ignore{$cid} = 1; # add this course to the ignore list, since we get a credit for this, can't be elective.
	}
    }
    if ( $incompleteflag ) {
	push @incomplete, '11 Science';
    }


    # 3. A Math ( 6423 Workplace, 6425 Foundations, 6426 Pre-Calculus )
    my $incompleteflag = 1; # assume incomplete unless we find a completed course;
    foreach my $cid (qw(6423 6425 6426)) {
	if ( $completed{$cid} ) { 
	    $incompleteflag = 0; 
	    $ignore{$cid} = 1; # add this course to the ignore list, since we get a credit for this, can't be elective.
	}
    }
    if ( $incompleteflag ) {
	push @incomplete, '11 Math';
    }


    # 4. A Social Science (big list)
    my $incompleteflag = 1; # assume incomplete unless we find a completed course;
    foreach my $cid ( qw(6306 6309 6307 2140 2150 6340 8306 8321 8307 8339 3140 3150 8340 )) {
	if ( $completed{$cid} ) { 
	    $incompleteflag = 0;
	    $ignore{$cid} = 1; # add this course to the ignore list, since we get a credit for this, can't be elective.
	}
    }
    if ( $incompleteflag ) {
	push @incomplete, '11 Social';
    }


    # 5. 3 more electives at 11 level or higher.
    # Loop over completed courses
    my @electives;
    foreach my $courseid ( keys %completed ) { 
	my $grade = $saskedgrade{$courseid};
	# print "Course:$courseid Grade:$grade<br>\n";

	if ( $ignore{$courseid} ) { next; } # these don't count, done above.
	if ( $grade < 11 ) { next; } # lower grade level
	push @electives, $courseid;
    }

    if ( @electives < 3 ) { # error
	push @incomplete, '11 Electives';
    }

    return @incomplete;


} # end of checkCredit11


#----------------
sub checkCredit12 { # check grade 12 completion list; return any errors (missing requirements)
#----------------

    # foreach my $key ( sort keys %arr ) { print qq{K:$key V:$arr{$key}<br>\n}; }

    my ($provnum,$dbh) = @_;

    # Load their completed courses
    my $sth = $dbh->prepare("select courseid from sasked_completedcourses where provnum = $provnum and creditsearned = '1'");
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}

    my %completed;
#    print qq{<b>Credit 11:$provnum</b><br>\n};
    while ( my $courseid = $sth->fetchrow ) {
#	print "$saskedname{$courseid} ($courseid)/ ";
	$completed{$courseid} = 1;
    }


    my @incomplete; # return text based codes
    my %ignore; # codes to ignore (since credit already given)


    # Go through the completion requirements;

    # 1. ELA A30
    if ( not $completed{8017} ) {
	push @incomplete, 'ELA A30';
    } else {
	$ignore{8017};
    }


    # 2. ELA B30
    if ( not $completed{8018} ) {
	push @incomplete, 'ELA B30';
    } else {
	$ignore{8018};
    }


=head
    # 3. Sciences ( Enviro 6246, Physical 6247, Health 6245, Computer 6702 ) (#physics 20 (6213) and chem 20 (6212) no longer allowed
    my $incompleteflag = 1; # assume incomplete unless we find a completed course;
    foreach my $cid qw(6245 6246 6247 6702 6212 6213) {  
	if ( $completed{$cid} ) { 
	    $incompleteflag = 0; 
	    $ignore{$cid} = 1; # add this course to the ignore list, since we get a credit for this, can't be elective.
	}
    }
    if ( $incompleteflag ) {
	push @incomplete, '11 Science';
    }


    # 3. A Math ( 6423 Workplace, 6425 Foundations, 6426 Pre-Calculus )
    my $incompleteflag = 1; # assume incomplete unless we find a completed course;
    foreach my $cid qw(6423 6425 6426) {
	if ( $completed{$cid} ) { 
	    $incompleteflag = 0; 
	    $ignore{$cid} = 1; # add this course to the ignore list, since we get a credit for this, can't be elective.
	}
    }
    if ( $incompleteflag ) {
	push @incomplete, '11 Math';
    }
=cut


    # 4. A Social Science
    my ($cdnflag, $g10flag, $g1112flag); # flags to show if done both gr 10 credit and 11/12 credit for these other SS courses.
    foreach my $cid ( qw(8306 8321 8307)) {
	if ( $completed{$cid} ) { 
	    $cdnflag = 1;
	    $ignore{$cid} = 1; # add this course to the ignore list, since we get a credit for this, can't be elective.
	}
    }

    # Now check the rest
    foreach my $cid ( qw(6306 6309 6307 2140 2150 6340 8339 3140 3150 8340 )) {
	if ( $completed{$cid} ) { 
	    if ( $saskedgrade{$cid} == 10 ) { $g10flag = 1; }
	    if ( $saskedgrade{$cid} == 11 or $saskedgrade{$cid} == 12 ) { $g1112flag = 1; }
	    $ignore{$cid} = 1;
	}
    }

    if ( not $cdnflag or not $g10flag or not $g1112flag ) {
	push @incomplete, '12 Social';
    }


    # 5. Electives: 6 more electives at 11 level or higher.
    # Loop over completed courses
    my @electives;
    foreach my $courseid ( keys %completed ) {
	my $grade = $saskedgrade{$courseid};

	if ( $ignore{$courseid} ) { next; } # these don't count, done above.
	if ( $grade < 11 ) { next; } # lower grade level
	push @electives, $courseid;
    }

    if ( @electives < 6 ) { # error
	push @incomplete, '12 Electives';
    }

    return @incomplete;


} # end of checkCredit12




#----------------
sub showStartPage {
#----------------

    my $checked;
    if ( $arr{checked} ) {
	$checked = qq{checked="checked"};
    }

    print qq{<form action="$self" method="post" style="display:inline;margin:1em;">\n};
    print qq{<input type="hidden" name="checked" value="1">\n};
    print qq{<input type="submit" value="$lex{'Check All'} $lex{Schools}" style="display:inline;"></form>\n};

    print qq{<h3>$lex{Select} $lex{Schools}/$lex{Grade}</h3>\n};

    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="1">\n};

    print qq{<table cellpadding="3" cellspacing="0" border="0">\n};
    print qq{<tr><td class="la" colspan="2"><input type="submit" value="$lex{Continue}"></td></tr>\n};

    print qq{<tr><td class="bla">$lex{Grade} <input type="text" name="grade" size="4"></td></tr>\n};
   
    foreach my $db ( @dbase ) { 

	print qq{<tr><td class="la">};
	print qq{<input type="checkbox" name="$db" value="1" $checked>\n};
	print qq{ $alldbase{$db} ($db)</td></tr>\n};
    }

    print qq{<tr><td class="la" colspan="2"><input type="submit" value="$lex{Continue}"></td></tr>\n};
    print qq{</table>\n};
    print qq{</form></body></html>\n};

    exit;

}


#---------------------
sub viewStudentCredits {
#---------------------

    # foreach my $key ( sort keys %arr ) { print qq{K:$key V:$arr{$key}<br>\n}; }
    # exit;
    # Passed: dbase and provnum;


    if ( not $arr{provnum} ) { print "<h3>Student Not found</h3>\n"; print "</body></html>\n"; exit; }

    # Local Database;
    my $dsn = "DBI:$dbtype:dbname=$arr{dbase}";
    my $dbh = DBI->connect($dsn,$guser,$gpassword);
    $dbh->{mysql_enable_utf8} = 1;


    # Central Database
    my $db = 'central';
    my $dsn1 = "DBI:$dbtype:dbname=$db";
    my $dbh1 = DBI->connect($dsn1,$user,$password);
    $dbh1->{mysql_enable_utf8} = 1;

    # Get Course Info from Sask Ed courses.
    my $sth1 = $dbh1->prepare("select title, grade from sasked_courses where code = ?");


    # Student Name
    my $sth = $dbh->prepare("select lastname, firstname, studnum, grade from studentall where provnum = ?");
    $sth->execute( $arr{provnum} );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
    my ($lastname, $firstname, $studnum, $grade ) = $sth->fetchrow;

    print qq{<h3>$firstname $lastname  Grade:$grade</h3>\n};


    # Load their completed courses
    my $sth = $dbh->prepare("select * from sasked_completedcourses where provnum = ? order by schoolyear, courseenddate");
    $sth->execute( $arr{provnum} );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}

    print qq{<table cellpadding="3" cellspacing="0" border="1">\n};
    print qq{<tr><th>Title</th><th>Code</th><th>Grade</th><th>School<br>Year</th><th>Credits<br>Earned</th></tr>\n};

    my $totalcredits;
    my ($curryear, $prevyear);
    my $first = 1;

    while ( my $ref = $sth->fetchrow_hashref ) {
	my %r = %$ref;

	$prevyear = $curryear;
	$curryear = $r{schoolyear};
	if ( $prevyear ne $curryear and not $first ) {
	    print qq{<tr style="background-color:#EEE;"><td colspan="4" class="bra">};
	    print qq{Current Credits</td><td  class="cn">$totalcredits</td></tr>\n};
	}
	$first = 0;
	
	# Get Course Title if not stored
	my ($title, $grade);
	$sth1->execute( $r{courseid} );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
	my ($title, $grade) = $sth1->fetchrow;

	my $creditcolor = 'green';
	if ( not $r{creditsearned} ) {
	    $creditcolor = 'red';
	}

	print qq{<tr><td>$title</td><td>$r{courseid}</td><td>$grade</td><td>$r{schoolyear}</td>};
	print qq{<td style="color:$creditcolor;" class="cn">$r{creditsearned}</td></tr>\n};
	$totalcredits += $r{creditsearned};

    }

    print qq{<tr style="background-color:#EEE;"><td colspan="4" class="bra">Total Credits</td>};
    print qq{<td class="cn">$totalcredits</td></tr>\n};
    print qq{</table>\n};

=head

    my @result = checkCredit10( $r{provnum}, $dbh );
    print q{<td>};
    if ( not @result ) { 
	print qq{<b>Complete</b>}; 
    } else { #print incompletes
	foreach my $res ( @result ) { 
	    print qq{$res<br>\n}; 
	}
    }
    print q{</td><td>};

    my @result11 = checkCredit11( $r{provnum}, $dbh );
    if ( not @result11 ) { 
	print qq{<b>Complete</b>}; 
    } else { #print incompletes
	foreach my $res ( @result11 ) { 
	    print qq{$res<br>\n}; 
	}
    }
    print qq{</td></tr>\n};
=cut

    print qq{</body></html>\n};
    exit;

}
