#! /usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

# Check the school marks from previous years and then compare the
# marks with student values stored in the sasked completed marks table
# (which is assumed to be up to date.


my %lex = ('Report' => 'Report',
	   'Main' => 'Main',
	   'Attendance' => 'Attendance',
	   'Periods Per Day' => 'Periods Per Day',
	   'View/Download' => 'View/Download',
	   'View Log File' => 'View Log File',
	   'Last Name' => 'Last Name',
	   'First' => 'First',
	   'Middle' => 'Middle',
	   'Birthdate' => 'Birthdate',
	   'Status' => 'Status',
	   'Reserve' => 'Reserve',
	   'Mother' => 'Mother',
	   'School Days' => 'School Days',
	   'Error' => 'Error',
	   'Date' => 'Date',
	   'Paper Size' => 'Paper Size',
	   'Letter' => 'Letter',
	   'Legal' => 'Legal',
	   'A4' => 'A4',
	   'Continue' => 'Continue',
	   'Records per Page' => 'Records per Page',
	   'Not Defined' => 'Not Defined',
	   'Grade' => 'Grade',
	   'Student' => 'Student',
	   'Not Found' => 'Not Found',
	   'Band' => 'Band',
	   'Font Size' => 'Font Size',
	   'Group' => 'Group',
	   'HTML' => 'HTML',
	   'Homeroom' => 'Homeroom',
	   'PDF' => 'PDF',
	   'Separate with Spaces' => 'Separate with Spaces',
	   'Report Type' => 'Report Type',
	   'Missing' => 'Missing',
	   'Days Open' => 'Days Open',
	   'Total' => 'Total',
	   'Month' => 'Month',
	   'Average' => 'Average',
	   'Division' => 'Division',
	   'Periods per Day' => 'Periods per Day',
	   'Select' => 'Select',
	   'School' => 'School',
	   'CSV' => 'CSV',
	   'Show' => 'Show',
	   'Gender' => 'Gender',
	   'Raw' => 'Raw',
	   'Results' => 'Results',
	   'Percentage' => 'Percentage',
	   'Remote' => 'Remote',
	   'Database' => 'Database',

	   'Check School Marks' => 'Check School Marks',

	   );

my $self = 'checkschoolmarks.pl';

my $oabase = '/opt/openadmin';


use DBI;
use CGI;
use Date::Business;
use Number::Format qw(:all);


my $defmaxrecords = 28; # Maximum records per PDF page.
my $group = 'grade';


# Read config variables
eval require "../admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

=head
eval { require "$globdir/global.conf"; };
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}
=cut

@dbase = sort keys %alldbase; # global records.


my $q = new CGI;
my %arr = $q->Vars;
print $q->header( -charset, $charset );



my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $day = $tim[3];
if (length($month) == 1){ $month = "0".$month;}
if (length($day) == 1){ $day = "0".$day;}
my $currsdate = "$year-$month-$day";
my $currdate = "$month[$month] $day, $year";


# HTML Header
my $title = $lex{'Check School Marks'};
print "$doctype\n<html><head><title>$title</title>
<link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">\n";

#print "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" href=\"/js/calendar-blue.css\" title=\"blue\">
#<script type=\"text/javascript\" src=\"/js/calendar.js\"></script>
#<script type=\"text/javascript\" src=\"/js/lang/calendar-en.js\"></script>
#<script type=\"text/javascript\" src=\"/js/calendar-setup.js\"></script>\n";


print "$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">$lex{Main}</a> ]\n";

print qq{<h1>$title };
if ( $schoolname ) { print " &ndash; $schoolname"; }
print qq{</h1>\n};

if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    checkSchoolMarks(); 
}



#-------------------
sub checkSchoolMarks {
#-------------------

    # foreach my $key ( sort keys %arr ) { print qq{K:$key V:$arr{$key}<br>\n}; }


    # Load Remote database
    if ( not $arr{db} ) {
	print qq{<h3>$lex{Database} $lex{'Not Found'}</h3>\n};
	print qq{</body></html>\n};
	exit;
    }

    my $db = $arr{db};
    my $dsn = "DBI:mysql:database=$db;host=$remotehost";
    my $dbh = DBI->connect($dsn,$remoteuser,$remotepassword);

=head
    # Load Configuration Variables;
    my $sth = $dbh->prepare("select id, datavalue from conf_system where filename = 'admin'");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    while (	my ($id, $datavalue) = $sth->fetchrow ) {
	eval $datavalue;
	if ( $@ ) {
	    print "$lex{Error}: $@<br>\n";
	    die "$lex{Error}: $@\n";
	}
    }

=cut

    # Get Courses in grades 10-12
    my %courses; # datastructure   $courses{subjsec} {description/endterm/exammix}
    my $sth = $dbh->prepare("select subjsec, description, endrptperiod, exammix from subject 
      where grade = 10 or grade = 11 or grade = 12");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    while ( my ($subjsec, $desc, $endterm, $exammix) = $sth->fetchrow ) {
	$courses{$subjsec}{'description'} = $desc;
	$courses{$subjsec}{'endterm'} = $endterm;
	$courses{$subjsec}{'exammix'} = $exammix;
    }


    # now get the final marks for each course for each student;
    my %marks; # datastructure   $marks{$studnum}{$subjsec} = mark.
    my $sth = $dbh->prepare("select a1, studnum from eval 
      where subjcode = ? and term = ? and a1 is not NULL and a1 != ''");

    my $sth1 = $dbh->prepare("select provnum, lastname, firstname from studentall where studnum = ?");
    my %provnum;
    my %names;

    foreach my $subjsec ( sort keys %courses ) {

	my $endterm = $courses{$subjsec}{'endterm'};

	$sth->execute( $subjsec, $endterm );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	while ( my ($mark, $studnum ) = $sth->fetchrow ) {

#	    print "Mark:$mark Studnum:$studnum<br>\n";

	    if ( $mark =~ m/[a-zA-Z]/ ) {
		next; # skip any nonnumeric values
	    }

	    # Filter any %'s.
	    $mark =~ s/\%//g;

	    my ($provnum, $firstname, $lastname);
	    if ( $provnum{$studnum} ) {
		$provnum = $provnum{$studnum};

	    } else { # look it up and add it

		$sth1->execute( $studnum );
		if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
		($provnum,$lastname, $firstname) = $sth1->fetchrow;
		# print qq{<b>$firstname $lastname - $provnum</b><br>\n};

		if ( not $provnum ) { 
		    print "<h3>Missing provincial number for student $firstname $lastname ($studnum)</h3>\n";
		    next;
		} else {
		    $provnum{$studnum} = $provnum;
		    $names{$provnum} = "$firstname $lastname";
		}
	    }

	    $marks{$provnum}{$subjsec} = $mark;
	}
    }


=head
    foreach my $provnum ( sort keys %marks ) {
	foreach my $subjsec ( keys %{ $marks{$provnum} } ) {
	    print qq{<div>$provnum - $subjsec - $marks{$provnum}{$subjsec}</div>\n};
	}
    }
    exit;
=cut


    # Now compare these marks with the final marks given for each course / student
    $arr{db}  =~  m/([a-zA-Z]+)(\d+)/ ;
    my ($dblocal, $year) = ($1, $2);
    # print qq{<h3>Local DB:$dblocal Year:$year</h3>\n};


    my $dsn = "DBI:$dbtype:dbname=$dblocal";
    my $dbh = DBI->connect($dsn,$guser,$gpassword);
    $dbh->{mysql_enable_utf8} = 1;

    # Loop through data structure and compare to SDS marks stored locally in school db.
    my $sth1 = $dbh->prepare("select finalmark from sasked_completedcourses where provnum = ? and courseid = ?");    

    my $first = 1;

    foreach my $provnum ( sort keys %marks ) {
	foreach my $subjsec ( keys %{ $marks{$provnum} } ) {
	    my ($courseid, $section ) = split('-', $subjsec );
	    
	    $sth1->execute( $provnum, $courseid );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    my $finalmark = $sth1->fetchrow;

	    if ( $finalmark != $marks{$provnum}{$subjsec} ) { # no match

		if ( $first ) {
		    print qq{<table cellspacing="0" cellpadding="3" border="1">\n};
		    print qq{<tr><th>Name</th><th>Course</th><th>SDS Mark</th><th>Local Mark</th></tr>\n};
		    $first = 0;
		}

		print qq{<tr><td>$names{$provnum} ($provnum)</td>\n};
		print qq{<td>$courses{$subjsec}{'description'} ($subjsec) $courses{$subjsec}{'exammix'}</td>\n};
		print qq{<td>$finalmark</td><td>$marks{$provnum}{$subjsec}</td></tr>\n};

	    }

	}
    }




} # end of checkstudentmarks




#----------------
sub showStartPage {
#----------------

    # Get remote databases and years
    my $remotedbase = 'information_schema';
    my $dsnr = "DBI:mysql:database=$remotedbase;host=$remotehost";
    my $dbhr = DBI->connect($dsnr,$remoteuser,$remotepassword);
    #my $dbh = DBI->connect($dsn,'tsecremote','ts99ec4');

    my $sth = $dbhr->prepare("select distinct table_schema from TABLES order by table_schema");
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my %remotedb;

    while ( my $db = $sth->fetchrow ) {
#	print qq{DB:$db<br>\n};
	if ( $db eq 'mysql' or $db eq 'information_schema' ) { next; }
	$remotedb{$db} = 1;
    }


    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\" ";
    print "style=\"padding:0.5em;border:1px solid gray;\">\n";

    print qq{<tr><td class="bra">$lex{Select} $lex{Remote} $lex{Database}</td><td></td></tr>\n};
    foreach my $db ( sort keys %remotedb ) { 
	print qq{<tr><td class="la"><input type="radio" name="db" value="$db"> $db</td></tr>\n};
    }

=head
    print "<tr><td class=\"bra\">$lex{'Report Type'}</td>\n";
    print "<td><select name=\"reporttype\"><option value=\"html\">$lex{HTML}</option>\n";
    print "<option value=\"csv\">$lex{CSV}</option></select></td></tr>\n";


    print "<tr><td class=\"bra\">$lex{Show} $lex{Gender} $lex{Results}</td>\n";
    print qq{<td><input type="checkbox" name="showgender" value="1" checked="checked"></td></tr>\n};

    print "<tr><td class=\"bra\">$lex{Show} $lex{Raw} $lex{Results}</td>\n";
    print qq{<td><input type="checkbox" name="showraw" value="1" checked="checked"></td></tr>\n};

    print "<tr><td class=\"bra\">$lex{Show} $lex{Percentage} $lex{Results}</td>\n";
    print qq{<td><input type="checkbox" name="showpercent" value="1" checked="checked"></td></tr>\n};

    print "<tr><td class=\"bra\">$lex{Show} $lex{Division}</td>\n";
    print qq{<td><input type="checkbox" name="showdivision" value="1" checked="checked"></td></tr>\n};


    print "<tr><td class=\"ra\">". $lex{Group}. "</td>\n<td>";
    print "<select name=\"groupname\"><option>$lex{Band}</option>\n";
    print "<option>$lex{Grade}</option><option>$lex{Homeroom}</option>\n";;
    print "</select>\n <input type=\"text\" name=\"groupvalue\" size=\"12\"> ";
    print $lex{'Separate with Spaces'}. "</td></tr>\n";

    # Paper Size
    $defaultpapersize =~ s/paper//; # strip out word paper so lex works; from admin.conf
    my $defpaper = ucfirst( $defaultpapersize );

    print "<tr><td align=\"right\">". $lex{'Paper Size'}. "</td>\n<td><b>";
    print $lex{Legal}. "</b></td></tr>\n";
    print "<select name=\"papersize\">";
    if ( $lex{$defpaper} ) { print "<option>". $lex{$defpaper}. "</option>\n"; }
    my @sizes = qw(Letter A4 Legal);
    foreach my $size ( @sizes ) {
	if ( $size eq $defpaper ) { next; }
	print "<option>$lex{$size}</option>";
    }
    print "</select></td></tr>\n ";

    print "<tr><td align=\"right\">". $lex{'Font Size'}. "</td>\n<td>";
    print "<select name=\"fontsize\"><option>10pt</option><option>11pt</option>\n";
    print "<option>12pt</option></select></td></tr>\n ";

    print "<tr><td class=\"ra\">". $lex{'Records per Page'}. "</td>\n<td>";
    print "<input type=\"text\" name=\"maxrecords\" size=\"4\" value=\"$defmaxrecords\"></td></tr>\n";

=cut

    print qq{<tr><td><input type="submit" value="$lex{Continue}"></td></tr>\n};

    print "</table></form>\n";

=head1
    print "<script type=\"text/javascript\">\n";
    print "Calendar.setup({ \n";
    print "inputField  : \"monthatt_date\", \n";
    print "ifFormat    : \"%Y-%m-%d\", \n";
    print "button      : \"monthatt_trigger\", \n";
    print "singleClick : false, \n";
    print "step : 1 \n";
    print "});</script>\n";

=cut

    print "</body></html>\n";

    exit;

}

