#!/usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('View' => 'View',
	   'Staff' => 'Staff',
	   'Absences' => 'Absences',
	   'Main' => 'Main',
	   'Eoy' => 'Eoy',
	   'No Records Found' => 'No Records Found',
	   'Top' => 'Top',
	   'Error' => 'Error',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Start Date' => 'Start Date',
	   'End Date' => 'End Date',
	   'Check All' => 'Check All',
	   'Select' => 'Select',
	   'Schools' => 'Schools',
	   'Continue' => 'Continue',

	   );


use DBI;
use CGI;
use Cwd;

my $self = 'staffabsViewCentral.pl';
#my $editscript = 'staffabsEdit.pl';
#my $deletescript = 'staffabsDelete.pl';


eval require "../admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


my @time = localtime(time);
my $year = $time[5] + 1900;
my $month = $time[4] + 1;
my $currdate = "$year-$month-$time[3]";


# Print Page Header
my $title = "$lex{View} $lex{Staff} $lex{Absences}";
print qq{$doctype\n<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="/division.css" type="text/css">\n};

if ( not $arr{page} ) { # calendar popup.
    print "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" ";
    print "href=\"/js/calendar-blue.css\" title=\"blue\">\n";
    print "<script type=\"text/javascript\" src=\"/js/calendar.js\"></script>\n";
    print "<script type=\"text/javascript\" src=\"/js/lang/calendar-en.js\"></script>\n";
    print "<script type=\"text/javascript\" src=\"/js/calendar-setup.js\"></script>\n";
}

print qq{</head>\n};

print qq{<body>[ <a href=\"$homepage\">$lex{Main}</a> ]\n};

print qq{<h1>$title</h1>\n};


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    displayAbsent();
}




#----------------
sub showStartPage {
#----------------

    my $checked;
    if ( $arr{checked} ) {
	$checked = qq{checked="checked"};
    }

    print qq{<form action="$self" method="post" style="display:inline;margin:1em;">\n};
    print qq{<input type="hidden" name="checked" value="1">\n};
    print qq{<input type="submit" value="$lex{'Check All'}" style="display:inline;"></form>\n};


    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";


    print "<tr><td class=\"bra\">$lex{Select} $lex{Schools}</td><td></td></tr>\n";
    foreach my $db ( sort keys %alldbase ) { # hash now found in admin.conf
	print "<tr><td></td><td class=\"la\">";
	print qq{<input type="checkbox" name="$db" value="1" $checked>\n};
	print "$alldbase{$db} ($db)</td></tr>\n";
    }

    # Start Date
    print "<tr><td class=\"bra\">$lex{'Start Date'}</td><td class=\"la\"><input type=\"text\" ";
    print "name=\"startdate\" id=\"sdate\" size=\"10\" value=\"$schoolstart\">";
    print "<button type=\"reset\" id=\"start_trigger\">...</button>\n";
    print "</td></tr>\n";


    # End Date
    print "<tr><td class=\"bra\">$lex{'End Date'}</td><td class=\"la\"><input type=\"text\" ";
    print "name=\"enddate\" id=\"edate\" size=\"10\" value=\"$currdate\">";
    print "<button type=\"reset\" id=\"end_trigger\">...</button></td></tr>\n";


    print qq{<tr><td></td><td><input type="submit" value="$lex{Continue}"></td></tr>\n};
    print "</table></form>\n";

    print "<script type=\"text/javascript\">
     Calendar.setup({
        inputField     :    \"sdate\", 
        ifFormat       :    \"%Y-%m-%d\",
        button         :    \"start_trigger\",
        singleClick    :    false,
        step           :    1
    });

    Calendar.setup({
        inputField     :    \"edate\",
        ifFormat       :    \"%Y-%m-%d\",
        button         :    \"end_trigger\",
        singleClick    :    false,
        step           :    1
    });
    </script>\n";

    print "</body></html>\n";

    exit;

} # end of showStartPage


#----------------
sub displayAbsent {
#----------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $startdate = $arr{startdate};
    delete $arr{startdate};
    my $enddate = $arr{enddate};
    delete $arr{enddate};

    print "<h3>Absences from $startdate to $enddate</h3>\n";

    my $dbcount;

    foreach my $db ( sort keys %arr ) { # hash now found in admin.conf

	$dbcount++;

	my ($dsn, $dbh, $schoolname );
	my $database = $db;
	my $dsn = "DBI:$dbtype:dbname=$database";
	my $dbh = DBI->connect($dsn,$user,$password);

	my $schoolname = $alldbase{$db};


	my $sth = $dbh->prepare("show columns from staff_absent");
	$sth->execute;
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	while (my @cols = $sth->fetchrow ) {
	    if ( $cols[0] eq 'id' or $cols[0] eq 'comment' ) { next; }
	    push @fields, $cols[0];
	}


	$sth = $dbh->prepare("select * from staff_absent order by adate desc, lastname, firstname");
	$sth->execute;
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	$rows = $sth->rows;

	print "<h1>$schoolname</h1>\n";

	if ($rows < 1 ) {
	    print qq{<p>$lex{'No Records Found'}</p>\n};
	    next;
	}

	print qq{<table border="1" cellpadding="3" cellspacing="0">\n};

	print "<tr>";
	foreach my $fld (@fields ) {
	    print "<th>$fld</th>\n";
	}
	#print qq{<th colspan="2"></th>};
	print qq{</tr>\n};

	while ( my $ref = $sth->fetchrow_hashref ) {
	    my %r = %$ref;
	    
	    print "<tr>\n";
	    foreach my $field ( @fields ) {
		print "<td>$r{$field}</td>";
	    }

=head
	print qq{<td><form action="$editscript" method="post" target="_blank" };
	print qq{style="display:inline;">\n};
	print qq{<input type="hidden" name="id" value="$r{id}">\n};
	print qq{<input type="submit" value="$lex{Edit}">\n};
	print qq{</form></td></td>};
=cut

    # Delete Button
=head
    print qq{<td><form action="$deletescript" method="post" target="_blank" };
    print qq{style="display:inline;">\n};
    print qq{<input type="hidden" name="id" value="$r{id}">\n};
    print qq{<input type="submit" value=\"$lex{Delete}\">\n};
    print qq{</form></td></td>};
=cut

	    print "</tr>\n";
	}

	print "</table>\n";

    } # end of database loop.


    print qq{<p>[ <a href=\"$homepage\">$lex{Main}</a> |\n};
    #print qq{<a href=\"$eoypage\">$lex{Eoy}</a> ]</p>\n};

    print "</body></html>\n";

    exit;

} # end of displayAbsent

