#!/usr/bin/perl
#  Copyright 2001-2016 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


my %lex = ('Staff' => 'Staff',
	   'Main' => 'Main',
	   'Eoy' => 'Eoy',
	   'Staff Member' => 'Staff Member',
	   'User Id' => 'User Id',
	   'Home' => 'Home',
	   'Room' => 'Room',
	   'Course' => 'Course',
	   'Error' => 'Error',
	   'Grade' => 'Grade',
	   'Position' => 'Position',
	   'Count' => 'Count',
	   'Red' => 'Red',
	   'View' => 'View',

	   'Select' => 'Select',
	   'Schools' => 'Schools',
	   'Continue' => 'Continue',

	   );


use DBI;
use CGI;

eval require "admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


# Print Page Header
my $title = "$lex{View} $lex{Staff}";

print "$doctype\n<html><head><title>$title</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head>\n";

print qq{<body style="padding:1.5em;">[ <a href="$homepage">$lex{Main}</a> ]\n};
print qq{<h1>$title</h1>\n};

if ( not $arr{page} ) {
    showStartPage();

} else {
    delete $arr{page};
    showStaff();
}


#------------
sub showStaff {
#------------


    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n" }; 
    foreach my $dbase ( keys %arr ) {

	my $dsn = "DBI:$dbtype:dbname=$dbase";
	my $dbh = DBI->connect($dsn,$guser,$gpassword);
	$dbh->{mysql_enable_utf8} = 1;

	print qq{<h2>$alldbase{$dbase}</h2>\n};

	# Get Staff Info
	$sth = $dbh->prepare("select id, lastname, firstname, userid from staff order by lastname, firstname");
	$sth->execute;
	if (DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

	print qq{<table cellpadding="3" border="1" cellspacing="0">\n};
	print qq{<tr><th>$lex{'Staff Member'}</th><th>$lex{Position}</th>};
	print qq{<th>$lex{Home}<br>$lex{Room}</th><th>$lex{Home}<br>$lex{Grade}</th>\n};
	print qq{<th>$lex{Course}<br><span style="font-size:80%;">Hover=Details</span></th></tr>\n};


	my $sth1 = $dbh->prepare("select subjsec, description, smdesc, startrptperiod, endrptperiod from subject
         where teacher = ?");
    
	my $sth2 = $dbh->prepare("select field_value from staff_multi
         where field_name = ? and userid = ?");

	while ( my ( $id, $lastname, $firstname, $userid ) = $sth->fetchrow) {

	    # Get subject info and put into hash
	    my %courses;
	    $sth1->execute( $userid );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    while ( my $ref = $sth1->fetchrow_hashref ) {
		my $subjsec = $ref->{subjsec};
		$courses{$subjsec} = $ref;
	    }

	    # Load Homerooms, if any
	    my @homerooms;
	    $sth2->execute( 'homeroom', $userid );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    while ( $hr = $sth2->fetchrow ) {
		push @homerooms, $hr;
	    }

	    # Load Grades
	    my @grades;
	    $sth2->execute( 'grade', $userid );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    while ( $gr = $sth2->fetchrow ) {
		push @grades, $gr;
	    }

	    # Load Positions (Jobs)
	    $sth2->execute( 'position', $userid );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    my $positions;
	    my $first = 1;
	    while ( $pos = $sth2->fetchrow ) {
		if ( not $first ) { $positions .= ', '; } else { $first = 0; }
		$positions .= $pos;
	    }


	    print "<tr><td><b>$lastname</b>, $firstname</td><td>$positions</td>\n";

	    print qq{<td class="cn">};
	    foreach my $hr ( sort {$a <=> $b}  @homerooms ) { print "$hr "; }
	    print qq{</td><td class="cn">};
	    foreach my $gr ( sort {$a <=> $b}  @grades ) { print "$gr "; }
	    print q{</td>};
	    
	    print qq{<td class="la">\n};
	    foreach my $subjsec ( sort {$a <=> $b} keys %courses ) { 
		my $ref = $courses{$subjsec};
		my %r = %$ref;
		print qq{<span title="$r{description} T$r{startrptperiod}-T$r{endrptperiod}">};
		print qq{$r{smdesc} ($subjsec)</span><br>\n};
	    }

	    print qq{</td>\n};
	    print qq{</tr>\n};

	}

	print qq{</table>\n};

    }

    print qq{</body></html>\n};

} # end of showStaff



#----------------
sub showStartPage {
#----------------


    # Check All Schools
    print qq{<form action="$self" method="post"> \n};
    print qq{<input type="hidden" name="checked" value="1">\n};
    print qq{<input type="submit" value="Select All Schools">\n};
    print qq{</form>\n};

    
    # Main Form
    print qq{<form action="$self" method="post"> \n};
    print qq{<input type="hidden" name="page" value="1">\n};
    print qq{<table cellpadding="3" cellspacing="0" border="0">\n};

    
    my $checked;
    if ( $arr{checked} ) { $checked = 'checked'; }
    
    # Schools
    print qq{<tr><td class="bla" style="vertical-align:top;">$lex{Select} $lex{Schools}</td></tr>\n};
    print qq{<td class="la">};;

    foreach my $key ( sort keys %alldbase ) { 
	print qq{<input type="checkbox" name="$key" value="1" $checked> $alldbase{$key}<br>\n}; 
    }
    print "</td></tr>\n";

    # Continue to next page
    print qq{<tr><td><input type="submit" value="$lex{Continue}"></td></tr>\n};
    print "</table></form>\n";

    print "</body></html>\n";

    exit;

} # end of showStartPage
