#!/usr/bin/perl
#  Copyright 2001-2016 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Error' => 'Error',
	   'Evaluation Master Entry' => 'Evaluation Master Entry',
	   'Category' => 'Category',
	   'School' => 'School',	   
	   'Main' => 'Main',
	   'Objective' => 'Objective',
	   'Objectives' => 'Objectives',
	   'Add' => 'Add',
	   'Please select the student and objectives' => 
	     'Please select the student and objectives',
	   'Select Student' => 'Select Student',
	   'Save Objectives' => 'Save Objectives',
	   'Strategies, Resources and Activities' => 'Strategies, Resources and Activities',
	   'Responsible Person(s)' => 'Responsible Person(s)',
	   'Long Term Objective' => 'Long Term Objective',
	   'Note' => 'Note',
	   'You are limited to 32 objectives per &quot;subject&quot;' =>
	     'You are limited to 32 objectives per &quot;subject&quot;',
	   'Mastery' => 'Mastery',
	   'Term' => 'Term',	   
	   'Select' => 'Select',
	   'Save Objectives' => 'Save Objectives',
	   'Entry Error: No student selected or &gt; 32 objectives selected.' =>
	     'Entry Error: No student selected or &gt; 32 objectives selected.',
	   'Add More' => 'Add More',
	   'Record Stored' => 'Record Stored',
	   'Record Updated' => 'Record Update',

	   'Mastery' => 'Mastery',
	   'Please Log In' => 'Please Log In',
	   'Strategy' => 'Strategy',
	   'Target Skill' => 'Target Skill',
	   'Current Performance Level' => 'Current Performance Level',
	   'Evaluation Method' => 'Evaluation Method',

	   );

my $self = 'evalmstadd.pl';

use DBI;
use CGI;
use CGI::Session;

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = CGI->new;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    
    print $q->header( -charset, $charset );
    print qq{$doctype\n<html><head>\n};
    print qq{<link rel="stylesheet" href="$iepcss" type="text/css"></head><body>\n};
    print qq{[ <a href="$iephome">$lex{Main}</a> ]\n};
    print qq{<form action="login.pl" method="post" style="display:inline;">\n};
    print qq{<input type="hidden" name="userid" value="$userid">\n};
    print qq{<input type="hidden" name="script" value="$self">\n};
    print qq{<input type="submit" value="$lex{'Please Log In'}">\n};
    print qq{</form></body></html>\n};
    exit;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "where school = $sdb ";


# Print Page Heading
my $title = "Add Student Objectives";
print qq{$doctype\n<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="$iepcss" type="text/css"></head>\n};
print qq{<body>[ <a href="$iephome">$lex{Main}</a> ] $firstname $lastname\n};

print qq{<form action="objectiveadd.pl" method="post" style="display:inline;">\n};
print qq{<input type="submit" value="Add New Objectives">\n};
print qq{</form>\n};

print qq{<h1>$title</h1>\n};

if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    selectObjectives();

} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    writeRecord();
}



#----------------
sub showStartPage {
#----------------

    # Start the Form
    print qq{<form action="$self" method="post" style="display:inline;">\n};
    print qq{<input type="hidden" name="page" value="1">\n};
    print qq{<input type="submit" value="Continue">\n};
    
    # Read in all special students from this school and put in array
    my $sth = $dbh->prepare("select lastname, firstname, studnum from special 
     $select order by lastname, firstname");  #$select set above for the school
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    my $first = 1;
    while ( my ( $lastname, $firstname, $studnum ) = $sth->fetchrow ) {
	if ( $first ) {
	    print qq{<table cellpadding="3" cellspacing="0" border="1">\n};
	    print qq{<tr><th>Select Student</th></tr>\n};
	    print qq{<tr><td><select name="studnum"><option></option>\n};
	    $first = 0;
	}
	print qq{<option value="$studnum">$lastname, $firstname ($studnum)</option>\n};
    }

    if ( $first ) {
	print qq{<h3>No Students Found</h3>\n};
	print qq{</body></html>\n};
	exit;
    } else {
	print qq{</select></td></table><p></p>\n};
    }
    # Done students.

   
    my $sth = $dbh->prepare("select distinct catnum, category, count(idnum) 
     from subject group by category order by category");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    print qq{<table cellpadding="3" cellspacing="0" border="1">\n};
    print qq{<tr><th>Select $lex{Category}</th></tr>\n};

    while ( my ($catnum,$category, $count) = $sth->fetchrow ) {
	print qq{<tr><td class="la">};
	print qq{<input type="radio" name="catnum" value="$catnum">\n};
	print qq{<b>$category</b>};
	print qq{ $count $lex{Objectives} ($catnum)</td></tr>\n};
    }

    print qq{</table>\n};

    print qq{<input type="submit" value="Continue">\n};
    print qq{</form></body></html>\n};

    exit;

} # End of showStartPage


#-------------------
sub selectObjectives {
#-------------------

    my $catnum = $arr{catnum};
    my $studnum = $arr{studnum};

    # Read in the student value, and check.
    my $sth = $dbh->prepare("select lastname, firstname from special where school = $sdb and studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth->fetchrow;
    if ( not $lastname ) {
	print qq{<h3>Student Not Found</h3>\n};
	print qq{</body></html>\n};
	exit;
    }

    
    # Now find subject name for entered value
    $sth = $dbh->prepare("select category from subject where catnum = ?");
    $sth->execute( $catnum );
    if ($DBI::errstr) { print $DBI::errstr; die;}    
    my $category = $sth->fetchrow;

    # Load student eval record if it exists for this catnum;
    $sth = $dbh->prepare("select * from evalmst where studnum = ? and subnum = ?");
    $sth->execute( $studnum, $catnum );
    if ($DBI::errstr) { print $DBI::errstr; die;}    
    my $ref = $sth->fetchrow_hashref;
    my %em = %$ref;
    my $emid = $em{id};
#    print "EMID:$emid<br>\n";

    
    # Load the objectives for this catnum;
    my %objectives;
    $sth = $dbh->prepare("select idnum, description from subject where catnum = ? order by idnum");
    $sth->execute( $catnum );
    if ($DBI::errstr) { print $DBI::errstr; die;}    
    while ( my ($idnum, $desc ) = $sth->fetchrow ) {
	$objectives{$idnum} = "$idnum. $desc";
    }

    
    # Check for objectives to skip, since already used.
    foreach my $idx ( 1..32 ) {
	my $key = 'obj'. $idx;
	if ( $em{$key} ) { # we have an objective. Set it to skip.
	    my $val = $em{$key};
	    # Get the numeric value for the objective
	    $val =~ /^\(([0-9-]+)\)/;
	    my ($dud, $idnum ) = split('-', $1); # This is the 4200-5 type of value
#	    print "SKIP:$idnum<br>\n";
	    delete $objectives{$idnum};
	}
    }

#    print "Objectives:", %objectives, "<br>\n";
    
    
    # Form Start
    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="catnum" value="$catnum">\n};
    print qq{<input type="hidden" name="page" value="2">\n};
    print qq{<input type="hidden" name="emid" value="$emid">\n};
    print qq{<input type="hidden" name="studnum" value="$studnum">\n};
    

    # Section subject specific stuff.
    # Now print objectives
    print qq{<h2>$category $lex{Objectives} - $firstname $lastname</h2>\n};
    print qq{<div><b>$lex{Note}:</b> \n};
    print qq{You are limited to 32 objectives per Objective Category<br>\n};
    print qq{<input type="submit" value="$lex{'Save Objectives'}"></div>\n};

    print qq{<table cellpadding="10" cellspacing="0" border="1">\n};    

    print qq{<tr><td colspan="4"><b>$lex{'Target Skill'}</b><br>\n};
    print qq{<textarea name="targetskill" rows="2" cols="100">$em{targetskill}</textarea></td></tr>\n};

    print qq{<tr><td colspan="4"><b>$lex{'Current Performance Level'}</b><br>\n};
    print qq{<textarea name="currperform" rows="2" cols="100">$em{currperform}</textarea></td></tr>\n};

    print qq{<tr><td colspan="4"><b>$lex{'Strategies, Resources and Activities'}</b><br>\n};
    print qq{<textarea name="strategy" rows="2" cols="100">$em{strategy}</textarea></td></tr>\n};

    print qq{<tr><td colspan="4" class="bla">$lex{'Responsible Person(s)'}<br>\n};
    print qq{<textarea name="responsible" rows="2" cols="100">$em{responsible}</textarea></td></tr>\n};

    print qq{<tr><td colspan="4"><b>$lex{'Evaluation Method'}</b><br>\n};
    print qq{<textarea name="evalmethod" rows="2" cols="100">$em{evalmethod}</textarea></td></tr>\n};

    print qq{<tr><td colspan="4" class="bla">$lex{'Long Term Objective'}<br>\n};
    print qq{<textarea name="longtermobjective" rows="2" cols="100">$em{longtermobjective}</textarea></td></tr>\n};

    
    if ( not $emid ) {  # no current record for this category.
   
	print "<tr><th>$lex{Select} $lex{Objective}</th><th>$lex{Mastery}</th><th>$lex{Term}</th></tr>\n";

	foreach  my $idnum ( sort keys %objectives ) {
	    my $description = $objectives{$idnum};

	    print qq{<tr><td class="la"><input type="checkbox" name="$idnum" value="1"> <i>$idnum</i>. $description</td>\n};

	    # Mastery Level
	    print qq{<td><select name="M-$idnum"><option></option>\n};
	    foreach my $mst ( @g_mastery ) {
		print qq{<option>$mst</option>};
	    }
	    print qq{</select></td>\n};

	    # Starting Term for implementation
	    print qq{<td><select name="T-$idnum"><option></option>\n};
	    foreach my $trm ( @g_termst ) {
		print qq{<option>$trm</option>};
	    }
	    print qq{</select></td></tr>\n};


	}
	
    } else { # a current record exists. Show the objectives already added and then setup for adding more.

#	print qq{<table cellpadding="10" cellspacing="0" border="1">\n};
	print qq{<tr><th>Objectives</th></tr>\n};
	for my $idx ( 1..32 ) {
	    my $key = 'obj'. $idx;

	    if ( $em{$key} ) {
		print qq{<tr><td>$em{$key}</td></tr>\n};
		
	    } else {
		print qq{<tr><td><select name="$key"><option></option>\n};
		foreach my $idnum ( sort keys %objectives ) {
		    print qq{<option value="$idnum">$objectives{$idnum}</option>\n};
		}
		print qq{</select></td></tr>\n};
	    }

	}
    }
	
    print qq{</table><input type="submit" value="$lex{'Save Objectives'}">\n};
    print qq{</form></body></html>\n};

    exit;

} # End of addObjectives



#---------------
sub writeRecord {
#---------------

#    foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
   
    # subject number.
    my $catnum = $arr{catnum};
    delete $arr{catnum};

    # emid, Eval Master record ID
    my $emid = $arr{emid};
    delete $arr{emid};

    # studnum
    my $studnum = $arr{studnum};
    delete $arr{studnum};

    
    # Load the objectives for this catnum;
    my %objectives;
    $sth = $dbh->prepare("select idnum, description from subject where catnum = ? order by idnum");
    $sth->execute( $catnum );
    if ($DBI::errstr) { print $DBI::errstr; die;}    
    while ( my ($idnum, $desc ) = $sth->fetchrow ) {
	$objectives{$idnum} = $desc;
    }

   
#    foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

#    print "<h3>No Records saved. Under Development.</h3>\n";
#    exit;


    if ( $emid ) { # we have a record to update

	foreach my $key ( keys %arr ) {
	    if ( $key =~ m/^obj.+/ ) { # we have an objNN type, put in description
		if ( $arr{$key} ) { # then add the description
		    my $idnum = $arr{$key};
		    my $desc = $objectives{ $idnum };
		    my $prefix = "$catnum-$idnum";
		    my $val = qq{($prefix) $desc};
		    $arr{$key} = $val;
		}
	    }
	    
	    my $sth = $dbh->prepare("update evalmst set $key = ? where id = $emid");
	    $sth->execute( $arr{$key} );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	}

	print qq{<h3>$lex{'Record Updated'}.</h3>\n};


    } else { # add a new record.

	my @objarray;
	foreach my $key ( keys %arr ) {
	    if ( $arr{$key} == 1 ) { # We have a selection for subject master
		push @objarray, $key; 
	    }
	}
	@objarray = sort { $a <=> $b} @objarray; # sort numerically.


	if ( $#objarray > 31 or not $studnum ) { # We have entry errors
	    print "<h3>";
	    print $lex{'Entry Error: No student selected or &gt; 32 objectives selected.'};
	    print "</h3>\n";
	    exit;
	}

    
	# get objective description from the subject table
	my $tmpcat = $dbh->quote( $catnum );
	my %rec; # hash to hold values to insert into evalmst table.
	$sth = $dbh->prepare("select description from subject where catnum = $tmpcat and idnum = ?");
	my $objcount = 1; # used to create 'obj1', 'obj2' keys
	foreach my $objective ( @objarray ) {  # $objective is an id number in subject.
	    $sth->execute( $objective );
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	    my $desc = $sth->fetchrow;

	    my $mastery = $arr{'M-'.$objective};
	    if ( $mastery ){ $mastery = $lex{Mastery}. q{:}. $mastery; }
	    my $term = $arr{'T-'.$objective};

	    my $value = $dbh->quote("($catnum-$objective) $desc $mastery $term");
	    my $key = 'obj'. $objcount;
	    $rec{$key} = $value;

	    $objcount++;

	}

	# put in rest of record values
	$rec{targetskill} = $dbh->quote( $arr{targetskill} );
	$rec{currperform} = $dbh->quote( $arr{currperform} );
	$rec{evalmethod} = $dbh->quote( $arr{evalmethod} );
	$rec{strategy} = $dbh->quote( $arr{strategy} );

	$rec{responsible} = $dbh->quote( $arr{responsible} );
	$rec{longtermobjective} = $dbh->quote( $arr{longtermobjective} );
	$rec{impactarea} = $dbh->quote( $arr{impactarea} );
	$rec{studnum} = $dbh->quote( $studnum );
	$rec{subnum} = $dbh->quote( $catnum );

	my @keys = keys %rec;
	my $keys = join(',', @keys);
	my $values = join(',', ( values %rec ));

	$sth = $dbh->prepare("insert into evalmst ( $keys ) values ( $values )");
	$sth->execute;

	if (not $DBI::errstr ) {
	    print qq{<h3>$lex{'Record Stored'}.</h3>\n};

	} else {
	    print qq{<h3>$lex{Error}:$DBI::errstr<br>\n};
	    print qq{Contact Les Richardson</h3>\n};
	}

    } # end of Insert New Record
	
    
    print qq{<p>[ <a href="$iephome">$lex{Main}</a> |\n};
    print qq{<a href="$self">$lex{'Add More'}</a> ]</p>\n};
    print qq{</body></html>\n};

    exit;


} # end of writeRecords
