#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Used to add an objective to a subject category.

my %lex = ('Main' => 'Main',
	   'Add' => 'Add',
	   'Objectives' => 'Objectives',
	   'Select Category' => 'Select Category',
	   'New Category' => 'New Category',
	   'Or' => 'Or',
	   'Continue' => 'Continue',
	   'Confirm' => 'Confirm',
	   'Category' => 'Category',
	   'Only 1 Category can be entered' => 'Only 1 Category can be entered',
	   'Either existing or new one' => 'Either existing or new one',
	   'Problem with missing value for new category' => 
	     'Problem with missing value for new category',
	   'Add More' => 'Add More',
	   'Objective' => 'Objective',
	   'Stored' => 'Stored',

	   );

my $self = 'objectiveadd.pl';

use DBI;
use CGI;
use CGI::Session;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}
eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


my $q = new CGI;
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;


# Print Page Header
my $title = "$lex{Add} $lex{Objectives}";
print qq{$doctype\n<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="$iepcss" type="text/css">\n};
print qq{</head><body>\n};
print qq{[ <a href="$iephome">$lex{Main}</a> ]\n};
print qq{<h1>$title</h1>\n};


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    confirmObjectives();

} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    writeRecords();
}


#----------------
sub showStartPage {
#----------------

    # Read in all subject categories and put in array
    my %cat;
    $sth = $dbh->prepare("select distinct category,catnum from subject order by category");
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    while ( my ($category,$catnum) = $sth->fetchrow ){
	$cat{$category} = $catnum;
    }


    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="1">\n};

    print qq{<p><input type="submit" value="$lex{Continue}"></p>\n};
    print qq{<table cellpadding="3" cellspacing="0" border="1">\n};

    print qq{<tr style="background-color:#DDD;"><td class="ra">$lex{'Select Category'}</td>\n};
    print qq{<td><select name="category"><option></option>\n};

    foreach my $key ( sort keys %cat ){
	print qq{<option value="$cat{$key}">$key</option>\n};
    }
    print qq{</select></td></tr>\n};

    print qq{<tr style="background-color:#DDD;"><td class="ra"><b>$lex{Or}</b> $lex{'New Category'}</td>\n};
    print qq{<td><input type="text" name="newcategory" size="30" maxlength="30"></td></tr>\n};
    

    for my $idx (1..10){
	$objname = "obj".$idx;
	print qq{<tr><td class="ra">$lex{Objective} $idx</td>\n};
	print qq{<td><input type="text" name="$objname" size="65"></td></tr>\n};
    }

    print qq{</table><p></p><input type="submit" value="$lex{Continue}">\n};
    print qq{</form></body></html>\n};

    exit;

} # end of showStartPage




#--------------------
sub confirmObjectives {
#--------------------

    use Math::Round qw(nhimult);


    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $catnum = $arr{category};
    my $category;

    if ( $arr{newcategory} ) {
	$category = $arr{newcategory};

	# look for next available number
	$sth = $dbh->prepare("select max(distinct catnum) from subject");
	$sth->execute;
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	$maxnum = $sth->fetchrow;
	$catnum = nhimult(10, $maxnum);
    }

    # print "Maxnum:$maxnum CATNUM:$catnum  CATEGORY:$category<br>\n";

    print qq{<h3>$lex{Category}: $category ($catnum)</h3>\n};

    my @objectives;
    for my $idx ( 1..10 ) {
	my $key = 'obj'. $idx;
	if ( $arr{$key} ) {
	    print qq{<p>$lex{Objective}: $arr{$key}</p>\n};
	    push @objectives, $arr{$key};
	}
    }


    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="2">\n};
    print qq{<input type="hidden" name="category" value="$category">\n};
    print qq{<input type="hidden" name="catnum" value="$catnum">\n};


    my $count = 1;
    foreach my $obj ( @objectives ) {
	print qq{<input type="hidden" name="obj$count" value="$obj">\n};
	$count++;
    }

    print qq{<input type="submit" value="$lex{Confirm} $lex{Objectives}"></form>\n};
    print qq{</body></html>\n};

    exit;

} # end of Confirm Objectives



#--------------
sub writeRecords {
#--------------

    foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }


    my $catnum = $arr{catnum};
    delete $arr{catnum};
    my $category = $arr{category};
    delete $arr{category};

    my $sth = $dbh->prepare("insert into subject (catnum, category, idnum, description, author, cdate )
      values ( ?, ?, ?, ?, ?, now() )");

    # Check for the starting number for this category of objectives
    my $sth1 = $dbh->prepare("select max(distinct idnum) from subject where catnum = ?");
    $sth1->execute( $catnum );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $startid = $sth1->fetchrow;
    if ( not $startid ) { $startid = 1; }

    for my $i (1..10) {
	$key = "obj".$i;
	if ( $arr{$key} ) {
	    print "$catnum - $category - $startid - $arr{$key} - $userid<br>\n";
	    $sth->execute( $catnum, $category, $startid, $arr{$key}, $userid );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    $startid++;
	} # end of if objective exists.
    }


    print qq{<h3>$lex{Objectives} $lex{Stored}</h3>\n};
    print qq{[ <a href="$self">$lex{'Add More'} $lex{Objectives}</a> ]\n};
    print qq{</body></html>\n};

    exit;

}
