#! /usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


my %lex = ('Reports' => 'Progress Reports',
	   'Main' => 'Main',
	   'Error' => 'Error',
	   'View/Download/Print' => 'View/Download/Print',
	   'Release of Confidential Information' => 'Release of Confidential Information',
	   'View Log File' => 'View Log File',

	   'Parent/Guardian Signature' => 'Parent/Guardian Signature',
	   'Principal Signature' => 'Principal Signature',
	   'School' => 'School',
	   'Report' => 'Report',
	   'Please Log In' => 'Please Log In',

	   'First Name' => 'First Name',
	   'Last Name' => 'Last Name',
	   'Release to' => 'Release to',
	   'Other' => 'Other',
	   'Continue' => 'Continue',
	   'Date' => 'Date',
	   'First Nation' => 'First Nation',
	   'Client Signature' => 'Client Signature',

	   );

my $self = 'rptconfrelease.pl';

my %releaseorgs = ('minofjustice' => 'Ministry of Justice, Corrections, and Policing; Young Offenders Program',
		   'mentalhealth' => 'Mental Health Agency/Professional',
		   'physician', 'Physician or Medical Facility',
		   'communityagency' => 'Community Agency'
    );


use DBI;
use CGI;
use CGI::Session;


my $q = new CGI;
my %arr = $q->Vars;


eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


eval require "liblatex.pl";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

-# required to get school name from dbase.
eval require "$globdir/global.conf";
if ( $@ ) {
    print $q->header; 
    print $lex{Error}. " global.conf: $@<br>\n";
    die $lex{Error}. " global.conf: $@\n";
}



my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;


if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">$lex{Main}</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;


# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "and school = $sdb ";


open( TERM, "term") || die "Can't find the term number: $!";
$term = <TERM>;

my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
    $yday, $iddst) = localtime(time);
$mon++; $wday++;
$year = $year + 1900;
#my $currdate = "$dow[$wday], $month[$mon] $mday, $year";
$currdate = "$year-$mon-$mday";


# Print Heading.
my $title = "Release of Confidential Information";
print "$doctype\n<html><head><title>$title</title>
<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">\n";

if ( not $arr{page} ) {
    print "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" ";
    print "href=\"/js/calendar-blue.css\" title=\"blue\">\n";
    print "<script type=\"text/javascript\" src=\"/js/calendar.js\"></script>\n";
    print "<script type=\"text/javascript\" src=\"/js/lang/calendar-en.js\"></script>\n";
    print "<script type=\"text/javascript\" src=\"/js/calendar-setup.js\"></script>\n";
}

print qq{</head><body>\n};
print qq{[ <a href="$iephome">$lex{Main}</a> ]\n};
print qq{<h1>$title</h1>\n};


if ( not $arr{page} ) {
    showStartPage();

} else {
    delete $arr{page};
    showReport();
}



#--------------
sub showReport {
#--------------

    # foreach my $key ( sort keys %arr ) { print qq{K:$key V:$arr{$key}<br>\n}; }


    my %r = %arr;
    delete $arr{date};
    delete $arr{firstname};
    delete $arr{lastname};
    delete $arr{firstnation};
    delete $arr{other};

    # join all arr hash into one field.
    my @releaseto;
    foreach my $key ( keys %arr ) {
	my $val = $releaseorgs{$key};
	push @releaseto, $val;
    }
    if ( $r{other} ) { push @releaseto, $r{other}; }
    
    my $releaseto = join('::', @releaseto);


    # Insert the record
    my $sth = $dbh->prepare("insert into confrelease (firstname, lastname, firstnation, rdate, releaseto, tauthor) 
      values (?,?,?,?,?,?)");
    $sth->execute( $r{firstname}, $r{lastname}, $r{firstnation}, $r{date}, $releaseto, $userid );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


    my $shortname = "confrelease$$";
    my $filename = "$shortname.tex";

    open(TEX,">$filename") || die "Can't open tex file";

    my $papersize;
    if ( $defaultpapersize ) {
	$papersize = $defaultpapersize;
    } else {
	$papersize = 'letterpaper';
    }


    # Preamble and Head of Document
    print TEX <<"EOS1";  
\\documentclass[12pt,$papersize,oneside]{article}
\\usepackage{array,graphicx,multicol,colortbl,inputenc}
\\inputencoding{latin1}
\\renewcommand{\\familydefault}{\\sfdefault}

\\setlength{\\hoffset}{-6mm}
\\setlength{\\voffset}{-28mm}
%\\setlength{\\headsep}{10pt}
%\\setlength{\\headheight}{14pt}
\\setlength{\\topmargin}{0mm}
\\setlength{\\textwidth}{160mm}
\\setlength{\\textheight}{$g_letterpaper_textheight}
\\setlength{\\parindent}{0pt}
\\setlength{\\evensidemargin}{0in}
\\setlength{\\oddsidemargin}{0in}
%\\setlength{\\extrarowheight}{4pt}
\\pagestyle{headings}

\\begin{document}
EOS1

    my $logowidth = '25mm';
    my $logofile = 'tseclogo.jpg';
    my $addresswidth = '100mm';
    my $name = 'Treaty Six Education Council';

    # Print the heading section for each new report card
    print TEX "\\thispagestyle{empty}\n\\begin{center}\n\n";

    print TEX "{\\Large\\bf $orgname}\n\n";

    print TEX "\\includegraphics[width=$logowidth]{";
    print TEX "$logofile} \n";

    # print TEX "\\parbox[b]{$addresswidth}{"; # start parbox

    print TEX "\\begin{tabular}[b]{ll}\n";


    print TEX "\\bf Mailing Address & \\bf Office Address\\\\ \n";
    print TEX "$mailaddress1 &  $officeaddress1\\\\\n";
    print TEX "$mailaddress2 &  $officeaddress2\\\\\n";
    print TEX "$mailaddress3 &  $officeaddress3\\\\\n";
    print TEX "{\\bf Phone} $officephone &{\\bf Fax} $officefax\\\\\n";
    print TEX "{\\bf Website} $website & \\\\\n";
    print TEX "\\end{tabular}\n";

    # print TEX "}\n"; # end of parbox;

    print TEX "\\includegraphics[width=$logowidth]{";
    print TEX "$logofile}\\quad \n\n";

    print TEX "\\hrulefill \n\\smallskip\n";

    ## End of Letterhead Section.

    print TEX "\\vspace{5mm}\n\n";


    print TEX "{\\LARGE Release of Confidential Information}\\bigskip\n\n";

    print TEX "\\begin{raggedright}\n";

    print TEX "I, {\\bf $r{firstname} $r{lastname}}, of the 
    {\\bf $r{firstnation} First Nation} in Saskatchewan do hereby consent and authorize
    Treaty Six Education Council, fomerly known as Battleford's Agency
    Tribal Chiefs, to release any information pertaining to me to the
    agencies/persons indicated below:\n";


    my $first = 1;
    foreach my $key ( sort keys %arr ) {
	if ( $first ) {
	    print TEX qq{\\begin{itemize}\n};
	    $first = 0;
	}
	print TEX qq{\\item $releaseorgs{$key}\n};
    }

    if ( $r{other} ) {
	print TEX qq{\\item $r{other}\n};
    }

    if ( not $first ) {
	print TEX qq{\\end{itemize}\n};
    }


    print TEX "I understand that I may revoke this consent at any time by notifying the facility ";
    print TEX "in writing, except to the extent that action has been taken in reliance on my consent. ";
    print TEX "A photocopy of this authorization is to be considered as valid as the original document.\n";

    print TEX "\\vspace{10mm}\n\n";

    print TEX "\\end{raggedright}\n";

     # Client Signature lines.
    print TEX "\\underline{\\hspace{2.5in}} \\hfill \\underline{\\hspace{2.5in}}\n\n";
    print TEX "{\\small $lex{'Client Signature'}\\hfill $lex{Date} }\n\n\\bigskip";

    # Parent
    print TEX "\\underline{\\hspace{2.5in}} \\hfill \\underline{\\hspace{2.5in}}\n\n";
    print TEX "{\\small Parent/Legal Guardian Signature (if required)\\hfill $lex{Date} }\n\n\\bigskip";

    # Witness
    print TEX "\\underline{\\hspace{2.5in}} \\hfill \\underline{\\hspace{2.5in}}\n\n";
    print TEX "{\\small Witness Signature\\hfill $lex{Date} }\n\n";



    # Print ending of report
    print TEX "\\end{center}\n";
    print TEX "\\end{document}\n";
    close TEX;

    print "<h2><a href=\"$webdownloaddir/$shortname.pdf\">\n";
    print "$lex{'View/Download/Print'} $lex{'Release of Confidential Information'} </a></h2>\n";

    print "<p>[ <a href=\"$iephome\">$lex{Main}</a> | \n";
    print "<a href=\"$webdownloaddir/pdflog$$.txt\">$lex{'View Log File'}</a> ]</p>\n";

    system("$pdflatex $filename > pdflog$$.txt");
    system("mv $shortname.pdf $downloaddir");
    system("mv pdflog$$.txt $downloaddir");
    system("rm -f $shortname.*");

    print "</body></html>\n";


} # end of showReport




#----------------
sub showStartPage {
#----------------

    print qq{<p></p><form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="1">\n};


    print qq{<table border="1" cellpadding="3" cellspacing="0">\n};

    print qq{<tr><td class="ra">$lex{'First Name'}</td>};
    print qq{<td class="la"><input type="text" size="30" name="firstname"></tr>\n};

    print qq{<tr><td class="ra">$lex{'Last Name'}</td>};
    print qq{<td class="la"><input type="text" size="30" name="lastname"></tr>\n};

    print qq{<tr><td class="ra">$lex{Date}</td>\n};
    print qq{<td class="la"><input type="text" name="date" id="date" size="10" value="$currdate">\n};
    print qq{<button type="reset" id="start_trigger">...</button></td></tr>\n};

    print qq{<tr><td class="ra">$lex{'First Nation'}</td>};
    print qq{<td class="la"><input type="text" size="30" name="firstnation"></tr>\n};


    print qq{<tr><td class="ra">$lex{'Release to'}</td><td class="la">};

    foreach my $key ( keys %releaseorgs ) {

	my $org = $releaseorgs{$key};

	print qq{<input type="checkbox" name="$key" value="1"> $org<br>\n};
    }

    print qq{$lex{Other} <input type="text" name="other" size="30"></td></tr>\n};


    print qq{<tr><td class="cn" colspan="2"><input type="submit" value="$lex{Continue}"></td></tr>\n};

    print qq{</table></form>\n};

    print qq{<script type="text/javascript">
     Calendar.setup({
        inputField     :    "date", 
        ifFormat       :    "%Y-%m-%d",
        button         :    "start_trigger",
        singleClick    :    false,
        step           :    1
    });
    </script>\n};

    print "</body></html>\n";

    exit;

} # end of showStartPage


