#! /usr/bin/perl
#  Copyright 2001-2011 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# File Maker Pro format Rubric Generator

my $templatepath = '../template/';

my %lex = ('Main' => 'Main',
	   'Rubric' => 'Rubric',
	   'PPP' => 'PPP',
	   'Student' => 'Student',
	   'Sask Ed' => 'Sask Ed',
	   'View/Download' => 'View/Download',
	   'View Log File' => 'View Log File',
	   'Cannot open' => 'Cannot open',
	   'Error' => 'Error',
	   'Sort by' => 'Sort by',
	   'Continue' => 'Continue',
	   'Font Size' => 'Font Size',
	   'Name' => 'Name',
	   'Checked' => 'Checked',
	   'Paper Size' => 'Paper Size',
	   'Letter' => 'Letter',
	   'Legal' => 'Legal',
	   'A4' => 'A4',
	   'Please Log In' => 'Please Log In',
	   'Medication' => 'Medication',
	   
	   );



my $self = 'rptsaskedppp.pl';

use DBI;
use CGI;
use CGI::Session;
use Cwd;


# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "liblatex.pl";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;


my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
    $yday, $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";
my $currsdate = "$year-$mon-$mday";

# Setup Database access
my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    exit;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;


# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "where school = $sdb ";



# Page Header
print "$doctype\n<html><head><title>$lex{Student} $lex{Rubric}</title>
<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$iephome\">$lex{Main}</a> ] $firstname $lastname\n";
print "<center><h1>$lex{Student} $lex{PPP} &amp; $lex{Rubric}</h1>\n";

if ( not $arr{page} ) {
    showStartPage();
} else {
    delete $arr{page};
}

#foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }



# Get the rubric template...
my $templatefile = 'rubricmain.tpl';
unless ( open ( FH,"<", $templatepath. $templatefile )) {
    print $lex{Error}. q{ }. $lex{Template}.": $!\n";
    die $lex{Error}. q{ }. $lex{Template}.": $!\n";
}
my $formtext;
# Now load rest of rubric template for layout.
{ local $/; $formtext = <FH>; close FH;}



# Get the objectives template...
$templatefile = 'ppp3.tpl';
unless ( open ( FH,"<", $templatepath. $templatefile )) {
    print "$lex{Error} $lex{Template}: $!\n";
    die "$lex{Error} $lex{Template}: $!\n";
}
my $objtext;
# Now load rest of objective template for layout.
{ local $/; $objtext = <FH>; close FH;}



# Start TEX Section.
my $shortname = "saskedppp$$";
my $filename = "$shortname.tex";

open(TEX,">$filename") || die $lex{'Cannot open'}. " tex file\n";

# Set Paper Size, text width and height, fontsize
my ( $papersize, $textwidth, $textheight );

if ( $arr{papersize} eq $lex{Letter} ) {
    $papersize = 'letterpaper';
    $textwidth = $g_letterpaper_textwidth;
    $textheight = $g_letterpaper_textheight;
} elsif ( $arr{papersize} eq $lex{Legal} ) {
    $papersize = 'legalpaper';
    $textwidth = $g_legalpaper_textwidth;
    $textheight = $g_legalpaper_textheight;
} elsif ( $arr{papersize} eq $lex{A4} ) {
    $papersize = 'a4paper';
    $textwidth = $g_a4paper_textwidth;
    $textheight = $g_a4paper_textheight;
} 
# print "Papersize: $papersize  TW: $textwidth  TH: $textheight<br>\n";
# Not required here, perhaps
# $textheight =~ s/mm//;# $textheight += 16;# $textheight .= 'mm';

my $fontsize = $arr{fontsize}. 'pt';

    print TEX "\\documentclass[ $fontsize, $papersize ]{article}
\\usepackage{newcent,graphicx,array,colortbl,inputenc,multicol,multirow,fancyhdr}
$a_latex_header
\\renewcommand{\\familydefault}{\\sfdefault}
\\usepackage[pdftex,bookmarks=false,pdfstartview=FitH]{hyperref}
\\setlength{\\textwidth}{ $textwidth }
\\setlength{\\textheight}{ $textheight }
\\setlength{\\hoffset}{-20mm}
\\setlength{\\voffset}{-20mm}
\\setlength{\\topmargin}{0mm}
\\setlength{\\evensidemargin}{0mm}
\\setlength{\\oddsidemargin}{0mm}
\\setlength{\\parindent}{0mm}
\\setlength{\\extrarowheight}{4pt}
\\setlength{\\headsep}{15pt}
\\begin{document}\n";


delete $arr{fontsize};
delete $arr{papersize};


# Now loop through all Students
foreach my $studnum ( sort keys %arr ) {

    # Get Student Name
    my $sth = $dbh->prepare("select lastname, firstname from special
     where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname ) = $sth->fetchrow;

    print TEX "\\pagestyle{fancy}\n";
    print TEX "\\lhead{PPP for $firstname $lastname}\n";
    print TEX "\\lfoot{$divisionname}\\cfoot{Page \\thepage}\n";
    print TEX "\\setcounter{page}{1}\n";
    print TEX "\\thispagestyle{empty}\n";

    printPPPTitlePage( $studnum );


    printIdentPage( $studnum );

    printStrengthChallengePage( $studnum );

    printAnnualOutcomes( $studnum );

    printObjectives( $studnum );



    print TEX "\\thispagestyle{empty}\n";
    
    printRubricTitlePage( $studnum );

    print TEX "\\pagestyle{plain}\n";
    print TEX "\\setcounter{page}{1}\n";
    
    printRubrics( $studnum );

    print TEX "\\thispagestyle{empty}\n";
    printTeam( $studnum );

}


print TEX "\\end{document}";
close TEX;

system("$pdflatex $filename > pdflog$$.txt");
system("mv $shortname.pdf $downloaddir");
system("mv pdflog$$.txt $downloaddir");
system("rm $shortname.*");

print "<center><h3><a href=\"$webdownloaddir/$shortname.pdf\">";
print "$lex{'View/Download'} $lex{Student} $lex{PPP} &amp; $lex{Rubric}</a></h3>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$webdownloaddir/pdflog$$.txt\">". $lex{'View Log File'};
print "</a> ]</center></body></html>\n";

exit;


#------------
sub printTeam {
#------------

    my $studnum = shift;

    # Get Student Name
    my $sth = $dbh->prepare("select lastname, firstname from special
     where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname ) = $sth->fetchrow;

    # Now lets do the team.
    $sth = $dbh->prepare("select userid, sign from team where studnum = ? order by userid");
    $sth->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    my @team = ();
    while ( my ($userid, $sign ) = $sth->fetchrow ) {
	($userid) = latex_filter( $userid );
	($teammember,$dud) = split /\(/,$userid;
        if ( $sign eq 'Y' ){
	   push @team,$teammember;  # needed for signature page
        }
    }

    # Now the "team" records.
    print TEX "{\\sf\\LARGE Signatures}\n\\bigskip\n\n{\\Large ";
    print TEX "We, the undersigned, approve of this educational plan for\n" ;
    print TEX " $firstname $lastname}.\n\n\\vspace{10mm}\n\n"; 

    foreach my $teammember ( @team ) {
	print TEX "\\underline{\\hspace{76mm}}\\hfill \\underline{\\hspace{38mm}}\n\n";
	print TEX "$teammember \\hfill Date \\bigskip\n\n";
    }

    print TEX "\\underline{\\hspace{76mm}} \\hfill \\underline{\\hspace{38mm}} \\\\ \n";
    print TEX "Parent/Guardian \\hfill Date \\bigskip\n\n";
    print TEX "\\underline{\\hspace{76mm}} \\hfill \\underline{\\hspace{38mm}} \\\\ \n";
    print TEX "Parent/Guardian \\hfill Date\n\n";
    print TEX "\\newpage\n";


}




#------------------
sub printObjectives {
#------------------

    my $studnum = shift;

    my $sth = $dbh->prepare("select * from evalmst where studnum = ?
       order by impactarea, longtermobjective");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


    while ( my $ref = $sth->fetchrow_hashref ) {
    
	my %rec = %$ref;

	# Search for term values in the objectives.
	my @noterm = ();
	my %terms = ();
	for my $i ( 1..32 ) {
	    my $field = "obj$i";

	    if ( $rec{$field} and $rec{$field} =~ m/Term:*\s*(.)/ ) {
		if ( not exists $terms{$1} ) { $terms{$1} = [ ]; } # create anonymous array
		$rec{$field} =~ s/Term:*\s*(.)//; # strip term text.
		push @{$terms{$1}}, $rec{$field};
            } elsif ( $rec{$field} ) { # no match
		push @noterm, $rec{$field};
	    }
	}
	# Now have all objectives in 2 data structures.
#	foreach my $key ( sort keys %terms ) {
#	    print "K:$key V:@{$terms{$key}}<br>\n";
#	}
#	print "<br><br>\n\n";


	my $shortterm = ''; # hold objectives text.
	foreach my $key ( sort keys %terms ) {
#	    print "K:$key<br>\n";
	    $shortterm = $shortterm. "\n\nTerm:$key\n";
	    my @obj = @{$terms{$key}};
	    @obj = latex_filter( @obj );

	    foreach my $objective ( @obj ) {
#		print "$objective<br>\n";
		$shortterm = $shortterm. " $objective \n";
	    }
	}
#	print "<br><br>Shortterm:$shortterm<br><br>\n";


	# Now do the noterm objectives
#	@noterm = ();
	if ( @noterm ) {
	    $shortterm = $shortterm. "\n\nYear End:\n";
	    $shortterm .= "\\begin{itemize}\n";
	    @noterm = latex_filter( @noterm );
	    foreach my $objective ( @noterm ) {
		$shortterm .= '\item '. $objective. "\n";
	    }
	    $shortterm .= "\\end{itemize}\n";
	}


	# Latex Filter
	foreach my $key ( keys %rec ) {
	    ( $rec{$key} ) = latex_filter( $rec{$key} );
	}

	# Now add this in... already filtered
	$rec{shortterm} = $shortterm;
#	 print "Short Term: $shortterm<br><br><br>\n";


	my $text = $objtext; # make a new blank objective record to plug into.

	# Now put replacement text back in.
	$text =~ s{\<\@(.*?)\@\>}
  	  { $rec{$1} }gsex;

	$text =~ s/\_/ /g; # remove underscores in field names, if any left.

	print TEX $text,"\n";
	print TEX "\\newpage\n\n";

    }  # End of While loop


} # end of printObjectives.




#----------------------
sub printAnnualOutcomes {  #
#----------------------

    my $studnum = shift;

    print TEX "\\begin{tabular}{|p{94mm}p{94mm}|}\\hline\n";
    print TEX "\\rowcolor[gray]{0.92}\\bf Priorities for Annual Student Outcomes & \\\\ \n";
    print TEX "\\rowcolor[gray]{0.92}Area of Development & Target Skill \\\\ \\hline\n";
    print TEX "\\end{tabular}\n";

    # Get Eval Master Info
    my $sth = $dbh->prepare("select impactarea, longtermobjective from evalmst 
     where studnum = ? order by impactarea, longtermobjective");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    print TEX "\\begin{tabular}{p{94mm}p{94mm}}\n\n";

    # Loop through all Outcomes for this student
    while ( my ( $impact, $objective ) = $sth->fetchrow ) {
	( $impact, $objective ) = latex_filter( $impact, $objective);
	print TEX "$impact & $objective \\\\ \n";
    }

    print TEX "\\end{tabular}\n\n";
    print TEX "\\newpage\n";

}



#-----------------------------
sub printStrengthChallengePage {  # plus Assessment info, Medical, Additional
#-----------------------------

    my $studnum = shift;

    # Get Student Info
    my $sth = $dbh->prepare("select strengths, challenges, assessments, 
     medical, medication, additional from special
     where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $strengths, $challenges, $assessments, 
     $medical, $medication, $additional ) = $sth->fetchrow;

    print TEX "\\begin{tabular}{|p{188mm}|}\\hline\n";
    print TEX "\\rowcolor[gray]{0.92}\\bf 1a. Strengths \\\\ \\hline \n";
    print TEX "$strengths \\\\ \\hline\n";

    print TEX "\\rowcolor[gray]{0.92}\\bf 1b. Challenges \\\\ \\hline \n";
    print TEX "$challenges \\\\ \\hline\n";

    print TEX "\\rowcolor[gray]{0.92}\\bf 1c. Assessment Information \\\\ \\hline \n";
    print TEX "$assessments \\\\ \\hline\n";

    print TEX "\\rowcolor[gray]{0.92}{\\bf 1d. Relevant Medical Information} \\\\ \\hline \n";
    print TEX "$medical \n\n{\\bf $lex{Medication}} $medication\\\\ \\hline\n";

    print TEX "\\rowcolor[gray]{0.92}\\bf 1e. Additional Information \\\\ \\hline \n";
    print TEX "$additional \\\\ \\hline\n";
    print TEX "\\end{tabular}\n\n";

    print TEX "\\newpage\n\n";

}



#-----------------
sub printIdentPage {  # Identity Page
#-----------------

    my $studnum = shift;

    # Get Student Info
    my $sth = $dbh->prepare("select lastname, firstname, grade, school from special
     where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname, $grade, $school ) = $sth->fetchrow;

    # Get School etc info
    my $etcdir = "$rootdir/$schooldbase/etc";

    # Read config variables
    package config;
    eval require "$etcdir/admin.conf";
    if ( $@ ) {
	print $lex{Error}. " $@<br>\n";
	die $lex{Error}. " $@\n";
    }
    package main;


    # Now Get Student Data; load global
    eval require "$globdir/global.conf";
    if ( $@ ) {
	print $lex{Error}. " $@<br>\n";
	die $lex{Error}. " $@\n";
    }

    # Set to Connect to School Database.
    my $dsn1 = "DBI:$dbtype:dbname=$schooldbase";
    my $dbh1 = DBI->connect($dsn1,$guser,$gpassword);
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    #print "GU:$guser  GP:$gpassword";

    my $sth1 = $dbh1->prepare("select * from student where studnum = ?");
    $sth1->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my $ref = $sth1->fetchrow_hashref;
    my %sr = %$ref;
    foreach my $key ( keys %sr ) {
	($sr{$key}) = latex_filter( $sr{$key} );
    }

    if ( "\u$sr{sex}" eq 'M' ) {
	$sr{sex} = 'Male';
    } else {
	$sr{sex} = 'Female';
    }


    print TEX "\\begin{tabular}{|p{188mm}|}\\hline\n\n";
    print TEX "\\vspace{6mm}\n\n";
    print TEX "\\setlength\\fboxsep{4mm}\n";
    print TEX "\\setlength\\fboxrule{0pt}\n";
    print TEX "\\fbox{\\includegraphics[width=28mm]{divlogo.jpg}}\n";

    print TEX "\\begin{tabular}[b]{rl}\n";
    print TEX "Division: & $divisionname \\\\ \n\n";
    print TEX "School: & $config::schoolname \\\\ \n\n";
    print TEX "School Address: & $config::schooladdr1 \\\\ \n\n";
    print TEX "& $config::schoolcity $config::schoolprov \\\\ \n\n";
    print TEX "& $config::schoolpcode \\\\ \n\n";

    print TEX "Phone: & $config::schoolphone \\\\ \n\n";
    print TEX "Fax: & $config::schoolfax \\\\ \n\n & \\\\";
    print TEX "\\hline\n\\end{tabular}\n\n";

    print TEX "\\vspace{10mm}\n\n";
    print TEX "{\\bf This {\\it confidential} document must be filed in the Student's Cumulative Records folder.}\n\n";
    print TEX "\\vspace{10mm}\n\n";
    print TEX "\\underline{\\hspace{180mm}}\n\n\\vspace{6mm}\n\n";


    print TEX "{\\bf Personal Program Plan for $firstname $lastname}\n\n";
    print TEX "\\vspace{10mm}\n\n";

    print TEX "\\begin{tabular}{p{60mm}p{60mm}p{60mm}}\n";
    print TEX "Class Placement: Grade $grade & School Year: $schoolyear & \\\\\n";
    print TEX "Date of Birth: $sr{birthdate} &Gender: $sr{sex} &Student ID\\#: $sr{provnum}\n\n";
    print TEX "\\end{tabular}\n";


    print TEX "\\vspace{6mm}\\underline{\\hspace{180mm}}\\vspace{6mm}\n\n";


    print TEX "\\begin{tabular}{p{36mm}p{56mm}p{36mm}p{56mm}}\n";
    print TEX "Parent / Guardian: & $sr{name1} & Parent / Guardian: & $sr{name2} \\\\\n";
    print TEX "Home Phone: & $sr{hphone1} & Home Phone: & $sr{hphone2} \\\\\n";
    print TEX "Work Phone: & $sr{wphone1} & Work Phone: & $sr{wphone2} \\\\\n";
    print TEX "Other Phone: & $sr{cell1} & Other Phone: & $sr{cell2} \\\\\n";
    print TEX "Email: & $sr{email} & Email: & \\\\\n";

    print TEX " & & & \\\\\n";
    print TEX " & & & \\\\\n";

    print TEX "Primary Address: & $sr{address1} \\\\\n";
    print TEX "& $sr{city1} $sr{prov1}\\\\\n";
    print TEX "& $sr{pcode1} \\\\\n";

    print TEX " & & & \\\\\n";

    print TEX "\\multicolumn{2}{l}{Emergency Contact: $sr{emname}} \\\\\n\n";
    print TEX "Home Phone & $sr{emhphone} \\\\\n\n";
    print TEX "Work Phone & $sr{emwphone} \\\\\n\n";
    print TEX "\\end{tabular}\n";


    print TEX "\\vspace{10mm}\n";
    print TEX "\\\\ \\hline\\end{tabular}\n";
    print TEX "\\newpage\n\n";


}



#--------------------
sub printPPPTitlePage {
#--------------------

    my $studnum = shift;

    # Get Student Info
    my $sth = $dbh->prepare("select lastname, firstname, grade, school from special
     where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname, $grade, $school ) = $sth->fetchrow;

    print TEX "\\vspace{20mm}\n\\begin{centering}\n";

    print TEX "\\includegraphics[width=28mm]{divlogo.jpg}\n\n";
    print TEX "\\vspace{6mm}\n";

    print TEX "{\\Huge\\it Confidential}\n\n\\vspace{6mm}\n";

    print TEX "{\\Huge Personal Program Plan}\n\n";
    print TEX "\\vspace{12mm}\n\n";

    print TEX "{\\Large $divisionname}\n\\vspace{15mm}\n\n";

    print TEX  "{\\bf\\Large $firstname $lastname}\n\n\\vspace{10mm}\n";

    print TEX "{\\large $schoolyear}\n\n\\vspace{10mm}\n";
    print TEX "\\end{centering}\n";

    print TEX "A Personal Program Plan (PPP) is required for students who\n";
    print TEX "\\begin{itemize}\n";
    print TEX "\\item are working on objectives substantially different from those oulined in the approved curricula;\n";
    print TEX "\\item require continuing individualized supports that cannot be met though the Adaptive Dimension; or\n";
    print TEX "\\item have been identified as requiring Intensive Supports level 1 or 2.\n";
    print TEX "\\end{itemize}\n\n";

    print TEX "A Personal Program Plan (PPP) is an evergreen, written document\n";
    print TEX "developed and implemented by a collaborative team. It is a compilation\n";
    print TEX "of annual student outcomes that have the highest priority for the\n";
    print TEX "student during the year.\n";

    print TEX "It includes:\n";
    print TEX "\\begin{itemize}\n";
    print TEX "\\item Student identification and background information\n";
    print TEX "\\item Current levels of performance\n";
    print TEX "\\item Annual student outcomes (SMART)\n";
    print TEX "\\item Short-term objectives\n";
    print TEX "\\item Methods, materials, and strategies\n";
    print TEX "\\item Team members who will implement the PPP, and the location for implementation\n";
    print TEX "\\item Plans for monitoring, evaluation, and review\n";
    print TEX "\\item Procedures for reporting\n";
    print TEX "\\item Plans for transitions\n";
    print TEX "\\end{itemize}\n";

    print TEX "\\newpage\n";


} # end of printPPPTitlePage




#-----------------------
sub printRubricTitlePage {
#-----------------------

    my $studnum = shift;

    # Get Student Info
    my $sth = $dbh->prepare("select lastname, firstname, grade, school from special
     where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname, $grade, $school ) = $sth->fetchrow;

    print TEX "\\vspace{20mm}\n\\begin{centering}\n";

    print TEX "\\includegraphics[width=16mm]{divlogo.jpg}\n\n";
    print TEX "\\vspace{6mm}\n";

    print TEX "{\\Huge\\it Confidential}\n\n\\vspace{15mm}\n";

    print TEX "{\\Huge Student Outcome Rubrics} \\bigskip\n\n To Accompany \\bigskip";
    print TEX "\n\n {\\huge Personal Program Plan}\n\n";
    print TEX "\\vspace{12mm}\n\n";

    print TEX "{\\large $divisionname}\n\\vspace{20mm}\n\n";

    print TEX  "{\\bf\\Large $firstname $lastname}\n\n\\vspace{12mm}\n";

    print TEX "{\\large $schoolyear}\n\n\\vspace{40mm}\n";

    print TEX "A Student Outcome Rubric (SOR) is a tool which allows teachers to assess\n\n";
    print TEX "the actual performance level of a student, over a specific period of time, on\n\n";
    print TEX "an annual student outcome in that student's PPP. SORs accompany a PPP\n\n";
    print TEX "and may be developed for a sampling of annual student outcomes in the PPP.\n\n";

    print TEX "\\end{centering}\n \\newpage\n";


} # end of printRubricTitlePage



#---------------
sub printRubrics {
#---------------

    my $studnum = shift;

    # Get Student Info
    my $sth = $dbh->prepare("select lastname, firstname, grade, school, birthdate, sex from special
     where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname, $grade, $school, $birthdate, $sex ) = $sth->fetchrow;
    
    my $age = calcAge($birthdate, $currsdate);
    my ($y,$m) = split /:/,$age;
    $age = "$y Years $m Months";

    if ( "\u$sex" eq 'M' ) { $sex = 'Male'; } else { $sex = 'Female'; }


    my $sth = $dbh->prepare("select * from eval_rubric where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


    while ( my $ref = $sth->fetchrow_hashref ) {
    
	my %rec = %$ref;
	foreach my $key ( keys %rec ) {
	    ( $rec{$key} ) = latex_filter( $rec{$key});
	}
	$rec{name} = "$firstname $lastname";
        $rec{age} = $age;
        $rec{sex} = $sex;
				       
	my $text = $formtext; # make a new blank record to plug in...

	# Now put replacement text back in.
	$text =~ s{\<\@(.*?)\@\>}
  	  { $rec{$1} }gsex;

	$text =~ s/\_/ /g; # remove underscores in field names.

	print TEX $text,"\n";
 
	print TEX "\\newpage\n\n";

    }  # End of For loop


} # end of printRubrics.



#----------------
sub showStartPage {
#----------------

    # Start Form
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    print "<tr><td></td></tr>\n"; # blank row
    print "<tr><td class=\"la\">$lex{'Paper Size'} ";
    print "<select name=\"papersize\">\n";
    print "<option>$lex{Letter}</option><option>$lex{Legal}</option>\n";
    print "<option>$lex{A4}</option></select></td></tr>\n";

    print "<input type=\"hidden\" name=\"fontsize\" value=\"11\">";
    print "<tr><td></td></tr>\n"; # blank row

    print "<tr><td class=\"la\">\n";
    print "<input type=\"submit\" value=\"$lex{Continue}\"></td></tr>\n";


    my $sth = $dbh->prepare("select lastname, firstname, studnum, grade, school from special
     $select order by lastname, firstname"); # $select is set by session code above
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    

    while ( my ($lastname, $firstname, $studnum, $grade, $sch ) = $sth->fetchrow ){

	print "<tr><td class=\"la\">";
	print "<input type=\"checkbox\" name=\"$studnum\" value=\"1\"> \n";
	print "<b>$lastname</b>, $firstname</td></tr>\n";

    }

    print "<tr><td class=\"la\">\n";
    print "<input type=\"submit\" value=\"$lex{Continue}\"></td></tr>\n";

    print "</table></form>\n";

    print "</center></body></html>\n";

    exit;

}

#----------
sub calcAge {
#----------
    # Passed (birthdate, $currdate)
    my $birthDate = shift;
    my $currentDate = shift;

    my ($byear,$bmonth,$bday) = split /-/,$birthDate;
    my ($cyear,$cmonth,$cday) = split /-/,$currentDate;
    my $age = $cyear - $byear;
    my $month = $cmonth - $bmonth;

    if ($cmonth < $bmonth){
	$month = $month + 12;
	if ($cday < $bday){ $month--;}
	$age--;
    }
    elsif ($cmonth == $bmonth and $cday < $bday){
	$age--; 
	$month = 11;
    } elsif ($cmonth > $bmonth and $cday < $bday) {
	$month--;
    }

    return "$age:$month";
}

