#!/usr/bin/perl
#  Copyright 2001-2012 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Personnel Entry' => 'Personnel Entry',
	   'Admin' => 'Admin',
	   'Error' => 'Error',
	   'User Id' => 'User Id',
	   'Last Name' => 'Last Name',
	   'First Name' => 'First Name',
	   'Job Title' => 'Job Title',
	   'Agency' => 'Agency',
	   'Phone' => 'Phone',
	   'E-Mail' => 'E-Mail',
	   'Save Personnel Record' => 'Save Personnel Record',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Record the following error' => 'Record the following error',
	   'Contact' => 'Contact',
	   'Your record is now stored' => 'Your record is now stored',
	   'Missing User Id or Name' => 'Missing User Id or Name',
	   'Userid already exists' => 'Userid already exists',
	   'Please try again' => 'Please try again',
	   'Edit/Delete Personnel Records' => 'Edit/Delete Personnel Records',
	   
	   );

my $self = 'pradd.pl';

use DBI;
use CGI;

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;
my $studnum = $arr{studnum};

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

print "$doctype\n<html><head><title>". $lex{'Personnel Entry'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"/iep.css\" type=\"text/css\"></head><body>\n";
print "[ <a href=\"$adminpage\">". $lex{Admin}. "</a> ]\n";
print "<center><h1>". $lex{'Personnel Entry'}. "</h1>\n";

if ( $arr{flag} ) {
    delete $arr{flag};
    addRecord();
}


print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"flag\" value=\"1\">\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";

print "<tr><th align=\"right\">". $lex{'User Id'}. "</th>
<td><input type=\"text\" name=\"userid\" size=\"10\"></td></tr>\n";

print "<tr><th align=\"right\">". $lex{'Last Name'}. "</th>\n<td>";
print "<input type=\"text\" name=\"lastname\" size=\"25\"></td></tr>\n";

print "<tr><th align=\"right\">". $lex{'First Name'}. "</th>\n<td>";
print "<input type=\"text\" name=\"firstname\" size=\"25\"></td></tr>\n";

print "<tr><th align=\"right\">". $lex{'Job Title'}. "</th>\n<td>";
print "<input type=\"text\" name=\"jobtitle\" size=\"20\" ></td></tr>\n";

print "<tr><th align=\"right\">". $lex{Agency}. "</th>\n<td>";
print "<input type=\"text\" name=\"agency\" size=\"20\"></td></tr>\n";

print "<tr><th align=\"right\">". $lex{Phone}. "</th>\n<td>";
print "<input type=\"text\" name=\"phone\" size=\"20\"></td></tr>\n";

print "<tr><th align=\"right\">". $lex{'E-Mail'}. "</th>\n<td>";
print "<input type=\"text\" name=\"email\" size=\"20\"></td></tr>\n";

print "<tr><th align=\"right\">$lex{'Password'}</th>\n<td>";
print "<input type=\"text\" name=\"password\" size=\"20\"></td></tr>\n";

print "<tr><td colspan=\"2\" align=\"center\">\n";
print "<input type=\"submit\" value=\"". $lex{'Save Personnel Record'}. "\">\n";
print "</td></tr></table>\n";

print "</form></center></body></html>\n";



#------------
sub addRecord {
#------------

    #foreach my $key (sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $dsn = "DBI:$dbtype:dbname=$dbase";
    my $dbh = DBI->connect($dsn,$user,$password);

    # Check for missing values
    if (not $arr{userid} or 
	not $arr{lastname} or 
	not $arr{firstname} ) {
	
	print "<h1>". $lex{'Missing User Id or Name'}. "</h1>\n";
	die;
    }

    # Check for existing user ids.
    my $sth = $dbh->prepare("select count(userid) from personnel where userid = ?");
    $sth->execute( $arr{userid} );
    if ($DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth->fetchrow;
    if ( $count > 0 ) {
	print "<h1>". $lex{'Userid already exists'}. ". \n";
	print $lex{'Please try again'}. ".</h1>\n";
	die;
    }


    foreach my $key (keys %arr) { 
	if ( $arr{$key} ) {
	    $arr{$key} = $dbh->quote( $arr{$key} );
	} else {
	    $arr{$key} = $sql{default};
	}
    }

    $sth = $dbh->prepare("insert into personnel values (
     $sql{default}, $arr{userid}, $arr{lastname}, $arr{firstname},
     $arr{jobtitle}, $arr{agency}, $arr{phone}, $arr{email}, $arr{password} )");
    $sth->execute;

    if (not $DBI::errstr ) {
	print "<h3>". $lex{'Your record is now stored'}. ".</h3>\n";
    } else {
	print "<h3>". $lex{'There was an error storing your data'}. ". ";
	print $lex{Contact}. " $adminname <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{'Record the following error'}. " $DBI::errstr</h3></p>\n";
    }

    print "<p>[ <a href=\"$adminpage\">". $lex{Admin}. "</a> |\n";
    print "<a href=\"prdeled.pl\">". $lex{'Edit/Delete Personnel Records'}. "</a> ]\n"; 
    print "</p></center></body></html>\n";

    exit;

}
