#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Script to Power Delete Rubrics

my $self='rubpwrdel.pl';
my %lex = ('Power Delete Rubrics' => 'Power Delete Rubrics',
	   'Admin' => 'Admin',
	   'Main' => 'Main',
	   'School' => 'School',
	   'dev_area' => 'Dev Area',
	   'target_skill' => 'Skill',
	   'responsible' => 'Resp',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Rubrics Deleted' => 'Rubrics Deleted',
	   'Error' => 'Error',
	   'Name' => 'Name',
	   'Delete' => 'Delete',
	   'Yes, Delete the Records!' => 'Yes, Delete the Records!',

	   );

use DBI;
use CGI;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my $cookieuser = $q->cookie($divcookie);
print $q->header;
my %arr = $q->Vars;
if ($arr{checked}) {
    $checked = $arr{checked};
    delete $arr{checked};
}

my $select;
if ($cookieuser){
    $select = " and special.school like '%($cookieuser%' ";
    $cookieuser = $dbase{$cookieuser};
} else {
    $cookieuser = "Not Logged In";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $fieldlist = "eval_rubric.id, eval_rubric.studnum, eval_rubric.dev_area,
 eval_rubric.target_skill, special.lastname, special.firstname";

my $sth = $dbh->prepare("select distinct eval_rubric.studnum, 
  special.lastname, special.firstname from eval_rubric,special 
  where eval_rubric.studnum = special.studnum group by eval_rubric.studnum
  order by special.lastname, special.firstname");

$sth->execute;
if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr;}
my $rows = $sth->rows;

# Show Page Header.
print "$doctype\n<html><head><title>". $lex{'Power Delete Rubrics'}. "</title>
<link rel=\"stylesheet\" href=\"/iep.css\" type=\"text/css\">
</head><body style=\"padding:1em 2em;\">";
print "[ <a href=\"$ieppage\">". $lex{Main};
print "</a> | <a href=\"$adminpage\">Admin</a> ]
<center><h1>". $lex{'Power Delete Rubrics'};
print "</h1></p>&nbsp;</p>\n";

if ($arr{flag}){
    delete $arr{flag};
    deleteRecords();
    die;
}

print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"flag\" value=\"1\">\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><th>". $lex{Name}. "</th><th>". $lex{Delete}. "?</th></tr>\n";
print "<tr><td colspan=\"2\" align=\"center\">";
print "<input type=\"submit\" value=\"". $lex{'Yes, Delete the Records!'}. "\"></td></tr>\n";

while ( my ($studnum, $lastname, $firstname) = $sth->fetchrow ) {
   
    print "<tr><td><b>$lastname</b>, $firstname</td>";
    print "<td align=\"center\">";
    print "<input type=\"checkbox\" name=\"$studnum\" value=\"1\" $checked></td>\n";

} # End of loop counter

print "<tr><td colspan=\"2\" align=\"center\">";
print "<input type=\"submit\" value=\"". $lex{'Yes, Delete the Records!'}. "\"></td></tr>\n";
print "</table></form></body></html>\n";


#---------------
sub deleteRecords {
#---------------

    #foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n";}


    my $sth = $dbh->prepare("delete from eval_rubric where studnum = ?"); 
    my $sth1 = $dbh->prepare("select lastname, firstname from special where studnum = ?");

    foreach my $studnum (keys %arr) {
	$sth->execute($studnum);
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	$sth1->execute($studnum);
	my ($lastname, $firstname) = $sth1->fetchrow;
	print "<b>$firstname $lastname</b> ". $lex{'Rubrics Deleted'}. "<br>\n";
    }

    print "<p>[ <a href=\"$adminpage\">". $lex{Admin}. "</a> ]\n";
    print "</body></html>\n";

}
