#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Edit Objectives' => 'Edit Objectives',
	   'Admin' => 'Admin',
	   'Error' => 'Error',
	   'Category Number' => 'Category Number',
	   'Category' => 'Category',
	   'ID Number' => 'ID Number',
	   'Description' => 'Description',
	   'Grade' => 'Grade',
	   'Comment Codes' => 'Comment Codes',

	   'Save Objective' => 'Save Objective',
	   'Edit/Delete Objectives' => 'Edit/Delete Objectives',
	   'Record Updated' => 'Record Updated',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Contact' => 'Contact',
	   'Record the following error' => 'Record the following error',
	   
	   );

use DBI;
use CGI;

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Page Header
print "$doctype\n<html><head><title>". $lex{'Edit Objectives'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"/iep.css\" type=\"text/css\"></head><body>\n";
print "[ <a href=\"$adminpage\">". $lex{Admin}. "</a> ]\n";
print "<center><h1>". $lex{'Edit Objectives'}. "</h1>\n";

if ( $arr{flag} ) {
    delete $arr{flag};
    updateRecord();
}

# Get existing record values
my $sth = $dbh->prepare("select * from subject where id = ?"); 
$sth->execute( $arr{id} );
if ($DBI::errstr) {print $DBI::errstr; die;}
my ($id, $catnum, $category, $idnum, $grade, $description, $commentcodes ) =  
    $sth->fetchrow;
$description =~ s/"/'/g; # in case description contains any double quotes.

print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"flag\" value=\"1\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";

print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";

print "<tr><th align=\"right\">". $lex{'Category Number'}. "</th>\n<td>$catnum";
#print "<input type=\"text\" name=\"catnum\" size=\"10\" value=\"$catnum\">
print "</td></tr>\n";

print "<tr><th align=\"right\">". $lex{Category}. "</th>\n<td>$category";
#print "<input type=\"text\" name=\"category\" size=\"25\" value=\"$category\">
print "</td></tr>\n";

print "<tr><th align=\"right\">". $lex{'ID Number'}. "</th>\n<td>$idnum";
#print "<input type=\"text\" name=\"idnum\" size=\"5\" value=\"$idnum\">
print "</td></tr>\n";

print "<tr><th align=\"right\">". $lex{Grade}. "</th>\n<td>";
print "<input type=\"text\" name=\"grade\" size=\"5\" value=\"$grade\"></td></tr>\n";

print "<tr><th align=\"right\">". $lex{Description}. "</th>\n<td>";
print "<input type=\"text\" name=\"description\" size=\"80\" value=\"$description\"></td></tr>\n";

print "<tr><th align=\"right\">". $lex{'Comment Codes'}. "</th>\n<td>";
print "<input type=\"text\" name=\"commentcodes\" size=\"10\" value=\"$commentcodes\">";
print "</td></tr>\n";

print "<tr><td colspan=\"2\" align=\"center\">\n";
print "<input type=\"submit\" value=\"". $lex{'Save Objective'}. "\">\n";
print "</td></tr></table>\n";

print "</form></center></body></html>\n";


#---------------
sub updateRecord {
#---------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $id = $arr{id};
    delete $arr{id};

    foreach my $key ( sort keys %arr ) {
        my $sth = $dbh->prepare("update subject set $key = ? where id = ?");
	$sth->execute( $arr{$key}, $id );
    }

    if (not $DBI::errstr ) {
	print "<h3>". $lex{'Record Updated'}. "</h3>\n";
    } else {
	print "<h3>". $lex{'There was an error storing your data'}. ". ";
	print $lex{Contact}. " $adminname <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{'Record the following error'}. " $DBI::errstr</h3>\n";
    }

    print "<p>[ <a href=\"$adminpage\">". $lex{Admin}. "</a> |\n";
    print "<a href=\"subdeled.pl\">". $lex{'Edit/Delete Objectives'}. "</a> ]\n"; 
    print "</center></body></html>\n";

    exit;

}
