#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# subrecat.pl - Recategorize Objectives within different categories.
my $newcat = 3; # Number of new categories to show for entry.
my $self = 'subrecat.pl';

my %lex = ('Recategorize Objectives' => 'Recategorize Objectives',
	   'Admin' => 'Admin',
	   'Error' => 'Error',
	   'Edit Other Categories' => 'Edit Other Categories',
	   'Recategorize Objectives' => 'Recategorize Objectives',
	   'Edit/Delete these Objectives' => 'Edit/Delete these Objectives',
	   'Add New Categories' => 'Add New Categories',
	   'Cat Num' => 'Cat Num',
	   'Category' => 'Category',
	   'These new categories may be used in the objectives below.' => 
	     'These new categories may be used in the objectives below.',
	   'Existing Objectives/Category' => 'Existing Objectives/Category',
	   'Cat<br>Num' => 'Cat<br>Num',
	   'Id<br>Num' => 'Id<br>Num',
	   'IdNum' => 'IdNum',
	   'Objective' => 'Objective',
	   'Update Objectives' => 'Update Objectives',
	   'Missing Text for Category' => 'Missing Text for Category',
	   'already exists' => 'already exists',
	   'Updated Categories' => 'Updated Categories',
	   'No category text found for category number' => 
	     'No category text found for category number',
	   
	   );


use DBI;
use CGI;

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;
my $catnum = $arr{cat};
my $update = $arr{update};

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Page Header
print "$doctype\n<html><head><title>". $lex{'Recategorize Objectives'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"/iep.css\" type=\"text/css\"></head><body>\n";
print "[ <a href=\"$adminpage\">". $lex{Admin}. "</a> |\n";
print "<a href=\"submuldeled.pl\">". $lex{'Edit Other Categories'}. "</a> |\n";
print "<a href=\"submuled.pl?cat=$catnum\">". $lex{'Edit/Delete these Objectives'}. "</a> ]\n";
print "<center><h1>". $lex{'Recategorize Objectives'}. "</h1>\n";


if ($update){ # update passed records.
    update();
}

# Start Form
print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"update\" value=\"1\">\n";
print "<input type=\"hidden\" name=\"cat\" value=\"$catnum\">\n";

# Input fields for new Categories
print "<h2 style=\"font-size: 120%;\">". $lex{'Add New Categories'}. "</h2>\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><th>". $lex{'Cat Num'}. "</th><th>". $lex{Category}. "</th></tr>\n";

# Print Input for New Category numbers and text.
for my $i ( 1..$newcat ) { # CN - Category Number CT-Category Text
    print "<tr><td><input type=\"text\" name=\"CN-$i\" size=\"8\"></td>";
    print "<td><input type=\"text\" name=\"CT-$i\" size=\"50\"></td></tr>\n";
}
print "</table>\n<p style=\"font-size:120%;\">";
print $lex{'These new categories may be used in the objectives below.'}. "</p>\n";
print "<h2 style=\"font-size: 120%;\">". $lex{'Existing Objectives/Category'}. "</h2>\n";


# print Heading for Table
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><th>". $lex{'Cat<br>Num'}. "</th><th>". $lex{Category}. "</th>\n<th>";
print $lex{'Id<br>Num'}. "</th><th>". $lex{Objective}. "</th></tr>\n";

# Submit Field
print "<div style=\"padding:0.4em;\">";
print "<input type=\"submit\" value=\"". $lex{'Update Objectives'}. "\"></div>\n";

# Select records
$sth = $dbh->prepare("select id, catnum, category, idnum, description from subject 
 where catnum = ? order by idnum");
$sth->execute( $catnum );
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

while ( my ( $id, $catnum, $category, $idnum, $description ) = $sth->fetchrow ) {
    print "<tr><td><input type=\"text\" name=\"CAT-$catnum-$id\" ";
    print "value=\"$catnum\" size=\"6\"></td>\n<td>$category</td><td>$idnum</td>";
    print "<td>$description</td></tr>\n";
}

print "</table>\n";

# Submit Field
print "<div style=\"padding:0.4em;\">";
print "<input type=\"submit\" value=\"". $lex{'Update Objectives'}. "\"></div>\n";

print "<div>[ <a href=\"$adminpage\">". $lex{Admin}. "</a> |\n";
print "<a href=\"submuldeled.pl\">". $lex{'Edit Other Categories'}. "</a> |\n";
print "<a href=\"submuled.pl?cat=$catnum\">". $lex{'Edit/Delete these Objectives'}. "</a> ]";
print "</div>\n";

print "</center></body></html>\n";



#---------
sub update { # update subject records (ie. objectives)
#---------
    
    # First Loop - Loop and Add new Categories to %Cathash.
    my %cathash;
    foreach my $key ( keys %arr ) { 
	my ($cn , $num) = split /-/,$key;
	if ($cn eq 'CN' and $arr{$key}){ 
	    # Test for Category text and add to hash.
	    #print "CN: $cn Num: $num CT: $arr{CT.\"-\".$num} <br>\n";
	    my $cttext = "CT-".$num;
	    if ($arr{$cttext}){ # we have matching text...
		$cathash{$arr{$key}} = $arr{$cttext};
	    } else { # mistake: forgot to add text for this category.
		print "<h2>". $lex{'Missing Text for Category'}. ": $arr{$key}</h2>\n";
		print "</body></html>\n";
		die;
	    }
	}
    }

    # Check that categories do not already exist.
    $sth = $dbh->prepare("select category from subject where catnum = ?");
    foreach my $key ( keys %cathash ) { 
	# check for pre-existing numbers, and fail
	$sth->execute( $key );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	my $cat = $sth->fetchrow;
	if ($cat){ # mistake again. Already Exists.
	    print "<p>". $lex{Category}. ": <b>$cat ($key)</b> ";
	    print $lex{'already exists'}. ".</p></body></html>\n";
	    die;
	}
    }


    # Start Table for updates
    print "<h2 style=\"font-size: 120%;\">". $lex{'Updated Categories'}. "</h2>\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>". $lex{'Cat Num'}. "</th><th>". $lex{Category}. "</th><th>";
    print $lex{IdNum}. "</th><th>". $lex{Objective}. "</th></tr>\n";


    # Now loop through new category numbers.
    foreach my $key ( keys %arr ) { 
	my ($cat,$oldcat, $idrec) = split /-/,$key;
	if ( $cat eq "CAT" and $oldcat ne $arr{$key} ){ 
	    # we have a category change 
	    # $cat holds 'CAT', $oldcat holds old category number,
	    # $idrec is the record id that we are changing.
	    # $arr{$key} holds the new category number.
	    
	    # check for category text
	    if ($cathash{$arr{$key}}){
		$cattext = $cathash{$arr{$key}};
	    } else { # get it out of subject table.
		$sth = $dbh->prepare("select category from subject where catnum = ");
		$sth->execute( $arr{$key} );
		if ($DBI::errstr){ print $DBI::errstr; die $DBI::errst; }
		$cattext = $sth->fetchrow;
	    }
	    if ( not $cattext ){ # no category text found!
		print "</table>";
		print "<h2>". $lex{'No category text found for category number'};
		print "<b>$arr{$key}</b>.\n";
		print "</h2></body></html>\n";
		die;
	    }

	    # Get Objective to display change.
	    $sth = $dbh->prepare("select description, idnum from subject where id = ?");
	    $sth->execute( $idrec );
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	    my ( $objective, $idnum ) = $sth->fetchrow;
	    
	    #print "Catnum: $arr{$key} CatText: $cattext IDRec: $idrec\n";
	    $sth = $dbh->prepare("update subject set category= ?,  catnum = ? where id = ?");
	    $sth->execute( $cattext, $arr{$key}, $idrec ) ;
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

	    print "<tr><td>";
	    print "<a href=\"subrecat.pl?cat=$arr{$key}\">";
	    print "$arr{$key}</a></td>\n<td>";
	    print "<a href=\"subrecat.pl?cat=$arr{$key}\">";
	    print "$cattext</a></td><td>";
	    print "<a href=\"submuled.pl?cat=$arr{$key}\">";
	    print "$idnum</a></td><td>";
	    print "<a href=\"submuled.pl?cat=$arr{$key}\">";
	    print "$objective</a></td></tr>\n";

	}
    } # keys loop
    print "</table>\n";
}
