#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Power Delete Complete Student Record

my $self = 'totalpwrdel.pl';
my %lex = ('Power Delete Student Records' => 'Power Delete Student Records',
	   'Admin' => 'Admin',
	   'Error' => 'Error',
	   'School' => 'School',
	   'Select' => 'Select',
	   'Chk' => 'Chk',
	   'Student' => 'Student',
	   'Yes, select these schools' => 'Yes, select these schools',
	   'Delete Complete Records of Selected Students' =>
	     'Delete Complete Records of Selected Students',
	   'All records of' => 'All records of',
	   'deleted' => 'deleted',
	   'Record Deletion Failed' => 'Record Deletion Failed',

	   );

use DBI;
use CGI;

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;
my $checked = $arr{checked};

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Page Header
print "$doctype\n<html><head><title>". $lex{'Power Delete Student Records'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">\n";
print "</head><body>[ <a href=\"$adminpage\">". $lex{Admin}. "</a> ]\n";
print "<center><h1>". $lex{'Power Delete Student Records'}. "</h1>\n";

if ( $arr{page} == 1 ) {
    delete $arr{page};
    selectStudent();
} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    deleteStudent();
}

print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\">\n";
print "<tr><th>". $lex{School}. "</th><th>". $lex{Select}. "</th></tr>\n";
print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";


foreach $key ( keys %dbase ) {
    print "<tr><td>$dbase{$key} ($key)</td>";
    print "<td><input type=\"checkbox\" name=\"$key\" value=\"1\" $checked>";
    print "</td></tr>\n";
}

print "<tr><td colspan=\"2\" align=\"center\">\n";
print "<input type=\"submit\" value=\"". $lex{'Yes, select these schools'}. "\">\n";
print $lex{Chk}. " <input type=\"checkbox\" value=\"checked\" name=\"checked\"></td></tr>\n";
print "</form></table></body></html>\n";


#-----------------
sub selectStudent {
#-----------------

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";
    print "<div style=\"padding:0.3em;\">";
    print "<input type=\"submit\" value=\"";
    print $lex{'Delete Complete Records of Selected Students'}. "\"></div>\n";

    foreach my $key (keys %arr){ # Loop through each database.
	if ( $key eq 'checked' ){ next; } # skip checked key
	print "<h2>$dbase{$key}</h2>\n";
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
	print "<tr><th>". $lex{Student}. "</th><th>". $lex{Select}. "</th></tr>\n";
	$sth = $dbh->prepare("select lastname,firstname, studnum from special
          where school = ? order by lastname, firstname");
	$sth->execute( $key );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	while ( my ($lastname,$firstname,$studnum) = $sth->fetchrow){
	    print "<tr><td><b>$lastname</b>, $firstname ($studnum)</td>\n";
	    print "<td><input type=\"checkbox\" name=\"$studnum\" value=\"1\" $checked>\n";
	    print "</td></tr>\n";
	}    
	print "</table>\n";

    }

    print "<div style=\"padding:0.3em;\"><input type=\"submit\" value=\"";
    print $lex{'Delete Complete Records of Selected Students'};
    print "\"></div>\n</form></center></body></html>\n";

    exit;

} # end of selectStudents


#----------------
sub deleteStudent {
#----------------

    #foreach my $key (keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    # Tables to delete records from
    my $sth = $dbh->prepare("select lastname,firstname from special where studnum = ?");
    my $sth1 = $dbh->prepare("delete from eval where studnum = ?");
    my $sth2 = $dbh->prepare("delete from evalmst where studnum = ?");
    my $sth3 = $dbh->prepare("delete from special where studnum = ?");
    my $sth4 = $dbh->prepare("delete from team where studnum = ?");
    my $sth5 = $dbh->prepare("delete from assess where studnum = ?");
    my $sth6 = $dbh->prepare("delete from eval_rubric where studnum = ?");
    my $sth7 = $dbh->prepare("delete from impact where studnum = ?");
    my $sth8 = $dbh->prepare("delete from services where studnum = ?");

    foreach my $studnum ( keys %arr ) {

	# Get Student Name
	$sth->execute( $studnum );
	my ( $lastname,$firstname ) = $sth->fetchrow;

	# Delete his/her records
	$sth1->execute($studnum);
	$sth2->execute($studnum);
	$sth3->execute($studnum);
	$sth4->execute($studnum);
	$sth5->execute($studnum);
	$sth6->execute($studnum);
	$sth7->execute($studnum);
	$sth8->execute($studnum);

	if ($DBI::errstr) {
	    print "<p style=\"color:red;\">". $lex{'Record Deletion Failed'}. q{. };
	    print $lex{Contact}. " $adminname<br>\n";
	    print $lex{Error}. " $DBI::errstr</p>\n";
	}

	print "<p>". $lex{'All records of'}. " $firstname $lastname ". $lex{deleted}. ".</p>\n";
    }

    print "<p>[ <a href=\"$adminpage\">". $lex{Admin}. "</a> ]</p>\n";
    print "</center></body></html>\n";

    exit;

}
