#!/usr/bin/perl
#  Copyright 2001-2015 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Attendance Entry' => 'Attendance Entry',
	   'Error' => 'Error',
	   'Main' => 'Main',
	   'Attendance' => 'Attendance',
	   'Attendance Date' => 'Attendance Date',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Attendance Entry' => 'Attendance Entry',
	   'Subject' => 'Subject',
	   'Periods per Day' => 'Periods per Day',
	   'Submit Attendance' => 'Submit Attendance',
	   'Reason' => 'Reason',	   
	   'Student' => 'Student',
	   'Per' => 'Per',
	   'Attendance Date' => 'Attendance Date',
	   'Late' => 'Late',
	   'Not Found' => 'Not Found',
	   'Period(s)' => 'Period(s)',
	   'Clear Prev Attendance' => 'Clear Prev Attendance',
	   'Period' => 'Period',
	   'Late' => 'Late',
	   'None' => 'None',
	   'More' => 'More',
	   'Record(s) Stored' => 'Record(s) Stored',
	   'Attendance Reasons' => 'Attendance Reasons',
	   'Skipping' => 'Skipping',
	   'Not Found' => 'Not Found',
	   'Missing' => 'Missing',
	   'Today' => 'Today',
	   'Day In Cycle' => 'Day In Cycle',

	   );

my $self = 'attaddall.pl';
my $adminuser = 'admin';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "../../lib/libschedule.pl";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

# Set Date
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
my $currdate = "$year-$month-$day";
my $currdate1 = "$month[$month] $day, $year";

my $title = $lex{'Attendance Entry'};
print qq{$doctype\n<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="$css" type="text/css">\n};

print qq{<link rel="stylesheet" type="text/css" media="all" };
print qq{href="/js/calendar-blue.css" title="blue">\n};
print qq{<script type="text/javascript" src="/js/calendar.js"></script>\n};
print qq{<script type="text/javascript" src="/js/lang/calendar-en.js"></script>\n};
print qq{<script type="text/javascript" src="/js/calendar-setup.js"></script>\n};

print qq{$chartype\n</head><body style="margin:1em 3em;">\n};

print qq{[ <a href="$homepage">$lex{Main}</a> |\n};
print qq{ <a href="$attpage">$lex{Attendance}</a> ] $currdate1\n};
print qq{<h1>$title</h1>\n};


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    doHomeroomAttendance();

} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    doSubjectAttendance();

} elsif ( $arr{page} == 3 ) {
    delete $arr{page};
    writeRecords();
}


#----------------
sub showStartPage {
#----------------
    
    # Find all teachers who do attendance and also record homerooms for them
    my $sth = $dbh->prepare("select distinct userid from staff where doatt = 'Y' order by lastname, firstname"); 
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    my $sth1 = $dbh->prepare("select field_value from staff_multi where field_name = 'homeroom'
      and userid = ?"); 

    my $sth2 = $dbh->prepare("select distinct subjsec, grade from subject s, eval e where s.teacher = ?
       and s.subjsec = e.subjcode");


    my %duplicates = ();
    my @subjectteachers;
    my @homeroomteachers;
    my %homeroomteachers;

    while ( my $userid = $sth->fetchrow ) {

	if ( $duplicates{$userid} ) { next; }

	# Homerooms
	$sth1->execute( $userid );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $first = 1;
	while ( my $hr = $sth1->fetchrow ) {
	    if ( $first ) {
		push @homeroomteachers, $userid;
		$first = 0;
	    }
	    push @{ $homeroomteachers{$userid}}, $hr;
	}

	# Now check if a subject teacher.
	$sth2->execute( $userid );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	while ( my ($subjsec, $grade) = $sth2->fetchrow ) {
	    if ( $g_AttendanceEntryMethod{$grade} eq 'subject' ) {
		push @subjects, $subjsec;
	    }
	    # print "Userid:$userid Course:$subjsec  Grade:$grade<br>\n";
	}

	if ( @subjects ) { 
	    push @subjectteachers, $userid;
	}

	$duplicates{$userid} = 1; # watch for duplicates
    }

    print qq{<table cellpadding="3" border="0" cellspacing="0">\n\n};


    # Teacher Homeroom Entry
    # Get Teacher Name
    my $sth1 = $dbh->prepare("select lastname, firstname from staff where userid = ?");

    # Homeroom Entry
    print qq{<tr><th colspan="3">$lex{'Homeroom'} $lex{'Attendance Entry'}</th></tr>\n};
    my $count = 0;

    foreach my $userid ( @homeroomteachers ) {

	# Get Name 
	$sth1->execute( $userid );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my ( $lastname, $firstname ) = $sth1->fetchrow;

	if ( $count == 0 ) { print "<tr>"; }

	my $hroom = join(',', @{$homeroomteachers{$userid}});

	
	# Do Form.
	print qq{<td><form action="$self" method="post">\n};
	print qq{<input type="hidden" name="page" value="1">\n};
	print qq{<input type="hidden" name="userid" value="$userid">\n};
	print qq{<input type="submit" value="$lastname, $firstname ($hroom)">\n};
	print qq{</form></td>\n};

	$count++;
	if ( $count % 3 == 0 ) { print "</tr>\n<tr>\n"; }
    }

    # Now clean up...
    my $remaining = 3 - ( $count % 3);
    for ( 1.. $remaining ) { print "<td></td>"; }
    print "</tr></table><p></p>\n\n";


    # Subject Entry
    if ( not @subjectteachers ) {
	print "<h3>No Subject Teacher Entry</h3>\n";
	print "</body></html>\n";
	exit;
    }
    

    # Start Form.
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";
	
    # Start Table
    print qq{<table cellpadding="3" border="0" cellspacing="0">\n\n};
    print qq{\n<tr><th colspan="3">$lex{Subject} $lex{'Attendance Entry'}</th></tr>\n\n};

    # show Date
    print qq{<tr><td colspan="3" style="font-size:120%;">$lex{'Attendance Date'} };
    print qq{<input type="text" name="date" id="date" size="12" value="$currdate">\n};
    print qq{<button type="reset" id="start_trigger">...</button></td></tr>\n\n};
    

    print "<tr>";
    my $count = 0;
    foreach my $userid ( @subjectteachers ) {

	# Get Name 
	$sth1->execute( $userid );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my ( $lastname, $firstname ) = $sth1->fetchrow;

	# Do Submit Button
	print "<td><input type=\"submit\" name=\"$userid\" value=\"$lastname, $firstname\"></td>\n";

	$count++;
	if ( $count % 3 == 0 ) { print "</tr>\n<tr>\n"; }	

    }

    # Now clean up...
    my $remaining = 3 - ( $count % 3);
    for ( 1.. $remaining ) { print "<td></td>"; }
    print "</tr>\n";
    
    print "</table></form>\n\n";
    # End of Subject Attendance Entry


    print "<script type=\"text/javascript\">
     Calendar.setup({
        inputField     :    \"date\", // id of the input field
        ifFormat       :    \"%Y-%m-%d\", // format of the input field
        button         :    \"start_trigger\", // trigger for the calendar (button ID)
        singleClick    :    false,        // double-click mode
        step           :    1             // show all years in drop-down boxes 
    })";

    print "</script>\n";

    print "</body></html>\n";
    exit;

}



#-----------------------
sub doHomeroomAttendance {
#-----------------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $userid = $arr{userid};
    delete $arr{userid};

    # Start of Form
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"3\">\n";
    print "<input type=\"hidden\" name=\"mode\" value=\"homeroom\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";

    # show Date
    print "<div style=\"font-size:120%;\">". $lex{'Attendance Date'};
    print " <input type=\"text\" name=\"date\" id=\"date\" size=\"12\" value=\"$currdate\">\n";
    print "<button type=\"reset\" id=\"start_trigger\">...</button>\n";
    print "</div>\n";


    # Get homeroom(s)! for this userid
    my $sth = $dbh->prepare("select field_value from staff_multi as sm, staff as s
      where sm.field_name = 'homeroom' and sm.userid = s.userid and s.userid = ?");
    $sth->execute( $userid );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my @homerooms;

    while ( my $homeroom = $sth->fetchrow ) {
	push @homerooms, $homeroom;

	# Find largest PPD for this homeroom
	my $maxppd;
	my $sth1 = $dbh->prepare("select distinct grade from student where homeroom = ?");
	$sth1->execute( $homeroom );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	while ( my $grade = $sth1->fetchrow ) {
	    if ( $g_ppd{$grade} > $maxppd ) {
		$maxppd = $g_ppd{$grade};
	    }
	}
	if ( not $maxppd ) {
	    print "$lex{'Periods per Day'} $lex{'Not Found'} &ndash; $lex{Homeroom}: $homeroom\n";
	    print "</body></html>\n";
	    exit;
	}
	#print "Maxppd: $maxppd<br>\n";


	# Select students from homeroom
	$sth1 = $dbh->prepare("select lastname, firstname, studnum from student 
          where homeroom = ? order by lastname, firstname");
	$sth1->execute( $homeroom );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


	print "<h1>". $lex{Homeroom}. " $homeroom</h1>\n";
	print "<p><input type=\"submit\" value=\"". $lex{'Submit Attendance'}. "\"></p>\n";
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";  

	print "<tr><th>". $lex{Student}. "</th><th>";
	for my $p ( 1..$maxppd ) {
	    print $lex{Per}. " $p</th><th>";
	}
	print $lex{Reason}. "</th><th>". $lex{Late}. "</th></tr>\n";

	while ( my ( $lastname, $firstname, $studnum ) = $sth1->fetchrow ){

	    print "<tr><td><b>$lastname</b>, $firstname</td>\n";
	    for my $p ( 1..$maxppd ) {
		print "<td><input type=\"checkbox\" name=\"$studnum:$p\" value=\"1\"></td>\n";
	    }
	    print "<td><select name=\"$studnum:Reason\"><option></option>\n";
	    
	    foreach my $reason ( @attend ) {
		print "<option>$reason</option>\n";
	    }
	    print "<option></option></select></td>\n<td>";
	    print "<input type=\"text\" name=\"$studnum:Late\" size=\"4\"></td></tr>\n";

	}

	print "</table>\n";


    } # end of homeroom loop

    print qq{<p><input type="submit" value="$lex{'Submit Attendance'}"></p>\n};
    my $homerooms = join(':', @homerooms);
    print qq{<input type="hidden" name="homeroom" value="$homerooms">};
    print "</form>\n";

    print "<script type=\"text/javascript\">
     Calendar.setup({
        inputField     :    \"date\", // id of the input field
        ifFormat       :    \"%Y-%m-%d\", // format of the input field
        button         :    \"start_trigger\", // trigger for the calendar (button ID)
        singleClick    :    false,        // double-click mode
        step           :    1             // show all years in drop-down boxes 
    })";

    print "</script>\n";
    print "</body></html>\n";

    exit;

}



#----------------------
sub doSubjectAttendance {
#----------------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my ( $date, $userid ); # only 2 values passed.
    foreach my $key ( keys %arr ) {
	if ( $key eq 'date' ) {
	    $date = $arr{$key};
	} else {
	    $userid = $key;
	}
    }

    # Start of Form
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"3\">\n";
    print "<input type=\"hidden\" name=\"mode\" value=\"subject\">\n";
    print "<input type=\"hidden\" name=\"date\" value=\"$date\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";

    # Find Day in Cycle
    my $day = findDayInCycle( $date, $dbh );

    # show Date
    print "<div style=\"font-size:130%;font-weight:bold;padding:0 0 0 1em;\">";
    print "$lex{'Attendance Date'}: $date<br>$lex{'Day In Cycle'}: $day</div>\n";

    # Find Current subjects for this teacher.
    my %subjects = findCurrentSubjects( $userid, $date, $dbh );
    print "Subjects:", %subjects, "<br>\n";

    my $sth= $dbh->prepare("select description, smdesc, grade from subject where subjsec = ?");
    my $subjcount;

    for  my $subjsec ( sort keys %subjects ) {

	# Get Subject Information
	$sth->execute( $subjsec );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	my ( $description, $smdesc, $grade ) = $sth->fetchrow;

	if ( not $subjects{$subjsec} ) { # no periods today
	    print "<h3>$description ($subjsec) $lex{Today}: $lex{'Not Found'}</h3>\n";
	    next;
	}


	# Get PPD for this subject based on grade value in subject.
	my $ppd = $g_ppd{ $grade };
	if ( not $ppd ) { 
	    print "<br clear=\"left\">\n<h3>$lex{Missing} $lex{Grade}: $description ($subjsec)</h3>\n";
	}

	# Get the Kids first... studnums.
	$sth1 = $dbh->prepare("select distinct s.studnum, s.lastname, s.firstname, s.homeroom
          from eval as e, student as s where  subjcode = ? and e.studnum = s.studnum
          order by s.lastname, s.firstname");
	$sth1->execute( $subjsec );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	# Print Start of Subject Entry Table
	$subjcount++;
	if ( $subjcount % 2 ) { print "<br clear=\"left\">\n"; }

	print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\" valign=\"top\" ";
	print "style=\"float:left; margin:1em;\">\n";
	print "<tr><th colspan=\"4\" style=\"font-size:130%;\">$description ($subjsec)</th></tr>\n";
	print "<tr><th>$lex{Student}</th><th>$lex{'Period(s)'}";
	print "</th><th>$lex{Reason}</th><th>$lex{Late}</th></tr>\n";
	print "<tr><td colspan=\"4\" align=\"center\">\n";
	print "<input type=\"reset\" value=\"". $lex{'Clear Prev Attendance'}. "\">\n";
	print "<input type=\"submit\" value=\"". $lex{'Submit Attendance'}. "\"></td></tr>\n";

	# return values in %subjects (ie. periods)
	my @periods = sort {$a <=> $b} split(/\s/, $subjects{$subjsec} );


	# Loop Through Students
	while ( my ( $studnum, $lastname, $firstname, $homeroom ) = $sth1->fetchrow ) {

	    if ( not $lastname ){  # student name not found.
		$lastname = "<span style=\"color:red;\">$lex{Student} $lex{'Not Found'}</span>";
	    }

	    # Name
	    print "<tr><td><b>$lastname</b>, $firstname ";
	    if ( $homeroom ) { print "($homeroom)"; }
	    print "</td><td>\n";

	    # Periods
	    if ( @periods ) {
		for my $p ( @periods ){ 
		    print $lex{Per}. $p;
		    print " <input type=\"checkbox\" name=\"$studnum:$subjsec:$p\" value=\"1\">\n";
		} 
	    } else {
		for my $p ( 1..$ppd ){ 
		    print $lex{Per}. $p;
		    print " <input type=\"checkbox\" name=\"$studnum:$subjsec:$p\" value=\"1\">\n";
		}
	    }

	    # Show Reason
	    print "</td><td><select name=\"$studnum:$subjsec:Reason\"><option></option>\n";
    	    foreach my $reason ( @attend ){
		print "<option>$reason</option>\n";
	    }
	    print "</select></td>";
	    print "<td><input type=\"text\" name=\"$studnum:$subjsec:Late\" size=\"4\"></td></tr>\n";

	    print "</tr>\n";

	}

	print "<tr><td colspan=\"4\" align=\"center\">\n";
	print "<input type=\"reset\" value=\"". $lex{'Clear Prev Attendance'}. "\">\n";
	print "<input type=\"submit\" value=\"". $lex{'Submit Attendance'}. "\"></td></tr>\n";
	print "</table>\n\n\n";


    } # Outer Loop here for each subject.

    print "</form>\n"; # end the form.

    print qq{</body></html>\n};

    exit;

}


#------------------
sub writeRecords {
#------------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n";}
    # exit;

    my $mode = $arr{mode};
    delete $arr{mode};
    my $date = $arr{date};
    delete $arr{date};
    my $userid = $arr{userid};
    delete $arr{userid};
    my @homerooms = split(/:/, $arr{homeroom});
    delete $arr{homeroom};


    print "<div style=\"font-size:140%;\">$lex{'Attendance Date'} $date</div>\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>$lex{Student}</th><th>$lex{Subject}</th><th>$lex{Period}</th><th>";
    print "$lex{Reason}</th><th>$lex{Late}</th></tr>\n";

    my $sth1 = $dbh->prepare("select lastname, firstname from student where studnum = ?");
    my $sth2 = $dbh->prepare("select description from subject where subjsec = ?");

    # Subject Insert
    my $sth4 = $dbh->prepare("insert into attend (studentid, absdate, reason, period, subjsec, late)
      values ( ?,?,?,?,?,? )");

    # Homeroom Insert
    my $sth6 = $dbh->prepare("insert into attend (studentid, absdate, reason, period, late)
     values ( ?,?,?,?,? )");


	    
    if ( $mode eq 'subject' ) {

	my $first = 1; # flag for attendance entry record
	foreach my $key ( sort keys %arr ) {
	    my %subjperiods; # subjperiods{subjsec}{period}

	    if ( $arr{$key} ) {  # if we have a value

		$first = 0;
		my ( $studnum, $subjsec, $period, $reason, $late );
		( $studnum, $subjsec, $period ) = split(/:/, $key );
		if ( not $period or $period =~ m/\D/ ) { next; } # skip if blank, or has text value

		# Capture Teacher periods and subjects.
		$subjperiods{$subjsec}{$period} = 1;

		my $reason = $arr{ "$studnum:$subjsec:Reason" };
		my $late = $arr{ "$studnum:$subjsec:Late" };

		# Get Student Name 
		$sth1->execute( $studnum );
		if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
		my ( $lastname, $firstname ) = $sth1->fetchrow;

		# Get Description
		$sth2->execute( $subjsec );
		if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
		my $description = $sth2->fetchrow;

		if ( not $reason ) {
		    print "<tr><td><b>$lastname</b>, $firstname ($studnum)</td><td>";
		    print "$description ($subjsec)</td><td>$period</td><td colspan=\"2\"";
		    print " style=\"color:red;\">$lex{'Attendance Reasons'} $lex{'Not Found'}";
		    print " $lex{'Skipping'}</td></tr>\n";
		    next;
		}

		# Insert the Record
		$sth4->execute( $studnum, $date , $reason, $period, $subjsec,$late );
		if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

		# Show Result
		print "<tr><td><b>$lastname</b>, $firstname ($studnum)</td><td>";
		print "$description ($subjsec)</td><td>$period</td><td>$reason</td><td>$late</td></tr>\n";

	    } # end, if we have a value
	} # end of for loop for each key


	if ( not $first ) { # Insert tattend record

	    my $sth5 = $dbh->prepare("insert into tattend ( userid, attdate, currdate, subjects, periods )
             values ( ?,?,now(),?,? )");

	    foreach my $subjsec ( keys %subjperiods ) {
		foreach my $period ( keys %{ $subjperiods{$subjsec} } ) {

		    $sth5->execute( $userid, $date, $subjsec, $period);
		    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

		} # period loop
	    } # course loop
	} # not first


    } else {  # homeroom method

	my $first = 1;
	my @periods;

	foreach my $key ( sort keys %arr ) {

	    if ( $arr{$key} ) {

		$first = 0;
		my ( $studnum, $subjsec, $period, $reason, $late );
		( $studnum, $period ) = split(/:/, $key );
		if ( not $period or $period =~ m/\D/ ) { next; } # skip if any text value or no value in $period fld.

		# Capture Teacher periods
		push @periods, $period;

		my $reason = $arr{ "$studnum:Reason" };
		my $late = $arr{ "$studnum:Late" };

		# Get Student Name
		$sth1->execute( $studnum );
		if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
		my ( $lastname, $firstname ) = $sth1->fetchrow;

		if ( not $reason ) {
		    print "<tr><td><b>$lastname</b>, $firstname ($studnum)</td><td>";
		    print "$description ($subjsec)</td><td>$period</td><td colspan=\"2\"";
		    print " style=\"color:red;\">$lex{'Attendance Reasons'} $lex{'Not Found'}";
		    print " $lex{'Skipping'}</td></tr>\n";
		    next;
		}

		# Insert the Record
		$sth6->execute( $studnum, $date, $reason, $period, $late );
		if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

		# Show Result
		print qq{<tr><td class="la">$lastname</b>, $firstname ($studnum)</td>};
		print qq{<td>$lex{None}</td><td>$period</td><td>$reason</td><td>$late</td></tr>\n};

	    } # end, if value
	} # end, for loop for each key

	if ( not $first ) { # Insert tattend record (subject, homeroom done above)
	    my $sth5 = $dbh->prepare("insert into tattend ( userid, attdate, currdate, subjects, periods )
             values ( ?,?,now(),?,? )");

	    foreach my $period ( @periods ) {
		foreach my $hr ( @homerooms ) {
		    my $subject = "HR:$hr";
		    $sth5->execute( $userid, $date, $subject, $period);
		    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
		}
	    }

	} # tattentry end
    } # end homeroom method

    print "</table>\n";


    print "<h1>$lex{'Record(s) Stored'}</h1>\n";

    print "[ <a href=\"$homepage\">$lex{Main}</a> |\n";
    print " <a href=\"$attpage\">$lex{Attendance}</a> |\n";
    print " <a href=\"$self\">$lex{More}</a> ]\n";

    print "</body></html>\n";

    exit;

}


#----------------
sub dateNormalize {
#----------------
    my $date = shift;
    my ($year,$month,$day) = split /-/, $date;
    if ( length( $month ) == 1 ) { $month = '0'. $month; } # prepend 0
    if ( length( $day ) == 1 ) { $day = '0'. $day; } # prepend 0
    $date = "$year$month$day";

    return $date;

}
