#!/usr/bin/perl
#  Copyright 2001-2011 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Eoy' => 'Eoy',
	   'Configuration' => 'Configuration',
	   'Error' => 'Error',
	   'File' => 'File',
	   'Update' => 'Update',
	   'Main' => 'Main',
	   'Not Defined' => 'Not Defined',

	   );

my $self = 'confupdate_file.pl';
my $defaultEtcPath = '../../etc';


use DBI;
use CGI;
use Data::Dumper;

$Data::Dumper::Purity = 1;
$Data::Dumper::Indent = 0;


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

# Set Path to etc directory
if ( not $g_EtcPath ) {
    $g_EtcPath = $defaultEtcPath;
}


my $q = CGI->new;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;


# Page Header
print "$doctype\n<html><head><title>$lex{Update} $lex{Configuration} - $lex{File}</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">$lex{Main}</a> | <a href=\"$eoypage\">$lex{Eoy}</a> |\n";
print "<a href=\"$self\">$lex{Start}</a> ]\n";

print "<h1>$lex{Update} $lex{Configuration} - $lex{File}</h1>\n";



# Select Main Filename Sections
my $sth = $dbh->prepare("select distinct filename from conf_system order by filename desc"); 
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

my $sth1 = $dbh->prepare("select id, dataname, datatype, datavalue from conf_system 
 where filename = ? order by dataname"); 

my $sth2 = $dbh->prepare("update conf_system set datavalue = ? where id = ?");


while ( my $filename = $sth->fetchrow ) {

    my $fullfilename = $filename. '.conf';

    # Pull in the file and eval values.
    eval require "$g_EtcPath/$fullfilename";
    if ( $@ ) {
	print "$lex{Error}: $@<br>\n";
	die "$lex{Error}: $@\n";
    }

    print "<h3>$fullfilename</h3>\n";

#	foreach my $key ( sort keys %main:: ) { print "$key "; }
#	print "\n\n";

    $sth1->execute( $filename );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    while ( my ( $id, $dataname, $datatype, $datavalue ) = $sth1->fetchrow ) {

	my $value_ref = [ ];
	my $name_ref = [ ];

	# skip any undefined values
	if ( not defined *$dataname  ) { 
	    print "$dataname $lex{'Not Defined'}<br>\n";
	    next; 
	}

	# Scalar
	if ( $datatype eq 'scalar' or $datatype eq 'scalaronoff' ) {

	    push @$name_ref, $dataname;
	    push @$value_ref, $$dataname;
	
	    my $d = Data::Dumper->new( $value_ref, $name_ref );
	    my $dv = $d->Dump;

	    if ( $dv eq $datavalue ) { next; } # skip this variable.
	    

	    print "SCALAR:<br>\nNew:$dv<br>\nOrg:$datavalue<br>\n";
	    $sth2->execute( $dv, $id );

	} elsif ( $datatype eq 'array' ) {

	    $dataname = '*'. $dataname;
	    push @$name_ref, $dataname;
	    push @$value_ref, \@$dataname;

	    my $d = Data::Dumper->new( $value_ref, $name_ref );
	    my $dv = $d->Dump;

	    if ( $dv eq $datavalue ) { next; } # skip this variable.

	    print "ARRAY:<br>\nNew:$dv<br>\nOrg:$datavalue<br>\n";
	    $sth2->execute( $dv, $id );


	} elsif ( ( $datatype eq 'hash' ) or ($datatype eq 'hashofarray')  ) {

	    $newdataname = '*'. $dataname;
	    push @$name_ref, $newdataname;
	    push @$value_ref, \%$dataname;

	    my $d = Data::Dumper->new( $value_ref, $name_ref );
	    my $dv = $d->Dump;

	    if ( $dv eq $datavalue ) { next; } # skip this variable.

	    print "HASH:<br>\nNew:$dv<br>\nOrg:$datavalue<br>\n";
	    $sth2->execute( $dv, $id );

	} else {
	    print "<br>UNKNOWN - $dataname - $datavalue<br><br>\n";
	}
    } # end of data loop

    print "\n\n";


} # end of filename loop

print "</body></html>\n";
