#!/usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


my %lex = ('Student Discipline' => 'Student Discipline',
	   'Student Search' => 'Student Search',
	   'Main' => 'Main',
	   'Discipline' => 'Discipline',
	   'Entry' => 'Entry',
	   'Date' => 'Date',
	   'Student Number' => 'Student Number',
	   'Infraction' => 'Infraction',
	   'Description' => 'Description',
	   'Action Taken' => 'Action Taken',
	   'Repeated Behavior Consequence' => 'Repeated Behavior Consequence',
	   'Parental Contact' => 'Parental Contact',
	   'None' => 'None',
	   'Phoned' => 'Phoned',
	   'Letter' => 'Letter',
	   'Interview' => 'Interview',
	   'Caregiver' => 'Caregiver',
	   'Private (to Admin)' => 'Private (to Admin)',
	   'Author' => 'Author',
	   'Save' => 'Save',
	   'Last,First/Last/Initials/Studnum' => 'Last,First/Last/Initials/Studnum',
	   'Search' => 'Search',
	   'Add' => 'Add',
	   'Student' => 'Student',
	   'No Student(s) Found' => 'No Student(s) Found',
	   'Error' => 'Error',
	   'Demerit' => 'Demerit',

	  );


my $self = 'discadd0.pl';

use DBI;
use CGI;

my @time = localtime(time);
my $year = $time[5] + 1900;
my $month = $time[4] + 1;
my $currdate = "$year-$month-$time[3]";

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

# Print Start of HTML Document.
my $title = "$lex{Add} $lex{Discipline} $lex{Entry}";

print "$doctype\n<html><head><title>$title</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";

if ( $arr{page} == 2 ) { # entry page.

    print "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" ";
    print "href=\"/js/calendar-blue.css\" title=\"blue\">\n";
    print "<script type=\"text/javascript\" src=\"/js/calendar.js\"></script>\n";
    print "<script type=\"text/javascript\" src=\"/js/lang/calendar-en.js\"></script>\n";
    print "<script type=\"text/javascript\" src=\"/js/calendar-setup.js\"></script>\n";

}

print "$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">$lex{Main}</a> | ";
print "<a href=\"$discpage\">$lex{Discipline}</a> ]\n";


print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
print "<input type=\"submit\" value=\"$lex{Search}\">\n";
print "<input type=\"text\" name=\"student\" size=\"30\">\n";
print "$lex{Student} ($lex{'Last,First/Last/Initials/Studnum'})</form>\n";

print "<h1>$title</h1>\n";


if ( not $arr{page} ) {
    showSearchForm();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    selectStudent();

} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    addRecord();
}


#------------
sub addRecord {
#------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }


    # Get student name.
    my $sth = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");
    $sth->execute( $arr{studnum} );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth->fetchrow;


    # Stuff Infractions into an array.
    my @infarray;
    my $sth = $dbh->prepare("select name from infraction order by name");
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    while (my $name = $sth->fetchrow ) {
	push @infarray, $name;
    }


    # Load Teachers Into Array
    my (%teacher, @teacher);
    $sth = $dbh->prepare("select lastname, firstname, userid from staff
      order by lastname,firstname");
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die;}
    while ( my ($lastname, $firstname, $userid) = $sth->fetchrow ){
	push @teacher, $userid;
	$teacher{$userid} = "$lastname, $firstname";
    }


    # Start Form
    print "<form action=\"discadd1.pl\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"studnum\" value=\"$arr{studnum}\">\n";

    print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"0\">\n";

    print "<tr><td></td><td><input type=\"submit\" value=\"$lex{Save}\"></td></tr>\n";

    print "<tr><td class=\"bra\">$lex{Date}</td>\n";
    print "<td><input type=\"text\" name=\"date\" id=\"date\" size=\"12\" value=\"$currdate\">\n";
    print " <button type=\"reset\" id=\"trigger\">...</button>";
    print "</td></tr>\n";

    print "<tr><td class=\"bra\">$lex{'Student Number'}</td><td>$arr{studnum}</td></tr>\n";
    print "<tr><td class=\"bra\">$lex{Student}</td><td>$firstname $lastname</td></tr>\n";


    print "<tr><td class=\"bra\">$lex{Infraction}</td><td><select name=\"mistake\">\n";

    foreach my $inf ( @infarray ) {
	print "<option>$inf</option>\n";
    }

    print "</select></td></tr>\n";


    print "<tr><td class=\"bra\">$lex{Description}</td>";
    print "<td><textarea name=\"description\" cols=\"60\" rows=\"6\"></textarea></td></tr>\n";

    print "<tr><td class=\"bra\">$lex{'Action Taken'}</td>\n";
    print "<td><textarea name=\"action\" cols=\"60\" rows=\"4\"></textarea></td></tr>\n";

    print "<tr><td class=\"bra\">$lex{'Repeated Behavior Consequence'}</td>\n";
    print "<td><textarea name=\"ifrepeat\" rows=\"4\" cols=\"60\"></textarea></td></tr>\n";

    print "<tr><td class=\"bra\">$lex{'Demerit'}</td>\n";
    print "<td><input type=\"text\" size=\"5\" name=\"demerit\"></td></tr>\n";

    print "<tr><td class=\"bra\">$lex{'Parental Contact'}</td>\n<td>";
    print "<input type=\"radio\" name=\"parent\" value=\"none\" checked> $lex{None}&nbsp;&nbsp;\n";
    print "<input type=\"radio\" name=\"parent\" value=\"phoned\"> $lex{Phoned}&nbsp;&nbsp;\n";
    print "<input type=\"radio\" name=\"parent\" value=\"letter\"> $lex{Letter}&nbsp;&nbsp;\n";
    print "<input type=\"radio\" name=\"parent\" value=\"interview\"> $lex{Interview} ($lex{Caregiver})";
    print "</td></tr>\n";

    print "<tr><td class=\"bra\">$lex{'Private (to Admin)'}</td>\n";
    print "<td><input type=\"checkbox\" name=\"private\" value=\"Y\"></td></tr>\n";

    print qq{<tr><td class="bra">$lex{'Author'}</td><td><select name="author"><option></option>\n};

    foreach my $userid ( @teacher) {
	print qq{<option value="$teacher{$userid} ($userid)">$teacher{$userid}</option>\n};
    }

    print qq{</select></td></tr>\n};

    print "<tr><td></td><td><input type=\"submit\" value=\"$lex{Save}\"></td></tr>\n";
    print "</table></form>\n";

    print "<script type=\"text/javascript\">
     Calendar.setup({
        inputField     :    \"date\", // id of the input field
        ifFormat       :    \"%Y-%m-%d\", // format of the input field
        button         :    \"trigger\", // trigger for the calendar (button ID)
        singleClick    :    false,        // double-click mode
        step           :    1             // show all years in drop-down boxes 
    });\n";

    print "</script>\n";

    print "</body></html>\n";

    exit;

}


#----------------
sub selectStudent {
#----------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $student = $arr{student};

    # Setup the Search
    if ($student =~ /\d+/) {  # we have a student number
	$sth = $dbh->prepare("select lastname, firstname, studnum from studentall where studnum = ?");
	$sth->execute( $student );

    } else { # we have words hopefully with a comma
	($lastname,$firstname)  = split /\,/, $student;
	$firstname =~ s/^\s*//;
	$lastname =~ s/^\s*//;
	if ($lastname and $firstname){ # both entered.
	    $sth = $dbh->prepare("select  lastname, firstname, studnum from studentall 
             where lastname = ? and firstname = ?");
	    $sth->execute( $lastname, $firstname );

	} elsif ($lastname and not $firstname){ # only lastname (no comma)
	    if (length($lastname) == 2){ # search by initials: fi, li.
		my $fi = substr($lastname,0,1). '%'; 
		my $li = substr($lastname,1,1). '%';
		$sth = $dbh->prepare("select lastname, firstname, studnum from studentall 
                 where lastname $sql{like} ? and firstname $sql{like} ?");
		$sth->execute( $li, $fi );

	    } else {
		$sth = $dbh->prepare("select lastname, firstname, studnum from studentall 
                  where lastname = ? order by firstname");
		$sth->execute( $lastname );
	    }
	} else { # not found
	    print "<h3>$lex{'No Student(s) Found'}</h3>\n";
	    showSearchForm();
	    print "</body></html>\n";
	    exit;
	}

    } # Last Else
    # We should now have a $sth defined.

    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $rows = $sth->rows;

    if ( $rows < 1) { # not found
	print "<h3>$lex{'No Student(s) Found'}</h3>\n";
	showSearchForm();
	print "</body></html>\n"; 
	exit; 
    }
 

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>Student</th><th></th></tr>\n";

    for ( 1..$rows ){
	my ($lastname, $firstname, $studnum) = $sth->fetchrow;
	print "<tr><td>$firstname $lastname ($studnum)</td><td>\n";
	print "<form action=\"$self\" method=\"post\"><input type=\"submit\" value=\"$lex{Add}\">\n";
	print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";
	print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
	print "</form></td></tr>\n";

    }

    print "</table>\n";
    
    showSearchForm();
    print "</center></body></html>\n";

    exit;

}


#----------------
sub showSearchForm {
#----------------

    print "<div style=\"padding:1em 0.2em;\">\n";
    print "<h3>$lex{'Student Search'}</h3>\n";

    print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
    print "<input type=\"submit\" value=\"$lex{Search}\">\n";
    print "<input type=\"text\" name=\"student\" size=\"30\"><br>\n";
    print "$lex{Student} ($lex{'Last,First/Last/Initials/Studnum'})\n";
    print "</form></div>\n";

}

