#!/usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('Student Not Found' => 'Student Not Found',
	   'Back!' => 'Back!',
	   'Student Discipline Entry' => 'Student Discipline Entry',
	   'Main' => 'Main',
	   'Discipline' => 'Discipline',
	   'Name Validation' => 'Name Validation',
	   'Name' => 'Name',
	   'Error' => 'Error',
	   'Missing' => 'Missing',
	   'Author' => 'Author',

	  );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

my $studnum = 0;
if ( $arr{studname} ) {
    ($dud,$studnum) = split('/',$arr{studname} );
    chop $studnum;  # to get rid of trailing )
}
if ($arr{studnum}) {
    $studnum = $arr{studnum};
}

my $sth = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");
$sth->execute( $studnum );
if ($DBI::errstr ) { print $DBI::errstr; print $DBI::errstr; }
my $rows = $sth->rows;
my ($lastname, $firstname) = $sth->fetchrow;

my $title = $lex{'Student Discipline Entry'};
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "</head><body>\n";


print qq{[ <a href="$homepage">$lex{Main}</a> | \n};
print qq{<a href="$discpage">$lex{Discipline}</a> ]\n};


if ( not $arr{author} ) {
    print qq{<h3>$lex{Missing} $lex{Author}</h3>\n};
    print qq{</body></html>\n};
    exit;
}


if ($rows < 1) {
    print qq{<h2>$lex{'Student Not Found'}</h2>\n};
    print "<form><input type=\"button\" onclick=\"javascript:history.back()\" value=\"";
    print $lex{'Back!'}. "\"></form></body></html>\n";

    exit; 
}


$arr{description} =~ s/"/&quot;/g;
$arr{action} =~ s/"/&quot;/g;
$arr{ifrepeat} =~ s/"/&quot;/g;

print "<h1>". $lex{'Name Validation'}. "</h1>\n";
print "<p>". $lex{Name}. ": <b>$lastname</b>, $firstname</p>\n";
print "<form action=\"discadd2.pl\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"date\" value=\"$arr{date}\">\n";
print "<input type=\"hidden\" name=\"author\" value=\"$arr{author}\">\n";
print "<input type=\"hidden\" name=\"private\" value=\"$arr{private}\">\n";
print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
print "<input type=\"hidden\" name=\"mistake\" value=\"$arr{mistake}\">\n";
print "<input type=\"hidden\" name=\"description\" value=\"$arr{description}\">\n";
print "<input type=\"hidden\" name=\"action\" value=\"$arr{action}\">\n";
print "<input type=\"hidden\" name=\"ifrepeat\" value=\"$arr{ifrepeat}\">\n";
print "<input type=\"hidden\" name=\"parent\" value=\"$arr{parent}\">\n";
print "<input type=\"hidden\" name=\"demerit\" value=\"$arr{demerit}\">\n";
print "<input type=\"submit\" value=\"Continue\"></form>\n";

print "</body></html>\n";
