#!/usr/bin/perl
#  Copyright 2001-2011 Leslie Richardson
#  Update by Kevin Waddell

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Add' => 'Add',
	   'Discipline' => 'Discipline',
	   'Record(s) Stored' => 'Record(s) Stored',
	   'Mistake' => 'Mistake',
	   'Description' => 'Description',
	   'Action' => 'Action',
	   'If Repeated' => 'If Repeated',
	   'Parent Contact' => 'Parent Contact',
	   'Author' => 'Author',
	   'Main' => 'Main',
	   'Add Another' => 'Add Another',
	   'Contact' => 'Contact',
	   'Please record the following error' => 'Please record the following error',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

# Reverse quoting from previous script.
$arr{description} =~ s/&quot;/\\"/g;
$arr{action} =~ s/&quot;/\\"/g;
$arr{ifrepeat} =~ s/&quot;/\\"/g;

# quote all items.
foreach my $key (keys %arr ) {
    if ( $arr{$key} ) {
	$arr{$key} = $dbh->quote( $arr{$key} );
    } else {
	$arr{$key} = $sql{default};
    }
}

#foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }


my $sth = $dbh->prepare("insert into discipline values (
 $sql{default}, $arr{date}, $arr{studnum}, $arr{mistake},
 $arr{description}, $arr{action}, $arr{ifrepeat},
 $arr{parent}, $arr{author}, $arr{private}, $arr{demerit} )");

$sth->execute;

print "$doctype\n<html><head><title>$lex{Add} $lex{Discipline}</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

if ( not $DBI::errstr ) {

    foreach my $key ( keys %arr ) { $arr{$key} =~ s/\\//g; } # strip backslashes for display.
    print "<h3>$lex{'Record(s) Stored'}</h3>\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><td align=\"right\">". $lex{Mistake}. "</td><td>$arr{mistake}</td></tr>\n";
    print "<tr><td align=\"right\">". $lex{Description}. "</td><td>$arr{description}</td></tr>\n";
    print "<tr><td align=\"right\">". $lex{Action}. "</td><td>$arr{action}</td></tr>\n";
    print "<tr><td align=\"right\">". $lex{'If Repeated'}. "</td><td>$arr{ifrepeat}</td></tr>\n";
    print "<tr><td align=\"right\">". $lex{'Parent Contact'}. "</td><td>$arr{parent}</td></tr>\n";
    print "<tr><td align=\"right\">". $lex{Author}. "</td><td>$arr{author}</td></tr>\n";
    print "</table>\n";


    print "<p> [ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
    print "<a href=\"$discpage\">$lex{Discipline}</a> | \n";
    print "<a href=\"discadd0.pl\">$lex{'Add Another'}</a> ]</p>\n";

} else {

    print "<h3>$lex{Error}<br>\n";
    print $lex{Contact};
    print " <a href=\"mailto:$adminemail\">$adminemail</a><br>\n ";
    print $lex{'Please record the following error'}. "$DBI::errstr;</h3>\n";

    print "<p>[ <a href=\"$discpage\">$lex{Discipline}</a> ]</p>";

}

print "</body></html>\n";
