#!/usr/bin/perl
#  Copyright 2001-2013 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('Discipline Records' => 'Discipline Records',
	   'by Date' => 'by Date',
	   'Delete' => 'Delete',
	   'Before' => 'Before',
	   'Delete Records' => 'Delete Records',
	   'Date' => 'Date',
	   'Missing' => 'Missing',
	   'Failed' => 'Failed',
	   'Main' => 'Main',
	   'Discipline' => 'Discipline',
	   'Error' => 'Error',
	   'Yes' => 'Yes',
	   'Records Deleted' => 'Records Deleted',
	   'Contact' => 'Contact',
	   'Password' => 'Password',
	   'Continue' => 'Continue',

	   );

my $self = 'discdatedel.pl';
my $delpassword = 'badidea';

use CGI;
use DBI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@<br>\n";
}


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


# Page Header.
my $title = "$lex{Delete} $lex{'Discipline Records'}";
print "$doctype\n<html><head><title>$title</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";

if ( not $arr{page} ) {

    print "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" ";
    print "href=\"/js/calendar-blue.css\" title=\"blue\">\n";
    print "<script type=\"text/javascript\" src=\"/js/calendar.js\"></script>\n";
    print "<script type=\"text/javascript\" src=\"/js/lang/calendar-en.js\"></script>\n";
    print "<script type=\"text/javascript\" src=\"/js/calendar-setup.js\"></script>\n";

}

print "$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">$lex{Main}</a> | ";
print "<a href=\"$discpage\">$lex{Discipline}</a> ]\n";

print "<h1>$title</h1>\n";


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    showRecords();

} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    deleteRecords();
}



#----------------
sub showStartPage {
#----------------

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<table cellspacing=\"0\" border=\"0\" cellpadding=\"3\">\n";

    print "<tr><td class=\"bra\">$lex{Password}</td><td class=\"la\">\n";
    print "<input type=\"text\" name=\"delpassword\" size=\"12\">\n";
    print "</td></tr>\n";

    print "<tr><td class=\"bra\">$lex{Delete} $lex{Records} $lex{Before}</td><td class=\"la\">\n";
    print "<input type=\"text\" name=\"deldate\" size=\"12\" id=\"deldate\">\n";
    print "<button type=\"reset\" id=\"start_trigger\">...</button>";
    print "</td></tr>\n";

    print "<tr><td></td><td class=\"la\"><input type=\"submit\" value=\"$lex{Continue}\">\n";
    print "</td></tr></table></form>\n";

    print "<script type=\"text/javascript\">
     Calendar.setup({
        inputField     :    \"deldate\", // id of the input field
        ifFormat       :    \"%Y-%m-%d\", // format of the input field
        button         :    \"start_trigger\", // trigger for the calendar (button ID)
        singleClick    :    false,        // double-click mode
        step           :    1             // show all years in drop-down boxes 
    })";

    print "</script>\n";
    print "</body></html>\n";

    exit;

}


#--------------
sub showRecords {
#--------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    if ( $arr{delpassword} ne $delpassword ) {
	print "<h3>$lex{Password} $lex{Error}</h3>\n";
	print "</body></html>\n";
	exit;
    }

    if ( not $arr{deldate} ){ 
	print "<h3>$lex{Date} $lex{Missing}</h3>\n";
	print "</body></html>\n";
	exit;
    }

    my ( $year, $month, $day, $date);
    if ( length( $arr{deldate} ) == 6 ) { # older yymmdd format
	($year, $month, $day ) = unpack("A2,A2,A2",$arr{deldate});
	print "Y:$year M:$month D:$day<br>\n";
	$year = "20".$year;
	$date = "$year-$month-$day";
    } else {
	($year, $month, $day ) = split /-/, $arr{deldate};
	$date = $arr{deldate};
    }
    
    if ( not $year or not $month or not $day ) {
	print "<h3>$lex{Date} $lex{Error}: $arr{deldate}</h3>\n";
	exit;
    }

    # print "Date:$date<br>\n";

    my $displaydate = "$month[$month] $day, $year";

    print "<h3>$lex{Delete} $lex{Before}: $displaydate</h3>\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"deldate\" value=\"$date\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";
    print "<input type=\"submit\" value=\"$lex{Yes}, $lex{'Delete Records'}\">\n";
    print "</form>\n";

    print "<p>[ <a href=\"$discpage\">$lex{Discipline}</a> ]</p>\n";
    print "</body></html>\n";

    exit;

}



#----------------
sub deleteRecords {
#----------------

    #foreach my $key (sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my ($year, $month, $day ) = split /-/, $arr{deldate};
    my $displaydate = "$month[$month] $day, $year";

    my $dsn = "DBI:$dbtype:dbname=$dbase";
    my $dbh = DBI->connect($dsn,$user,$password);
    $dbh->{mysql_enable_utf8} = 1;

    my $sth = $dbh->prepare("delete from discipline where to_days(date) < to_days('$arr{deldate}')");
    my $result = $sth->execute;

    if ($DBI::errstr) {
	print "$lex{Error}: $DBI::errstr<br>\n";
	print "$lex{Contact}: $adminname<br>\n";

    } else {
	print "<h1>$result $lex{'Records Deleted'} << $displaydate</h1>\n";
    }

    print "</body></html>\n";

    exit;

}
