#!/usr/bin/perl
#  Copyright 2001-2013 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Discipline Record(s)' => 'Discipline Record(s)',
	   'Main' => 'Main',
	   'Discipline' => 'Discipline',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Not Found' => 'Not Found',
	   'Student' => 'Student',
	   'Date' => 'Date',
	  );	   

use DBI;
use CGI;

my $q = CGI->new;
print $q->header; 

require "../../etc/admin.conf" or die "Cannot read admin.conf!";

my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
    $yday, $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
$dow++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

my $title = "$lex{Edit}/$lex{Delete} $lex{'Discipline Record(s)'}";

print "$doctype\n<html><head><title>$title</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">$lex{Main}</a> | \n";
print "<a href=\"$discpage\">$lex{Discipline}</a> ]\n";

print "<h1>$title</h1>\n";

print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";
print "<tr><th>$lex{Date}</th><th>$lex{Student}</th><th>$lex{Edit}</th><th>$lex{Delete}</th></tr>\n";


my $sth = $dbh->prepare("select d.id, d.date, d.userid from discipline as d, studentall s 
   where d.userid = s.studnum order by d.date desc, s.lastname, s.firstname");
$sth->execute;
if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr; }


my $sth1 = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");

while ( my ($id, $date, $studnum) = $sth->fetchrow ) {

    # Get Name
    $sth1->execute( $studnum );
    my ($lastname, $firstname) = $sth1->fetchrow;
    if (not $lastname) { $lastname = "<span style=\"color:red;\">$lex{'Not Found'}</span>"; }
  
    print "<tr><td>$date</td><td>$firstname $lastname ($studnum)</td>\n";

    # Edit
    print qq{<td><form action="disced0.pl" method="post">\n};
    print qq{<input type="hidden" name="id" value="$id">\n};
    print qq{<input type="submit" value="$lex{Edit}"></form></td>\n};

    # Delete
    print qq{<td><form action="discdel0.pl" method="post">\n};
    print qq{<input type="hidden" name="id" value="$id">\n};
    print qq{<input type="submit" value="$lex{Delete}"></form></td>\n};

    print "</tr>\n";

}

print "</table></body></html>\n";
