#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson
#  Update by Kevin Waddell

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# NOTE: No editing of 'author' field present. This is property of record.

my %lex = ('Edit' => 'Edit',
	   'Main' => 'Main',
	   'Discipline' => 'Discipline',
	   'Author' => 'Author',
	   'Date' => 'Date',
	   'Student Number' => 'Student Number',
	   'Infraction' => 'Infraction',
	   'Description' => 'Description',
	   'Action Taken' => 'Action Taken',
	   'Repeated Behavior Consequence' => 'Repeated Behavior Consequence',
	   'Parental Contact' => 'Parental Contact',
	   'Private' => 'Private',
	   'Save' => 'Save',
	   'Error' => 'Error',
	   'Demerit' => 'Demerit',


	  );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

my $sth = $dbh->prepare("select * from discipline where id = ?"); 
$sth->execute( $arr{id} );

my ( $id, $date, $userid, $infraction,$description, $action,
     $ifrepeat, $parent, $author, $private, $demerit ) = $sth->fetchrow;

print "$doctype\n<html><head><title>". $lex{Edit}. q{ }. $lex{Discipline}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | <a href=\"$discpage\">". $lex{Discipline}. "</a> ]\n";
print "<center><h1>". $lex{Edit}. q{ }. $lex{Discipline}. "</h1>\n";
print "<form action=\"disced1.pl\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";

print "<center><input type=\"submit\" value=\"". $lex{Save}. "\"></center>\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

print "<tr><td align=\"right\"><b>". $lex{Author}. "</b></td>";
print "<td>$author</td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{Date}. "</b></td>\n";
print "<td><input type=\"text\" name=\"date\" size=\"11\" value=\"$date\"></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Student Number'}. "</b></td>\n";
print "<td>$userid</td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{Infraction}. "</b></td>\n";
print "<td><input type=\"text\" name=\"infraction\" size=\"30\" value=\"$infraction\" ></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{Description}. "</b></td>\n";
print "<td><textarea name=\"description\" cols=\"60\" rows=\"6\">$description</textarea></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Action Taken'}. "</b></td>\n";
print "<td><textarea name=\"action\" cols=\"60\" rows=\"4\">$action</textarea></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Repeated Behavior Consequence'}. "</b></td>\n";
print "<td><textarea name=\"ifrepeat\" rows=\"4\" cols=\"60\">$ifrepeat</textarea></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{Demerit}. "</b></td>\n";
print "<td><input type=\"text\" name=\"demerit\" size=\"5\" value=\"$demerit\"></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Parental Contact'}. "</b></td>\n";
print "<td><input type=\"text\" name=\"parent\" size=\"12\" value=\"$parent\"></td></tr>\n";

my $checked;
if ( $private ) { $checked = 'checked="checked"'; } 

print "<tr><td align=\"right\"><b>". $lex{Private}. "</b></td>\n";
print "<td><input type=\"checkbox\" name=\"private\" value=\"1\" $checked></td></tr>\n";

print "</table><center>
<input type=\"submit\" value=\"". $lex{Save}. "\"></center></form>\n";

print "</center></body></html>\n";
