#!/usr/bin/perl
#  Copyright 2001-2013 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Add' => 'Add',
	   'Infraction Type' => 'Infraction Type',
	   'Main' => 'Main',
	   'Discipline' => 'Discipline',
	   'Error' => 'Error',
	   'Contact' => 'Contact',
	   'Record(s) Stored' => 'Record(s) Stored',
	   'Save' => 'Save',
	   
	   );

use DBI;
use CGI;

my $self = 'infadd.pl';
my $maxentries = 6; # number of entries


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;



my $title = "$lex{Add} $lex{'Infraction Type'}";
print "$doctype\n<html><head><title>$title</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">$lex{Main}</a> | \n";
print "<a href=\"$discpage\">$lex{Discipline}</a> ]\n";


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

print "<h1>$title</h1>\n";

if ( not $arr{page} ) {
    showStartPage();

} else {
    delete $arr{page};
    addRecords();
}


#----------------
sub showStartPage {
#----------------

    print "<table><tr><td width=\"90%\">\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<table cellpadding=\"8\"><tr><th>$lex{'Infraction Type'}</th></tr>\n";
    for my $i ( 1 .. $maxentries ) {
	my $catnum = 'cat'. $i;
	print "<tr><td><input type=\"text\" name=\"$catnum\" size=\"40\"></td></tr>\n";
    }

    print "<tr><td class=\"cn\"><input type=\"submit\" value=\"$lex{Save}\"></td></tr>\n";
    print "</form></body></html>\n";

    exit;

}


#-------------
sub addRecords {
#-------------

    for my $i (1..$maxentries) {

	my $category = "cat$i";
	if ($arr{$category}) { # We have a value

	    $sth = $dbh->prepare("insert into infraction (name) values ( ? )");
	    $sth->execute( $arr{$category} );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

	}
    }


    if (not $DBI::errstr ) {
	print "<h3>$lex{'Record(s) Stored'}</h3></p>\n";

    } else {
	print "<h3>$lex{Error}: $DBI::errstr;<br>\n";
	print "$lex{Contact} $adminname <a href=\"mailto:$adminemail\">$adminname</a></h3>\n";
    }

    print "<p>[ <a href=\"$discpage\">$lex{Discipline}</a> | \n";
    print "<a href=\"catadd.pl\">$lex{Add} $lex{'Infraction Types'}</a> ]\n";
    print "</p></body></html>\n";

    exit;
}
