#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('View Discipline Entries' => 'View Discipline Entries',
	   'Main' => 'Main',
	   'Discipline' => 'Discipline',
	   'Start' => 'Start',
	   'End' => 'End',
	   'Name' => 'Name',
	   'Infract/Par' => 'Infract/Par',
	   'Description' => 'Description',
	   'Action' => 'Action',
	   'Error' => 'Error',
	   'Demerit(s)' => 'Demerit(s)',
	   'Private' => 'Private',
	   'Repeat' => 'Repeat',
	   'Total' => 'Total',
	   'Parent' => 'Parent',

	   );

use DBI;
use CGI;

my @time = localtime(time);
my $year = $time[5] + 1900;
my $month = $time[4] + 1;
my $currdate = "$year-$month-$time[3]";

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
%arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

if ( not $arr{edate} ) {
    $arr{edate} = $currdate;
}    
if ( not $arr{sdate} ) {
    $arr{sdate} = $schoolstart;
}


if ($arr{sort} eq 'a') {
    $sortorder = "date, userid";
} else {
    $sortorder = "date desc, userid";
}
my $sth = $dbh->prepare("select date, userid, infraction, description, action, 
 ifrepeat, parent, author, private, demerit from discipline order by date desc, userid");

$sth = $dbh->prepare("select date, userid, infraction, description, action, 
  ifrepeat, parent, author, private, demerit from discipline 
  where to_days(discipline.date) >= to_days('$arr{sdate}') and 
  to_days(discipline.date) <= to_days('$arr{edate}') 
  order by $sortorder");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
$rows = $sth->rows;

print "$doctype\n<html><head><title>". $lex{'View Discipline Entries'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> | 
<a href=\"$discpage\">". $lex{Discipline}. "</a> ]\n";

print "<center><h1>". $lex{'View Discipline Entries'}. "</h1>
<p><b>". $lex{Start}. ":</b> $arr{sdate} <b>". $lex{End}. ":</b> $arr{edate}</p>\n
<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">
<tr><th>". $lex{Name}. "</th><th>". $lex{'Infract/Par'}. "</th><th>". $lex{Description}. "</th>
<th>". $lex{Action}. "</th></tr>\n";

my $sth1 = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");

my $totaldemerit;
while ( my ( $date, $userid, $infraction,$description, $action, $ifrepeat, 
	     $parent, $author, $private, $demerit ) = $sth->fetchrow ) {

    $totaldemerit += $demerit;
    $sth1->execute( $userid );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth1->fetchrow;

    print "<tr><td><b>$date<br>$firstname $lastname</b><br>($userid)</td>\n";
    print "<td>$infraction<br><b>". $lex{Parent}. ":</b> $parent<br><b>";
    print $lex{Private}. ":</b> $private</td><td>$description</td><td>$action<br><b>";
    print $lex{Repeat}. ":</b> $ifrepeat<br>". $lex{'Demerit(s)'}. " $demerit</td></tr>\n";

}

#print "<tr><td colspan=\"4\">". $lex{Total}. q{ }. $lex{'Demerit(s)'};
#print " $totaldemerits</td></tr>\n";


print "</table></center></body></html>\n";

