#!/usr/bin/perl
#  Copyright 2001-2013 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Student Infractions' => 'Student Infractions',
	   'by Date' => 'by Date',
	   'Main' => 'Main',
	   'Discipline' => 'Discipline',
	   'Click on Student Name to view their records' => 
	     'Click on Student Name to view their records',
	   'only' => 'only',
	   'Student' => 'Student',
	   'Last,First/Last/Initials/Studnum' => 
	     'Last,First/Last/Initials/Studnum',	   
	   'Search' => 'Search',
	   'Error' => 'Error',
	   'Demerit(s)' => 'Demerit(s)',
	   'If Repeated' => 'If Repeated',
	   'Parent' => 'Parent',
	   'Private' => 'Private',
	   'Total' => 'Total',
	   'Summary' => 'Summary',
	   'Blank=All' => 'Blank=All',

	   );

my $self = 'rptstud.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $student = $arr{student};
delete $arr{student};
# summary, page also passed.


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

my $title = "$lex{'Student Infractions'} $lex{'by Date'}";
print "$doctype\n<html><head><title>$title</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">$lex{Main}</a> | \n";
print "<a href=\"$discpage\">$lex{Discipline}</a> ]\n";
if ( $arr{page} ) { showSearchForm(); }

print "<h1>$title</h1></td>";


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    showInfractions();
}




#----------------
sub showStartPage {
#----------------

    print qq{<form action="$self" method="post" style="display:inline;padding:0.3em;">\n};
    print qq{<input type="hidden" value="1" name="page">\n};

    print "<input type=\"submit\" value=\"$lex{Search}\">\n";
    print "<input type=\"text\" name=\"student\" size=\"30\">\n";
    print "$lex{Student} ($lex{'Last,First/Last/Initials/Studnum'})  $lex{'Blank=All'}<br>\n";

    print qq{<input type="checkbox" name="summary" value="1"> $lex{Summary}?\n};

    print "</form>\n";

    print "</body></html>\n";
    exit;

}
    


#------------------
sub showInfractions {
#------------------

    print "<h3>$lex{'Click on Student Name to view their records'} <i>$lex{only}</i></h3>\n";


# Setup the Search
    if ($student =~ /\d+/) {  # we have a student number
	$studnum = $student;
	$sth = $dbh->prepare("select lastname, firstname, studnum from studentall
     where studnum = '$studnum'");
    } else { # we have words hopefully with a comma
	($lastname,$firstname)  = split(/\,/, $student);
	$firstname =~ s/^\s*//;
	$lastname =~ s/^\s*//;
	if ($lastname and $firstname){ # both entered.
	    $sth = $dbh->prepare("select lastname, firstname, studnum 
              from studentall where lastname = '$lastname' 
              and firstname = '$firstname' order by lastname, firstname");
	} elsif ($lastname and not $firstname){ # only lastname (no comma)
	    if (length($lastname) == 2){ # search by initials: fi, li.
		$fi = substr($lastname,0,1); $li = substr($lastname,1,1);
		$sth = $dbh->prepare("select lastname,firstname, studnum from studentall
                 where lastname $sql{like} '$li%' and firstname $sql{like} '$fi%'
                 order by lastname, firstname");
	    } else {
		$sth = $dbh->prepare("select lastname, firstname, studnum 
                  from studentall where lastname = '$lastname' 
                  order by lastname, firstname");
	    }
	} else { # print an error....
	    $sth = $dbh->prepare("select lastname, firstname, studnum 
                from studentall order by lastname, firstname");
	}
    } # Last Else

    $sth->execute;
    if ($DBI::errstr) {print "Error: $DBI::errstr"; die;}
    $rows = $sth->rows;

    # Loop through each found student.
    while (my ( $lastname, $firstname,$studnum ) = $sth->fetchrow ) {

	$sth1 = $dbh->prepare("select * from discipline
          where userid = ? and infraction != 'Withdrew from School' 
          order by date desc");
	$sth1->execute( $studnum );
	if ($DBI::errstr) { print $lex{Error}. " $DBI::errstr \n"; }
	my $discrows = $sth1->rows;
	if ( not $discrows ){ next; } # skip kids without discipline entries.

	print "<h2><a href=\"$self?student=$studnum\">$firstname $lastname</a>";
	print " ($studnum)</h2>\n";      

	if ( ! $arr{summary} ) {

	    print "<ul>";

	    my $dtotal; # Demerit Totals
	    while ( my $r = $sth1->fetchrow_hashref ){

		print '<li><i>'. $r->{date} . '</i> [ <b>'. $r->{infraction}. '</b> ';
		print $r->{demerit}. q{ }. $lex{'Demerit(s)'}. ']';
		print ' <i>('. $r->{author}. ')</i> '. "\n";

		print $r->{description}. q{ }. $ref->{action}. ' <i>'. $lex{'If Repeated'}. ',</i>';
		print $r->{ifrepeat};
		print ' <i>'. $lex{Parent}. ':</i>'. $r->{parent};
		print ' <i>'. $lex{Private}. ':</i>'. $r->{private}. "</li>\n";
		$dtotal += $r->{demerit};
	    }
    
	    print "<span style=\"font-weight:bold;font-size:110%;\">";
	    print $lex{Total}. q{ }. $lex{'Demerit(s)'}. " $dtotal</span>\n";
	    print "</ul><p></p>";

	}
    }

    print "</ul><p>[ <a href=\"$homepage\">$lex{Main}</a> | \n";
    print "<a href=\"$discpage\">$lex{Discipline}</a> ]\n";
    showSearchForm();
    print "</p></body></html>\n";

    exit;

}


#-----------------
sub showSearchForm {
#-----------------

    print qq{<form action="$self" method="post" style="display:inline;padding:0.3em;">\n};
    print "<input type=\"submit\" value=\"$lex{Search}\">\n";
    print "<input type=\"text\" name=\"student\" size=\"30\">\n";
    print "$lex{Student} ($lex{'Last,First/Last/Initials/Studnum'})\n";
    print "</form>\n";

}

