#!/usr/bin/perl
#  Copyright 2001-2013 Leslie Richardson

#  This file is part of Open Admin for Schools.


my %lex = ('Discipline Entries' => 'Discipline Entries',
	   'Main' => 'Main',
	   'Discipline' => 'Discipline',
	   'Start' => 'Start',
	   'End' => 'End',
	   'Name' => 'Name',
	   'Infract/Par' => 'Infract/Par',
	   'Description' => 'Description',
	   'Action' => 'Action',
	   'Error' => 'Error',
	   'Demerit(s)' => 'Demerit(s)',
	   'Private' => 'Private',
	   'Repeat' => 'Repeat',
	   'Total' => 'Total',
	   'Parent' => 'Parent',
	   'View' => 'View',
	   'Start Date' => 'Start Date',
	   'End Date' => 'End Date',
	   'Sort Order' => 'Sort Order',
	   'Ascending' => 'Ascending',
	   'Descending' => 'Descending',
	   'Continue' => 'Continue',

	   );

use DBI;
use CGI;

my @time = localtime(time);
my $year = $time[5] + 1900;
my $month = $time[4] + 1;
my $currdate = "$year-$month-$time[3]";

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
%arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

my $title = "$lex{View} $lex{'Discipline Entries'}";
print "$doctype\n<html><head><title>$title</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";

if ( not $arr{page} ) {

    print "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" ";
    print "href=\"/js/calendar-blue.css\" title=\"blue\">\n";
    print "<script type=\"text/javascript\" src=\"/js/calendar.js\"></script>\n";
    print "<script type=\"text/javascript\" src=\"/js/lang/calendar-en.js\"></script>\n";
    print "<script type=\"text/javascript\" src=\"/js/calendar-setup.js\"></script>\n";

}

print "$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">$lex{Main}</a> | \n";
print "<a href=\"$discpage\">$lex{Discipline}</a> ]\n";

print "<h1>$title</h1>\n";


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    showRecords();

}



#----------------
sub showStartPage {
#----------------

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<table cellspacing=\"0\" border=\"0\" cellpadding=\"3\">\n";

    print "<tr><td class=\"bra\">$lex{'Start Date'}</td><td class=\"la\">\n";
    print "<input type=\"text\" name=\"startdate\" size=\"12\" id=\"startdate\" value=\"$schoolstart\">\n";
    print "<button type=\"reset\" id=\"start_trigger\">...</button>";
    print "</td></tr>\n";

    print "<tr><td class=\"bra\">$lex{'End Date'}</td><td class=\"la\">\n";
    print "<input type=\"text\" name=\"enddate\" size=\"12\" id=\"enddate\" value=\"$currdate\">\n";
    print "<button type=\"reset\" id=\"end_trigger\">...</button>";
    print "</td></tr>\n";

    print "<tr><td class=\"bra\">$lex{'Sort Order'}</td><td class=\"la\">\n";
    print qq{<input type="radio" name="sort" value="d" checked="checked"> $lex{Descending}<br>\n};
    print qq{<input type="radio" name="sort" value="a"> $lex{Ascending}</td></tr>\n};


    print "<tr><td></td><td class=\"la\"><input type=\"submit\" value=\"$lex{Continue}\">\n";
    print "</td></tr></table></form>\n";

    print "<script type=\"text/javascript\">
     Calendar.setup({
        inputField     :    \"startdate\", // id of the input field
        ifFormat       :    \"%Y-%m-%d\", // format of the input field
        button         :    \"start_trigger\", // trigger for the calendar (button ID)
        singleClick    :    false,        // double-click mode
        step           :    1             // show all years in drop-down boxes 
    });\n";

    print "Calendar.setup({
        inputField     :    \"enddate\", // id of the input field
        ifFormat       :    \"%Y-%m-%d\", // format of the input field
        button         :    \"end_trigger\", // trigger for the calendar (button ID)
        singleClick    :    false,        // double-click mode
        step           :    1             // show all years in drop-down boxes 
    })\n";

    print "</script>\n";
    print "</body></html>\n";

    exit;

}


#--------------
sub showRecords {
#--------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $sortorder;
    if ($arr{sort} eq 'a') {
	$sortorder = "date, userid";
    } else {
	$sortorder = "date desc, userid";
    }


    my $sth = $dbh->prepare("select date, userid, infraction, description, action, 
     ifrepeat, parent, author, private, demerit from discipline order by date desc, userid");

    $sth = $dbh->prepare("select date, userid, infraction, description, action, 
     ifrepeat, parent, author, private, demerit from discipline 
     where to_days(discipline.date) >= to_days('$arr{startdate}') and 
     to_days(discipline.date) <= to_days('$arr{enddate}') 
     order by $sortorder");
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    $rows = $sth->rows;


    print "<p><b>$lex{Start}:</b> $arr{startdate} <b>$lex{End}:</b> $arr{enddate}</p>\n";

    print qq{<table border="1" cellpadding="3" cellspacing="0">\n};
    print "<tr><th>$lex{Name}</th><th>$lex{'Infract/Par'}</th><th>$lex{Description}</th>\n";
    print "<th>$lex{Action}</th></tr>\n";

    my $sth1 = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");

    my $totaldemerit;
    while ( my ( $date, $userid, $infraction,$description, $action, $ifrepeat, 
		 $parent, $author, $private, $demerit ) = $sth->fetchrow ) {

	$totaldemerit += $demerit;
	$sth1->execute( $userid );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my ($lastname, $firstname) = $sth1->fetchrow;

	print "<tr><td><b>$date<br>$firstname $lastname</b><br>($userid)</td>\n";
	print "<td>$infraction<br><b>$lex{Parent}:</b>$parent<br><b>";
	print "$lex{Private}:</b> $private</td><td>$description</td><td>$action<br><b>";
	print "$lex{Repeat}:</b> $ifrepeat<br>$lex{'Demerit(s)'}:$demerit</td></tr>\n";

    }

    print "</table></body></html>\n";

    exit;

}
