#!/usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


my %lex = ('Group Email' => 'Group Email',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Main' => 'Main',
	   'Blank=All' => 'Blank=All',
	   'Select' => 'Select',
	   'Values' => 'Values',
	   'Group' => 'Group',
	   'Parent 1' => 'Parent 1',
	   'Parent 2' => 'Parent 2',
	   'Separate with Spaces' => 'Separate with Spaces',
	   'Subject' => 'Subject',
	   'Message' => 'Message',
	   'Continue' => 'Continue',
	   'Student' => 'Student',
	   'Checked' => 'Checked',
	   'Email Sent' => 'Email Sent',
	   'Error' => 'Error',
	   'Email' => 'Email',
	   'Attach File' => 'Attach File',
	   'Cannot open file' => 'Cannot open file',
	   'Maximum File Upload size exceeded!' => 'Maximum File Upload size exceeded!',
	   'Next Page' => 'Next Page',


	   );

my $self = 'emailgroup.pl';

# Configured Values
my $maxbufcount = 1000; # 1000K limit
my $mailserver = 'richtech.ca'; # localhost
my $noreplyName = 'OpenAdmin Messaging System';
my $noreplyEmail = 'no-reply@yoursite.net';


use CGI;
use DBI;
use Mail::Sender;

# calc current date
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
my $currdate = "$year-$month-$day";

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " :$@<br>\n";
    die $lex{Error}. " :$@<br>\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $checked = $arr{checked};
delete $arr{checked};


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

# Show page Header
my $title = $lex{'Group Email'};
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body style=\"padding:1em;\">\n";

print "[ <a href=\"$homepage\">$lex{Main}</a> ]\n";
print "<h1>$title</h1>\n";

if ( not $arr{page} ) { # Select Groups and which emails to do (Student, Parents)
    showStartPage();

} elsif ( $arr{page} == 1 ) { # Select Students, Parents / Set Message, Attachment
    delete $arr{page};
    selectRecipients();

} elsif ( $arr{page} == 2 ) { # post the Mail
    delete $arr{page};
    postEmail();

}
 


#----------------
sub showStartPage {
#----------------

    # Setup the form and start of table.
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
    print "<table cellpadding=\"3\" border=\"0\" cellspacing=\"0\">\n";
    
    print "<tr><td class=\"bra\">$lex{Group}</td>\n";
    print "<td class=\"la\"><select name=\"groupType\">\n";
    print "<option value=\"grade\">$lex{Grade}</option>\n";
    print "<option value=\"homeroom\">$lex{Homeroom}</option>";
    print "</select>\n";
    print "<input type=\"text\" name=\"groupValue\" size=\"25\">\n";
    print " $lex{'Separate with Spaces'}, $lex{'Blank=All'}</td></tr>\n";

    print "<tr><td class=\"bra\">$lex{Select}</td><td class=\"la\">\n";
    print "<input type=\"checkbox\" name=\"selStudent\" value=\"1\"> ";
    print "$lex{Student} $lex{Email}<br>\n";

    print "<input type=\"checkbox\" name=\"selPar1\" value=\"1\"> ";
    print "$lex{'Parent 1'} $lex{Email}<br>\n";

    print "<input type=\"checkbox\" name=\"selPar2\" value=\"1\"> ";
    print "$lex{'Parent 2'} $lex{Email}<br>\n";

    print "<tr><td class=\"bra\">$lex{'Next Page'} $lex{Checked}?</td><td class=\"la\">\n";
    print "<input type=\"checkbox\" name=\"checked\" value=\"checked\"></td></tr>\n";

    print "<tr><td></td><td class=\"la\">";
    print "<input type=\"submit\" value=\"$lex{Continue}\">";
    print "</td></tr>\n";

    print "</table></form>\n";
    print "</body></html>\n";

    exit;

}



#-------------------
sub selectRecipients { # Choose students/parents to email to and put in message
#-------------------

    # foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    # Get passed group values
    my @group = split /\s/, $arr{groupValue}; # split into array based on spaces
    delete $arr{groupValue};
    #print "Group", @group, "<br>\n";

     
    my $groupType;
    if ( $arr{groupType} eq 'grade' ) {
	$groupType = 'grade';
    } else {
	$groupType = 'homeroom';
    }
    delete $arr{groupType};


    # Select students, sorted by lastname, firstname,
    my $select;

    if ( @group ) {
	$select = 'where ';
	my $first = 1;
	foreach my $value ( @group ) {
	    $value = $dbh->quote( $value );
	    if ( not $first ) { $select .= ' or '; }
	    $select .= "$groupType = $value ";
	    $first = 0;
	}
    }

     if ($select) { print "Select: $select<br>\n"; }
    
    my $sth = $dbh->prepare("select lastname, firstname, studnum, 
       email, par1_email, par2_email from student 
       $select order by lastname, firstname");
    $sth->execute;
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }


    # Setup the form and start of table.
    print "<form action=\"$self\" method=\"post\" enctype=\"multipart/form-data\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";


    print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";

    print "<tr><td colspan=\"2\"><b>". $lex{Subject};
    print "</b> <input type=\"text\" name=\"subject\" size=\"50\"></td></tr>\n";

    print "<tr><td class=\"la\" colspan=\"2\"><b>". $lex{Message};
    print "</b><br><textarea name=\"message\" rows=\"10\" cols=\"60\">";
    print "</textarea></td></tr>\n";

    print "<tr><td class=\"la\" colspan=\"2\"><b>". $lex{'Attach File'};
    print " <input type=\"file\" name=\"filename\"></td></tr>\n";

    print "<tr><th colspan=\"2\"><input type=\"submit\" value=\"". $lex{Continue};
    print "\"></td></tr>\n";


    # Loop through the students
    while ( my ($lastname, $firstname, $studnum, $email, $par1_email, $par2_email ) = $sth->fetchrow ) {

	 print "<tr><td class=\"ra\"><b>$lastname</b>, $firstname ($studnum)</td><td class=\"la\">\n";
	 if ( $email and $arr{selStudent} ) {
	     print $lex{Student};
	     print " <input type=\"checkbox\" name=\"$email\" value=\"1\" $checked> $email&nbsp;&nbsp;| ";
	 }
	 if ( $par1_email and $arr{selPar1} ) {
	     print $lex{'Parent 1'};
	     print " <input type=\"checkbox\" name=\"$par1_email\" value=\"1\" $checked>";
	     print "$par1_email&nbsp;&nbsp;| ";
	 }
	 if ( $par2_email and $arr{selPar2} ) {
	     print $lex{'Parent 2'};
	     print "<input type=\"checkbox\" name=\"$par2_email\" value=\"1\" $checked>";
	     print "$par2_email&nbsp;&nbsp;| ";
	 }
	 
	 print "</td></tr>\n";
     }


     # Print Submit Row
     print "<tr><td colspan=\"4\" class=\"cn\">";
     print "<input type=\"submit\" value=\"$lex{'Continue'}\"></td></tr>\n";
    
     print "</table>\n</form></body></html>\n";
    
     exit;

 }



#------------
sub postEmail  {
#------------

    my $subject = $arr{subject};
    delete $arr{subject};

    my $message = $arr{message};
    delete $arr{message};
    #$message =~ s/[\r\n|\r]/\n/g; # don't mess with CRLF.
    my @lines = split /\n/, $message;

    my $file = $q->param("filename");
    my $filename = $file;  # fileName is output filename, file is input.
    delete $arr{filename}; # value not needed.

    my ($name, $ext); 

    if ( $filename ) {   # it will not have leading path info...

	$filename =~ s!^.*(\\|\/)!!; 
	$filename = lc($filename);
	@name = split /\./, $filename; # split on dots.
	$ext = $name[$#name];  # last element is the extension.

#	unless ( $ext eq 'csv' ){
#	    print "<b>". $lex{'The file must be a .csv file!'}. "</b>";
#	    print "</body></html>\n";
#	    die;
#	}


	open ( OUTFILE, ">$filename") || 
	    die $lex{'Cannot open file'}. " $filename"; 
	my $bufcount = 0;
	while ( my $bytesread = read( $file, my $buffer, 1024) ) { 
	    print OUTFILE $buffer;
	    $bufcount++;
	    if ( $bufcount > $maxbufcount ) {
		print "<h1>". $lex{'Maximum File Upload size exceeded!'};
		print " ($maxbufcount K)</h1>\n";
		print "</body></html>\n";
		die $lex{'Maximum File Upload size exceeded!'};
	    }
	}

	close OUTFILE;

	# We should now have the file in place.
	# my @cmd = split / /, "mv $filename $downloaddir";
	# system( @cmd );

    } # end of File upload.


    # Setup to send mail.
    my $fromString = "$noreplyName <$noreplyEmail>";

    my $sender = new Mail::Sender { from => $fromString,
				    smtp => $mailserver,
				    subject => $subject,
				    keepconnection => 1,
				    on_errors => 'code'

    };
	
    die $lex{Error}. ": $Mail::Sender::Error\n" unless ref $sender;


    print "</center><div><ul>\n";

    my %duplicates;

    foreach my $emailaddress ( sort keys %arr) {

	if ( $duplicates{$emailaddress} ) { next; } # skip existing email addresses.
	$duplicates{$emailaddress} = 1;

	if ( $filename ) { # multipart attachment

	    $sender->OpenMultipart({ to => $emailaddress

				   }) or die "Open Multipart Failure: $sender->{'error_msg'}\n";

	    $sender->Body({ encoding => 'Quoted-printable'}) or die "Body Failure: $sender->{'error_msg'}\n";

	    $sender->SendEnc( @lines ) or die "SendEnc Failure: $sender->{'error_msg'}\n";

	    $sender->Attach({ file => $filename,
			      description => $filename,
			      encoding => 'Base64'
			    }) or die "Attach Failure: $sender->{'error_msg'}\n";


	} else { # single message

	    $sender->Open({ to => $emailaddress,
			    encoding => 'Quoted-printable'
			  });
	    $sender->SendEnc( @lines );

	}

	print  "<li>$emailaddress</li> \n";
	$sender->Close or die "Close Failure: $sender->{'error_msg'}\n";

    }

    $sender->Close(1); # full close to object.


    unlink $filename or warn "Could not unlink $filename: $!";

    print qq{</ul></div>\n};
    print qq{<h1>$lex{'Email Sent'}</h1>\n};

    print qq{<p>[ <a href="$homepage">$lex{Main}</a> ]</p>\n};
    print qq{</body></html>\n};

    exit;

} # End of postMail
