#!/usr/bin/perl
#  Copyright 2001-2011 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Delete' => 'Delete',
	   'Date' => 'Date',
	   'Are you sure' => 'Are you sure',
	   'Main' => 'Main',
	   'Eoy' => 'Eoy',
	   'No Record(s) Found' => 'No Record(s) Found',
	   'Contact' => 'Contact',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Error' => 'Error',
	   'Yes' => 'Yes',
	   'Record(s) Deleted' => 'Record(s) Deleted',
    );

my $self = 'datedel.pl';

use CGI;
use DBI;

# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

$sth = $dbh->prepare("select date, type, desc1 from dates where id = ?"); 
$sth->execute( $arr{id} );
my ( $date, $type, $desc1 ) = $sth->fetchrow;


print "$doctype\n<html><head><title>$lex{Delete} $lex{Date}</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">$lex{Main}</a> |\n";
print "<a href=\"$eoypage\">$lex{Eoy}</a> ]<center>\n";


if ( $arr{itemid} ) {
    deleteRecord( $arr{itemid} );
}

if ( not $date ) { # No Record
    print "<h1>". $lex{'No Record(s) Found'}. "</h1>\n";
    print "</body></html>\n";
    exit;
}

print "<h1>$lex{Delete} $lex{Date}</h1>\n";
print "<table cellpadding=\"3\" border=\"0\" cellspacing=\"0\">\n";
print "<tr><td class=\"bra\">$lex{Date}</td>\n";
print "<td class=\"la\">$date - $type - $desc1</td></tr></table>\n";

print "<p><em>$lex{'Are you sure'}?</em></p>\n";

print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"itemid\" value=\"$arr{id}\">\n";
print "<input type=\"submit\" value=\"$lex{Yes}, $lex{Delete} $lex{Date}";
print "\"></form></center></body></html>\n";


#---------------
sub deleteRecord {
#---------------

    my $id = shift;

    $sth = $dbh->prepare("delete from dates where id = ?");
    $sth->execute( $id );

    if ( $DBI::errstr ) {
	print "<h3>$lex{Error}: $DBI::errstr<br>\n";
	print "$lex{Contact}: $adminname $adminemail</h3>\n";

    } else {
	print "<h3>$lex{'Record(s) Deleted'}</h3>";
    }

    print "<div>[ <a href=\"datedeled.pl\">";
    print "$lex{Edit}/$lex{Delete} $lex{Date}</a> |\n";
    print "<a href=\"$eoypage\">$lex{Eoy}</a> ]</div>\n";
    print "</center></body></html>\n";

    exit;

}
