#!/usr/bin/perl
#  Copyright 2001-2011 Leslie Richardson
#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; version 2 of 
#  the License, only.

# Fix any teacher fields in the subject table that contain teacher names.
# The field should only contain the teacher userid.

my %lex = ('Fix' => 'Fix',
	   'Error' => 'Error',
	   'Teacher' => 'Teacher',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Updated' => 'Updated',
	   'Successful' => 'Successful',

	   );

use DBI;
use CGI;
use CGI::Session;
use Time::JulianDay;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@<br>\n";
}

my $q = new CGI;
my %arr = $q->Vars;
print $q->header(-charset, $charset);

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

my $title = "$lex{Fix} $lex{Teacher}";

print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body style=\"padding:1em 2em;\">\n";

print "[ <a href=\"$homepage\">$lex{Main}</a> |\n";
print "<a href=\"$reppage\">$lex{'Report Card'}</a> |\n";

print "<h1>$title</h1>\n";


my $sth1 = $dbh->prepare("update subject set teacher = ? where id = ?");

my $sth = $dbh->prepare("select id, teacher, description from subject order by subjsec");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

my $first = 1;


while ( my ($id, $teacher, $description) = $sth->fetchrow ) {

    if ( $teacher =~ m/\((\w+)\)/ ) { # we have a name value
	$first = 0;
	my $original = $teacher;
	my $newteacher = $1;

	# Reset the teacher.
	$sth1->execute($newteacher, $id);
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	
	print "<p>$lex{Updated}: $description - $original</p>\n";

    } # update loop

}

if ( $first ) { print "<h3>$lex{Fix} $lex{Teacher} $lex{Successful}</h3>\n"; }

print "</body></html>\n";
