#!/usr/bin/perl
#  Copyright 2001-2011 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('View' => 'View',
	   'Subjects' => 'Subjects',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Sort' => 'Sort',
	   'Grade' => 'Grade',
	   'Subject' => 'Subject',
	   'Teacher' => 'Teacher',
	   'Subjsec' => 'Subjsec',
	   'Description' => 'Description',
	   'Seq' => 'Seq',
	   'Terms' => 'Terms',
	   'SmDesc' => 'SmDesc',
	   'Mode' => 'Mode',
	   'MarkBy' => 'MarkBy',
	   'Subjects' => 'Subjects',
	   'Credit' => 'Credit',
	   'Difficulty' => 'Diff',
	   'Error' => 'Error',
	   'Edit' => 'Edit',

	   );


use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

my %sortorder =  ( $lex{Grade} => 'grade, sequence, description',
		   $lex{Teacher} => 'teacher, description',
		   $lex{Subject} => 'description, grade, teacher'
    );

my $sortorder;
if ( $arr{sort} and $sortorder{ $arr{sort} } ) {
    $sortorder= $sortorder{$arr{sort}};
} else {
    $sortorder = $sortorder{Grade};
}

my $sth = $dbh->prepare("select * from subject order by $sortorder");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

my $title = "$lex{View} $lex{Subjects}";
print "$doctype\n<html><head><title>$title</title>
 <link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
 $chartype\n</head><body>\n";

print "<a href=\"$homepage\">$lex{Main}</a> |\n";
print "<a href=\"$reppage\">$lex{'Report Card'}</a> ] ";
  
# Sortorder form
print "<form action=\"subjview.pl\" method=\"post\" style=\"display:inline;\">";
print "<select name=\"sort\">";
foreach $key (keys %sortorder) {
    print "<option>$key</option>\n";
}
print "</select><input type=\"submit\" value=\"$lex{Sort}\">\n";
print "</form>\n";

# Title / Table
print "<h1>$title</h1>\n";
print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";

# Header
print "<tr><th>$lex{Subjsec}</th><th>$lex{Description}</th>\n<th>";
print "$lex{Grade}</th><th>$lex{Teacher}</th><th>$lex{Seq}</th><th>";
print "$lex{Terms}</th><th>$lex{SmDesc}</th><th>$lex{Mode}<br>$lex{MarkBy}";
print "</th><th>$lex{Credit}<br>$lex{Difficulty}</th><th></th></tr>\n";


while ( my $ref = $sth->fetchrow_hashref ) {
    my %rec = %$ref;

    print "<tr><td valign=\"top\">$rec{subjsec}</td>\n";

    print "<td valign=\"top\" style=\"font-size:120%;\">$rec{description}</td>";
    print "</td>";

    print "<td>$rec{grade}</td><td>$rec{teacher}</td>\n";
    print "<td>$rec{sequence}</td><td>$rec{startrptperiod} - $rec{endrptperiod}</td>\n";
    print "<td>$rec{smdesc}</td>\n";
    print "<td>$rec{instmode}<br>$rec{exammix}</td><td>$rec{credit}<br>$rec{difficulty}</td><td>\n";

    print "<form action=\"subjed.pl\" method=\"post\" style=\"display:inline;\">";
    print "<input type=\"submit\" value=\"$lex{Edit}\">\n";
    print "<input type=\"hidden\" name=\"id\" value=\"$rec{id}\"></form>\n";
    print "</td></tr>\n";

    # Show Objectives, if any
    my $first = 1;
    for my $i (1..20) {
	my $fld = 'q'. $i;
	if ( $rec{$fld} ) {
	    if ($first) { # put in new row...
		print "<tr style=\"background-color:#EEE;\"><td colspan=\"10\">";
		$first = 0;
	    }
	    print "$fld:$rec{$fld} | ";
	}
    }
    print "</td></tr>\n";

}

print "</table></body></html>\n";
