#!/usr/bin/perl
#  Copyright 2001-2015 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

%lex = ('Edit' => 'Edit',
	'Staff Member' => 'Staff Member',
	'Main' => 'Main',
	'Eoy' => 'Eoy',
	'Unable to open template file:' => 'Unable to open template file:',
	'Contact' => 'Contact',
	'Update' => 'Update',
	'Error' => 'Error',
	'Password' => 'Password',
	'You MUST have a unique userid and a password' => 
	  'You MUST have a unique userid and a password',
	'Error' => 'Error',
	'Grade(s)' => 'Grade(s)',
	'Homeroom(s)' => 'Homeroom(s)',
	'Position' => 'Position',
	'Record(s) Updated' => 'Record(s) Updated',
	'Separate with Spaces' => 'Separate with Spaces',
	'Add' => 'Add',
	'Required' => 'Required',
	'Bold' => 'Bold',
	'Preregistration' => 'Preregistration',
	'Access Control(s)' => 'Access Control(s)',
	'Current' => 'Current',
	'Spaces Not Allowed' => 'Spaces Not Allowed',
	'Type' => 'Type',
	'Grade' => 'Grade',
	'Percent' => 'Percent',
	'Teacher' => 'Teacher',
	'Occupation' => 'Occupation',
	'Other' => 'Other',
	'Homeroom' => 'Homeroom',
	'Only' => 'Only',
	'Userid Already Exists' => 'Userid Already Exists',

	 );

my $self = 'staffed_firstnation.pl';
my $g_staffpwd_groups = 0; # turn off character group (uppercase, lowercase, symbols) checking
my $g_staffpwd_following = 0; # turn off following character checking (keyboard, same)

my $maxmulti = 4; # Occupation Limits


use CGI;
use DBI;
use Data::Password qw(:all);  # for password checking...

eval require "../../etc/admin.conf.root";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}



eval require "../../lib/libmeta.pl";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header(-charset, $charset ); 
my %arr = $q->Vars;
my $recid = $arr{id};

my $table;
if ( $arr{tbl} ) {
    $table = 'prereg_staff';
    $multitable = 'prereg_staff_multi';
} else {
    $table = 'staff';
    $multitable = 'staff_multi';
}

my $dbtype = 'mysql';
my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

# Load Configuration Variables;
my $sth = $dbh->prepare("select id, datavalue from conf_system where filename = 'admin'");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
while (	my ($id, $datavalue) = $sth->fetchrow ) {
    eval $datavalue;
    if ( $@ ) {
	print "$lex{Error}: $@<br>\n";
	die "$lex{Error}: $@\n";
    }
}



# Print Page Header
print "$doctype\n<html><head><title>\n";
print $lex{Edit}. q{ }. $lex{'Staff Member'};
print "</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";

print "$chartype\n</head><body>[ <a href=\"$homepage\">";
print $lex{Main}, "</a> | <a href=\"$eoypage\">";
print $lex{Eoy}, "</a> ]<h1>\n";

if ($arr{tbl}) {
    print $lex{Edit}. " <span style=\"color:red;\"> ". $lex{Preregistration}. "</span> ". $lex{'Staff Member'};
} else {
    print $lex{Edit}. q{ }. $lex{'Staff Member'};
}

print "</h1>\n";


if ( $arr{writeflag} ) { # Write the records
    delete $arr{writeflag};
    writeRecord();
}

print qq{<p><b>$lex{Bold}</b> = $lex{Required}</p>\n};


# Load the record into a hash.
my $sth = $dbh->prepare("select * from staff where id = ?");
$sth->execute( $arr{id} );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
my $ref = $sth->fetchrow_hashref;
my %rec = %$ref;



# Read in Template as single text variable
unless (open (FH,"<../../template/staff_inac.tpl")) {
    print $lex{'Unable to open template file:'},"$!\n";
    die $lex{'Unable to open template file:'},"$!\n";
}
my $formtext;
{ local $/; $formtext = <FH>; close FH;}


# Create hash for fieldnames from meta.
$sth = $dbh->prepare("select fieldid, fieldname, required 
  from meta where tableid = ?");
$sth->execute( 'staff' );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my %fieldnames = ();
while ( my ( $fieldid, $fieldname, $required ) = $sth->fetchrow ) {
    if ( $required ) { # has any value
	$fieldname = "<span style=\"font-weight:bold;\">$fieldname</span>";
    }
    $fieldnames{$fieldid} = $fieldname;
}

# Now put replacement text back in.
$formtext =~ s{\<\*(.*?)\*\>}
  { exists( $fieldnames{$1} ) 
	? $fieldnames{$1} 
	: $1
  }gsex;

# Find all fields , so we only wrap forms around them (typically
# faster than doing all fields in the table )
my @fields = ();
while ( $formtext =~ m/\<\@(.*)\@\>/g){
    push @fields, $1;
}


# get replacement values for fields, %rec holds values
my %values = ();
foreach my $fieldid ( @fields ) {
    $values{$fieldid} = metaInputField(
	'staff', $fieldid, $rec{ $fieldid }, $dbh,'' );
}

# now put field values back into $text variable...
$formtext =~ s{ \<\@(.*?)\@\> }
  { exists($values{$1}) 
	? $values{$1} 
	: "$values{$1}-$1"
  }gsex;


# print top of form, then $text, then bottom of page.
print "<form action=\"$self\" method=\"post\"> 
<input type=\"hidden\" name=\"writeflag\" value=\"1\">
<input type=\"hidden\" name=\"tbl\" value=\"$arr{tbl}\">
<input type=\"hidden\" name=\"id\" value=\"$recid\">\n";

print qq{<div><input type="submit" value="$lex{Update} $lex{'Staff Member'}"></div>\n};


print $formtext,"\n";


# Now do the position field(s).
$sth = $dbh->prepare("select id, field_value from $multitable 
  where field_name = 'position' and userid = ?");
$sth->execute( $rec{userid} );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}


print qq{<table cellpadding="3" cellspacing="0" border="0" style="margin:1em;">\n};
print qq{<tr><td colspan="2"><hr></td></tr>\n};
my $count = 1;

# foreach my $pos ( @g_position ) { print qq{<div>$pos</div>}; }

while ( my ( $id, $fieldvalue ) = $sth->fetchrow ) {
    print qq{<tr><td class="ra">$lex{Staff} $lex{Position} $count</td><td><select name="m:$id">};
    print qq{<option>$fieldvalue</option><option></option>\n};
    foreach my $pos ( @g_position ) { print qq{<option>$pos</option>}; }
    print qq{\n</select></td></tr>\n};
    $count++;
}

print qq{<tr><td class="ra">$lex{Add} $lex{Position}</td><td><select };
print qq{name="m:addposition"><option></option>\n};

foreach my $pos ( @g_position ) { print qq{<option>$pos</option>}; }
print qq{\n</select></td></tr>\n};

print qq{<tr><td colspan="2" style="background-color:#888;color:white;">};
print qq{$lex{Homeroom} $lex{Teacher} <b>$lex{Only}</b> (Subject Teachers have NO values here)</td></tr>\n};


# Now do the grade field(s).
my $sth = $dbh->prepare("select id, field_value from $multitable 
  where field_name = 'grade' and userid = ?");
$sth->execute( $rec{userid} );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
print "<tr style=\"background-color:#DDD;\"><td class=\"ra\">$lex{Current} $lex{'Grade(s)'} </td>\n<td>";

while ( my ( $id, $fieldvalue ) = $sth->fetchrow ) {
    print qq{ <input type="text" name="m:$id" size="3" value="$fieldvalue">};
}
print "</td></tr>\n";
print "<tr><td class=\"ra\">$lex{Add} $lex{'Grade(s)'}</td><td><input type=\"text\" ";
print "name=\"m:addgrade\" size=\"6\"> $lex{'Separate with Spaces'}</td></tr>\n";


print qq{<tr><td colspan="2">&nbsp;</td></tr>\n};


# Now do the homeroom field(s).
my $sth = $dbh->prepare("select id, field_value from $multitable 
  where field_name = 'homeroom' and userid = ?");
$sth->execute( $rec{userid} );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}

print "<tr style=\"background-color:#DDD;\"><td class=\"ra\">$lex{Current} $lex{'Homeroom(s)'}</td>\n<td>";
while ( my ( $id, $fieldvalue ) = $sth->fetchrow ) {
    print qq{ <input type="text" name="m:$id" size="3" value="$fieldvalue">}
}
print "</td></tr>\n";

print "<tr><td class=\"ra\">$lex{Add} $lex{'Homeroom(s)'}</td><td><input type=\"text\" ";
print "name=\"m:addhomeroom\" size=\"6\"> $lex{'Separate with Spaces'}</td></tr>\n";


print qq{<tr><td colspan="2" style="background-color:#888;color:white;">};
print qq{&nbsp;</td></tr>\n};

#print qq{<tr><td colspan="2">&nbsp;</td></tr>\n};


# Now do the access control field(s).
my $sth = $dbh->prepare("select id, field_value from $multitable 
  where field_name = 'access' and userid = ?");
$sth->execute( $rec{userid} );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}

print "<tr><td class=\"ra\">$lex{Current} $lex{'Access Control(s)'}</td>\n<td>";
while ( my ( $id, $fieldvalue ) = $sth->fetchrow ) {
    print qq{ <input type="text" name="m:$id" size="3" value="$fieldvalue">}
}
print "</td></tr>\n";

print "<tr><td class=\"ra\">$lex{Add} $lex{'Access Control(s)'}</td><td><input type=\"text\" ";
print "name=\"m:addaccess\" size=\"6\"> $lex{'Separate with Spaces'}</td></tr>\n";
print qq{</table><p></p>\n};



# First Nations Job Description

# Load existing occupations structure 
eval $rec{'occupations'};
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


# Load FTE
my $sth = $dbh->prepare("select defaultvalue from meta where tableid = ? and fieldid = ?");
$sth->execute('student_inac','fte' );
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my $default = $sth->fetchrow;
my %fte = split(/\s+/, $default);
foreach my $key ( keys %fte ) { $fte{$key} =~ s/\_/ /g; }


# Load Grades
$sth = $dbh->prepare("select distinct grade from student order by grade");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my @grades = ();
while ( my $gr = $sth->fetchrow ) {
    if ( $gr eq 'EC' or $gr eq 'ECS' ) { $gr = 'K'; }
    if ( $gr eq 'K5' or $gr eq 'K4' ) { $gr = 'K'; }
    push @grades, $gr;
}


# Load OccupationTypes
$sth = $dbh->prepare("select defaultvalue from meta where tableid = ? and fieldid = ?");
$sth->execute('staff','occupations' );
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my $default = $sth->fetchrow;
my %jobtype = split(/\s+/, $default);
foreach my $key ( keys %jobtype ) { $jobtype{$key} =~ s/\_/ /g; }



print qq{<table cellspacing="0" cellpadding="3" border="1" style="margin:2em 0 0 1em;">\n};
print qq{<caption style="font-size:130%;font-weight:bold;text-align:left;">AANDC - Job Description</caption>\n};
print qq{<tr><th>$lex{Occupation} $lex{Type}</th><th>$lex{Percent}<br>1-100</th></tr>\n};

for my $i (1..$maxmulti ) {

    # Job Type
    my $type = $occ{$i}{'type'};
    print qq{<tr><td class="la"><select name="$i:type:">};
    print qq{<option value="$type">$jobtype{$type}</option>\n};
    foreach my $key (sort keys %jobtype ) { print qq{<option value="$key">$jobtype{$key}</option>}; }
    print qq{<option></option></select></td>\n};

    # Percent
    my $val = $occ{$i}{'percent'};
    print qq{<td class="cn"><input type="text" name="$i:percent:" size="4" value="$val"></td></tr>\n};


}

print qq{</table>\n};
# end of Job Entry Values

print qq{<div><input type="submit" value="$lex{Update} $lex{'Staff Member'}"></div>\n};
print qq{</form></body></html>\n};




#--------------
sub writeRecord {
#--------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }


    use Data::Dumper;
    $Data::Dumper::Purity = 1;
    $Data::Dumper::Indent = 0;

    # Extract the Occupations Fields, if present
    my %occ = (); # occupation structure
    foreach my $key ( sort keys %arr) {
	my @vals = split(/:/, $key );
	if ( $vals[1] ) { # we have some stuff to take care of.
	    if ( $vals[0] eq 'm' ) { next; } # skip multirecs.
	    if ( $arr{$key} ) { # if a defined value, add to structure
		if ( $#vals == 2 ) {
		    $occ{"$vals[0]"}{"$vals[1]"}{"$vals[2]"} = $arr{$key};
		} else {
		    $occ{"$vals[0]"}{"$vals[1]"} = $arr{$key};
		}
	    }
	    delete $arr{$key};
	}
     }

    if ( %occ ) {
	my $value_ref = [ ];
	my $name_ref = [ ];

	$dataname = '*occ';
	push @$name_ref, $dataname;
	push @$value_ref, \%occ;

	my $d = Data::Dumper->new( $value_ref, $name_ref );
	my $occupations = $d->Dump;
	$arr{'occupations'} = $occupations;
    }



    # Make sure we have userid, password
    if ( not $arr{userid} or not $arr{password} ){
	print "<h1>$lex{'You MUST have a unique userid and a password'}</h1>\n";
	print "</body></html>\n";
	exit;
    }


    # Check for password quality using Data::Password module.
    $MINLEN = $g_staffpwd_minlen;  # from admin.conf settings.
    $MAXLEN = $g_staffpwd_maxlen;
    $FOLLOWING = $g_staffpwd_following;
    $GROUPS = $g_staffpwd_groups;
    if ( $g_staffpwd_dictionary ) {
	$DICTIONARY = $g_staffpwd_dictionary;
    } else {
	$DICTIONARY = 0; # turn it off.
    }

    if ( IsBadPassword( $arr{password} )) {
	print "<h1 style=\"color:red;\">$lex{Password} $lex{Error}<br>\n";
	print IsBadPassword( $arr{password} );
	print "</h1></body></html>\n";
	exit;
    }

    # Checkbox updates (since no returned values for these)
    my %checkboxfields = ();
    my $sth = $dbh->prepare("select distinct fieldid from meta 
      where tableid = 'staff' and formtype = 'checkbox'");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr }
    while ( my $fieldid = $sth->fetchrow ) {
        $checkboxfields{$fieldid} = 1;
    }


    # marker for prereg mode or normal mode.
    my $table = 'staff';
    my $prereg;
    if ( $arr{tbl} ){ 
	$prereg = $arr{tbl};
	$table = 'prereg_staff';
    }
    delete $arr{tbl};

    # Check for identical userid.
    $sth = $dbh->prepare("select lastname, firstname from $table where userid = ? and id != ?");
    $sth->execute( $arr{userid}, $arr{id} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    while ( my ($lastname, $firstname ) = $sth->fetchrow ) {
	print qq{<h1 style="color:red;">$lex{Error}: $lex{'Userid Already Exists'}: $firstname $lastname</h1>\n};
	print qq{</body></html>\n};
	exit;
    }

    # View Passed values.
    # foreach my $key ( sort keys %arr) {	print "K:$key V:$arr{$key}<br>\n"; }

    my $id = $arr{id};
    delete $arr{id};

    # Update staff table records
    foreach my $key ( keys %arr ) {
	if ( $key =~ m/^m:/ ) { next; } # skip multirecord values
	$sth = $dbh->prepare("update $table set $key = ? where id = $id");
	$sth->execute( $arr{$key} );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    }


    # Update any checkbox fields.
    foreach my $fieldid ( keys %checkboxfields ) {

	# if field HAS a value, then make it NULL, since checkboxes not passed in forms.
	# Load the field.
	my $sth = $dbh->prepare("select $fieldid from staff where id = ?");
	$sth->execute( $id );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr }
	my $recval = $sth->fetchrow;
	my $passedval = $arr{$fieldid};

	# Null field if present
	if ( $recval and not $passedval ) { #record has 1, but nothing passed; we must fix.
	    my $sth1 = $dbh->prepare("update staff set $fieldid = NULL where id = ?");
	    $sth1->execute( $id );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr }
	}
    }	


    my $sth2 = $dbh->prepare("select field_name from $multitable where id = ?");

    # Update records in staff_multi
    foreach my $key ( keys %arr ) {
	if ( $key =~ m/^m:/ ) { 
	    my $id = $key;
	    $id =~ s/^m://; # strip off start.

	    if ( $id =~ m/add/ and $arr{$key} ) { # we are adding new multirecords...
		$id =~ s/^add//; # strip add
		my $fieldname = $id;
		my $sth = $dbh->prepare("insert into $multitable ( userid, field_name, field_value ) 
                  values( ?, ?, ? )");
		if ( $fieldname eq 'position' ) { # Add single record
		    $sth->execute( $arr{userid}, 'position', $arr{$key} );
		    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

		} else { # possible multiple records add (grades, homerooms)
		    foreach my $val ( split / /, $arr{$key} ) {
			$sth->execute( $arr{userid}, $fieldname, $val );
			if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
		    }
		}

	    } elsif ( not $arr{$key} ) { # delete the record.
		my $sth = $dbh->prepare("delete from $multitable where id = ?");
		$sth->execute( $id );
		if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	    } else { # update the record;

		# Get Fieldname for the record.
		$sth2->execute( $id );
		if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
		my $fieldname = $sth2->fetchrow;

		# Check for spaces in value
		if ( $arr{$key} =~ m/\s+/ and ( $fieldname eq 'grade' or $fieldname eq 'homeroom' )) {
		    print "<h3>$lex{Error}: $lex{'Spaces Not Allowed'} - $arr{$key}</h3>\n";
		    print "</body></html>\n";
		    exit;
		}

		my $sth = $dbh->prepare("update $multitable set field_value = ? where id = ?");
		$sth->execute( $arr{$key}, $id );
		if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    }
	}
    }


    if ( not $DBI::errstr ) {
	print "<h3>$lex{'Record(s) Updated'}</h3>\n";

    } else {
	print "<h3>$lex{Error}: $DBI::errstr<br>$lex{Contact} ";
	print "$adminname - <a href=\"mailto:$adminemail\">$adminemail</a></h3>\n";
    }


    # Search for staff_multi REDUNDANT records and remove.
    my %multiusers;
    my $sth = $dbh->prepare("select distinct userid from staff_multi");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    while ( my $userid = $sth->fetchrow ) {
	$multiusers{$userid} = 1;
    }


    # remove current users from multiusers;
    my $sth = $dbh->prepare("select userid from staff");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    while ( my $userid = $sth->fetchrow ) {
	delete $multiusers{$userid};
    }

    # remove extra ones.
    if ( %multiusers ) {
	my $sth = $dbh->prepare("delete from staff_multi where userid = ?");
	foreach my $userid ( keys %multiusers ) {
	    print "Multi:$userid<br>\n";
	    $sth->execute( $userid );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	}
    }


    print "<p>[ <a href=\"$homepage\">$lex{Main}</a> |";
    print " <a href=\"$eoypage\">$lex{Eoy}</a> ]</p>\n";

    if ( $prereg ) {
	print "[ <a href=\"staffdeled.pl?tbl=prereg\">";
	print "$lex{Edit}  <span style=\"color:red;\">$lex{Preregistration}</span> $lex{'Staff Member'}";
    } else {
	print "[ <a href=\"staffdeled.pl\">$lex{Edit} $lex{'Staff Member'}";
    }

    print "</a> ]</p></body></html>\n";

    exit;

}
