#!/usr/bin/perl
#  Copyright 2001-2015 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Error' => 'Error',
	   'Main' => 'Main',
	   'Click on <i>name</i> to view Student Objectives' =>
	     'Click on <i>name</i> to view Student Objectives',
	   'Student' => 'Student',
	   'Category' => 'Category',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Name' => 'Name',
	   'Category' => 'Category',
	   'Method' => 'Method',
	   'Responsible' => 'Responsible',
	   'Objective' => 'Objective',
	   'Number of dependent Evaluation Records' => 'Number of dependent Evaluation Records',
	   'These records will be deleted also' => 'These records will be deleted also',
	   'Are you sure you want to delete these records?' => 
	     'Are you sure you want to delete these records?',
	   'Yes, delete the records!' => 'Yes, delete the records!',
	   'Record Deletion Failed' => 'Record Deletion Failed',
	   'Contact' => 'Contact',
	   'Record deleted' => 'Record deleted',
	   'View' => 'View',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Please Log In' => 'Please Log In',
	   'Target Skill' => 'Target Skill',
	   'Strategy' => 'Strategy',
	   'Objectives' => 'Objectives',

	   );

my $self = 'iepobjectivedeled.pl';

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;
my $studnum = $arr{studnum};

my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $currdate = "$year-$month-$tim[3]";


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');

    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$tchpage\">$lex{Main}</a> ]\n";
    print "<form action=\"../tlogin.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"iep/$self\">\n";
    print "<input type=\"submit\" value=\"$lex{'Please Log In'}\">\n";
    print "</form></body></html>\n";
    exit;

}

my $userid = $session->param('userid');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from staff where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;


# Print Page Heading
my $title = "$lex{Edit}/$lex{Delete} $lex{Student} $lex{Objectives}";
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\"></head>\n";
print "<body>[ <a href=\"$tchpage\">$lex{Main}</a> ] $firstname $lastname\n";


print "<h1>$title</h1>\n";

if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    confirmDelete( $arr{id} );

} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    deleteRecord( $arr{id} );
}


#----------------
sub showStartPage {
#----------------


    my $sth = $dbh->prepare("select e.id, e.studnum, e.subnum from iep_evalmst as e, iep_student as s 
     where e.studnum = s.studnum $select
     order by s.lastname, s.firstname , e.subnum");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $rows = $sth->rows;

    my $sth1 = $dbh->prepare("select lastname, firstname from iep_student where studnum = ?");
    my $sth2 = $dbh->prepare("select category from iep_objectives where catnum = ?");
    my $first = 1;


    while ( my ( $id, $studnum, $subnum ) = $sth->fetchrow ) {

	if ( $first ) {
	    print qq{<div style="padding:0.5em;">};
	    print qq{$lex{'Click on <i>name</i> to view Student Objectives'}</div>\n};
	    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">";
	    print "<tr><th>$lex{Student}</th><th>$lex{Category}</th><th></th><th></th></tr>\n";
	    $first = 0;
	}

	# Get Student Name
	$sth1->execute( $studnum );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my ( $lastname, $firstname ) = $sth1->fetchrow;
  
	# Get Subject Desc
	$sth2->execute( $subnum );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $category = $sth2->fetchrow;

	my $name = "$firstname $lastname ($studnum)";
	print qq{<tr><td class="bra"><form action="iepobjectiveview.pl" method="post">\n};
	print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
	print "<input type=\"submit\" value=\"$name\"></form></td>\n";

	print "<td>$category ($subnum)</td>";

	print "<td><form action=\"iepobjectiveed.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";
	print "<input type=\"submit\" value=\"$lex{Edit}\"></form></td>\n";

	print "<td><form action=\"$self\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";
	print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
	print "<input type=\"submit\" value=\"$lex{Delete}\"></form></td></tr>\n";

    }

    if ( $first ) {
	print "<h3>No Records Found</h3>\n";
    } else {
	print qq{</table>\n};
    }

    print "</body></html>\n";

    exit;

} # end of showStartPage



#----------------
sub confirmDelete {
#----------------

    # passed id of record to delete.
    my $id = shift;

    my $sth = $dbh->prepare("select * from iep_evalmst where id = ?"); 
    $sth->execute( $id );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my $ref = $sth->fetchrow_hashref;
    my %r = %$ref;
    # my ($studnum, $subnum, $obj1, $obj2, $obj3, $strategy, $responsible,$targetskill ) = $sth->fetchrow;

    # Now Find out how many records depend on this...
    $sth = $dbh->prepare("select count(subnum) from iep_eval where studnum = ? and subnum = ?"); 
    $sth->execute( $r{studnum}, $r{subnum} );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my $evalcount = $sth->fetchrow;

    # Get Student Name
    $sth = $dbh->prepare("select lastname,firstname from iep_student where studnum = ?");
    $sth->execute( $r{studnum} );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname ) = $sth->fetchrow;
  
    # Get Subject Name
    $sth = $dbh->prepare("select category from iep_objectives where catnum = ?");
    $sth->execute( $r{subnum} );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my $category = $sth->fetchrow;

    print qq{<table border="1" cellspacing="0" cellpadding="3">\n};

    print qq{<tr><td class="bra">$lex{Name}</td><td>$firstname $lastname</td></tr>\n};
    print qq{<tr><td class="bra">$lex{Category}</td><td>$category</td></tr>\n};
    print qq{<tr><td class="bra">$lex{Strategy}</td><td>$r{strategy}</td></tr>\n};
    print qq{<tr><td class="bra">$lex{Responsible}</td><td>$r{responsible}</td></tr>\n};
    print qq{<tr><td class="bra">$lex{Objective} 1</td><td>$r{obj1}</td></tr>\n};
    print qq{<tr><td class="bra">$lex{Objective} 2</td><td>$r{obj2}</td></tr>\n};
    print qq{<tr><td class="bra">$lex{Objective} 3</td><td>$r{obj3}</td></tr>\n};
    print qq{</table>\n};

    print "<p><b>$lex{'Number of dependent Evaluation Records'}: $evalcount</b><br>\n";
    print "$lex{'These records will be deleted also'}</p>\n";

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";
    print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";

    print "<p><em>$lex{'Are you sure you want to delete these records?'}</em></p>\n";
    print "<input type=\"submit\" value=\"$lex{'Yes, delete the records!'}\">\n";
    print "</form></body></html>\n";

    exit;

}


#---------------
sub deleteRecord {
#---------------

    my $id = shift; # passed id of record in evalmst to delete.

    # Get the student number and subject number (catnum)
    my $sth = $dbh->prepare("select studnum, subnum from iep_evalmst where id = ?");
    $sth->execute( $id );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr;}
    my ( $studnum, $subnum ) = $sth->fetchrow;

    # Now delete the record.
    $sth = $dbh->prepare("delete from iep_evalmst where id = ?");
    $sth->execute( $id );

    # We'll also delete the dependent records, too.
    $sth = $dbh->prepare("delete from iep_eval where studnum = ? and subnum = ?");
    $sth->execute( $studnum, $subnum );


    if ($DBI::errstr) {
	print "<h3>$lex{'Record Deletion Failed'}. $lex{Contact} $adminname.\n";
	print "$lex{Error} $DBI::errstr</h3>\n";
    } else {
	print "<h3>$lex{'Record deleted'}</h3>\n";
    }

    print "<p>[ <a href=\"$tchpage\">$lex{Main}</a> |\n";
    print "<a href=\"$self\">$lex{View}/$lex{Edit}/$lex{Delete} ";
    print "$lex{Objectives}</a> ]\n"; 

    print "</body></html>\n";

    exit;

}
