#!/usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Error' => 'Error',
	   'Add' => 'Add',
	   'Reading Tests' => 'Reading Tests',
	   'Student(s)' => 'Student(s)',
	   'Continue' => 'Continue',
	   'Category' => 'Category',	   
	   'Name' => 'Name',
	   'Save' => 'Save',
	   'Score' => 'Score',
	   'Test Date' => 'Test Date',
	   'No User Id' => 'No User Id',
	   'No Password' => 'No Password',
	   'Please Log In' => 'Please Log In',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Select' => 'Select',
	   'Blank=All' => 'Blank=All',
	   'Chk' => 'Chk',
	   'Record Exists' => 'Record Exists',
	   'Edit Record' => 'Edit Record',
	   'Required' => 'Required',
	   'Date and Reading Level' => 'Date and Reading Level',
	   'Only' => 'Only',
	   'No Blanks Allowed' => 'No Blanks Allowed',
	   'Skipping' => 'Skipping',
	   'Next Page' => 'Next Page',
	   'Record(s) Stored' => 'Record(s) Stored',


	   );

use DBI;
use CGI;
use CGI::Session;


my $self = 'fpAdd.pl';

my $q = new CGI;
my %arr = $q->Vars;

my @time = localtime(time);
my $year = $time[5] + 1900;
my $month = $time[4] + 1;
my $currdate = "$year-$month-$time[3]";


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Session Setup Here
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

# Get/Set  Session Values (a defined userid means it was passed)
if ( $arr{userid} ){ # we want to login, passed userid/password pair.

    # Check password/userid against database (-1 no user, -2 wrong password);
    my $error = checkPassword($arr{userid}, $arr{password});
    if ($error == -1){ print $q->header( -charset, $charset ); login($lex{'No User Id'}); }
    if ($error == -2){ print $q->header( -charset, $charset ); login($lex{'No Password'}); }

    $cookietime = checkCookieTime( $arr{duration} );

    # Set values for userid and logged_in in session
    $session->param( 'logged_in','1');
    $session->expire( 'logged_in', $cookietime );
    $session->param( 'userid',$arr{userid} );
    $session->param( 'duration',$cookietime );

    $userid = $arr{userid};


} else { # check logged_in value in session

    if ( not $session->param('logged_in') ){
	$userid = $session->param('userid');
        print $q->header( -charset, $charset );
        print $lex{'Please Log In'}. "</body></html>\n"; 
        exit;
    }
    # Ok, we have a login. Values below we have in environment.

    $userid = $session->param('userid');
    $duration = $session->param('duration');

    if ( not ($duration =~ /\+/)) { # if not in +20m format, do so.
	$duration = checkCookieTime( $duration );
    }

    $session->expire('logged_in', $duration );


} # End of check for logged_in value

print $session->header( -charset, $charset );

# Session Setup End

# Page Header
my $title = "$lex{Add} $lex{'Reading Tests'}";
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";

print "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" ";
print "href=\"/js/calendar-blue.css\" title=\"blue\">\n";
print "<script type=\"text/javascript\" src=\"/js/calendar.js\"></script>\n";
print "<script type=\"text/javascript\" src=\"/js/lang/calendar-en.js\"></script>\n";
print "<script type=\"text/javascript\" src=\"/js/calendar-setup.js\"></script>\n";
print "<style type=\"text/css\">td.ra { text-align:right; }
td.bcn { text-align:center;font-weight:bold;font-size:120%; }
</style>\n";

print "$chartype\n</head><body style=\"padding:1em 2em;\">\n";
print "[ <a href=\"$tchpage\">$lex{Main}</a> ]\n";
print "<h1>$title</h1>\n";


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    selectStudents();

}  elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    enterTests();

}  elsif ( $arr{page} == 3 ) {
    delete $arr{page};
    writeRecords();
}


#----------------
sub showStartPage {
#----------------


    # Start Form
    print "<form action=\"$self\" method=\"post\"> \n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    # Date
    print qq{<tr><td class="ra">$lex{'Test Date'}</td>\n};
    print qq{<td class="la"><input type="text" name="date" id="date" size="10" value="$currdate">\n};
    print qq{<button type="reset" id="start_trigger">...</button>\n};
    print qq{</td></tr>\n};

    # Season
    print qq{<tr><td class="ra">Season</td>\n};
    print qq{<td class="la"><select name="season"><option></option>\n};
    print "<option value=\"2014-fall\">2014 Fall</option>\n";
    print "<option value=\"2015-spring\">2015 Spring</option>";
    print "<option value=\"2015-fall\">2015 Fall</option>\n";

    print "<option value=\"2016-spring\">2016 Spring</option>";
    print "<option value=\"2016-fall\">2016 Fall</option>\n";
    print "<option value=\"2017-fall\">2017 Fall</option>";
    print "<option value=\"2017-spring\">2017 Spring</option>\n";

    print "<option value=\"2014-spring\">2014 Spring</option>";

    print "</select></td>\n";

    # Select Student
    print qq{<tr><td class="ra">$lex{Select} $lex{Student}</td>\n};
    print qq{<td><select name="groupname">};
    print "<option value=\"grade\">$lex{Grade}</option>\n";
    print "<option value=\"homeroom\">$lex{Homeroom}</option>\n";
    print "</select> \n";
    print "<input type=\"text\" name=\"groupvalue\" size=\"10\">$lex{'Blank=All'}</td></tr>\n";

    # Next Page Checked.
    print qq{<tr><td class="ra">$lex{Chk} $lex{'Next Page'}</td>\n};
    print qq{<td><input type="checkbox" name="chk" value="checked">\n};
    print qq{</td></tr>\n};    

    print "<tr><td></td><td>\n<input type=\"submit\" value=\"$lex{Continue}\"></td></tr>\n";

    print "</table></form>\n";

    print "<script type=\"text/javascript\">
     Calendar.setup({
        inputField     :    \"date\", // id of the input field
        ifFormat       :    \"%Y-%m-%d\", // format of the input field
        button         :    \"start_trigger\", // trigger for the calendar (button ID)
        singleClick    :    false,        // double-click mode
        step           :    1             // show all years in drop-down boxes 
    });
   </script>\n";

    print "</body></html>\n";

    exit;

} # end of showStartPage



#----------------
sub selectStudents {
#----------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }    


    my $groupvalue = $arr{groupvalue};
    delete $arr{groupvalue};
    my $chk = $arr{chk};
    delete $arr{chk};

    my $select;
    if ( $groupvalue ) { # we're picking a group
	if ( $arr{groupname} eq 'grade' ) {
	    $select = 'where grade = ?';
	} else {
	    $select = 'where homeroom = ?';
	}
    }

    my $sth = $dbh->prepare("select lastname, firstname, studnum from student
      $select order by lastname, firstname");
    if ( $select ) {
	$sth->execute( $groupvalue );
    } else {
	$sth->execute;
    }
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }


    # Form Header
    print "<form action=\"$self\" method=\"post\"> \n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";
    print "<input type=\"hidden\" name=\"date\" value=\"$arr{date}\">\n";
    print "<input type=\"hidden\" name=\"season\" value=\"$arr{season}\">\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    print "<tr><td class=\"la\"><input type=\"submit\" value=\"$lex{Continue}\">";
    print "</td></tr>\n";


    while ( my ( $lastname, $firstname, $studnum ) = $sth->fetchrow ) {

	print "<tr><td class=\"la\">";
	print "<input type=\"checkbox\" name=\"$studnum\" value=\"1\" $chk> ";
	print "<b>$lastname</b>, $firstname ($studnum)</td></tr>\n";

    }

    print "<tr><td class=\"la\"><input type=\"submit\" value=\"$lex{Continue}\">";
    print "</td></tr>\n";

    print "</table></form></body></html>\n";

    exit;

} # end of selectStudents



#-------------
sub enterTests {
#-------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $defaultdate = $arr{date};
    delete $arr{date};
    my $defaultseason = $arr{season};
    delete $arr{season};
    # Now only student numbers left in hash...



    my $sth = $dbh->prepare("select lastname, firstname from student where studnum = ?");

    # Create a hash for sorting.
    my %sorted;
    foreach my $studnum ( sort keys %arr ) {
	# Get Student Name
	$sth->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my ( $lastname, $firstname ) = $sth->fetchrow;
	$sorted{"$lastname$firstname$studnum"} = $studnum;
    }


    # Start Form
    print "<form action=\"$self\" method=\"post\"> \n";
    print "<input type=\"hidden\" name=\"page\" value=\"3\">\n";

    print "<div style=\"text-align:left;\">";
    print "<input type=\"submit\" value=\"$lex{Save}\"></div>\n";

    print qq{<table cellspacing="0" cellpadding="3" border="1">\n};
    print qq{<tr><th>Student</th><th>Test<br>Date</th><th>Type</th><th>Level</th>\n};
    print qq{<th>Accuracy</th><th>Comprehension<br>A-K /7 L-Z /10</th><th>Fluency<br>/3</th>};
    print qq{<th>Fiction/<br>NF</th><th>Rec<br>Placement</th>\n};
    print qq{<th>Letter Id /52</th><th>Sounds /26</th><th>High Freq<br>Words</th>\n};
    print qq{<th>Comment</th></tr>\n\n};


    foreach my $key ( sort keys %sorted ) {
	my $studnum = $sorted{$key};

	# Get Student Name
	$sth->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my ( $lastname, $firstname ) = $sth->fetchrow;

	# Print Table Header and Heading values
	print qq{<tr><td class="la"><b>$lastname</b>, $firstname</td>\n};


	# Test Date
	my $trigger = $studnum. '_trigger';
	my $idfield = $studnum. '_date';
	print qq{<td><input type="text" name="$studnum:date" id="$idfield" size="8" value="$defaultdate">\n};
	print qq{<button type="reset" id="$trigger">...</button><br>\n};

	# Season
	print qq{<select name="$studnum:season"><option>$defaultseason</option>\n};

	print "<option value=\"2014-fall\">2014 Fall</option>\n";
	print "<option value=\"2015-spring\">2015 Spring</option>";
	print "<option value=\"2015-fall\">2015 Fall</option>\n";

	print "<option value=\"2016-spring\">2016 Spring</option>";
	print "<option value=\"2016-fall\">2016 Fall</option>\n";
	print "<option value=\"2017-fall\">2017 Fall</option>";
	print "<option value=\"2017-spring\">2017 Spring</option>\n";

	print "<option value=\"2014-spring\">2014 Spring</option>";
	print qq{</select>\n};

	print qq{</td>\n};


	# Type
	print qq{<td class="la"><input type="radio" name="$studnum:type" value="Independent">Indep<br>\n};
	print qq{<input type="radio" name="$studnum:type" value="instructional">Instr<br>\n};
	print qq{<input type="radio" name="$studnum:type" value="hard">Hard</td>\n};

	# Level
	print "<td class=\"la\"><select name=\"$studnum:level\"><option></option>";
	foreach my $letter ('A'..'Z'){ print "<option>$letter</option>"; }
	print "</select></td>\n";

	# Accuracy
	print "<td class=\"la\"><input type=\"text\" size=\"6\" name=\"$studnum:accuracy\"></td>\n";


	# Comprehension
	print "<td class=\"la\"><input type=\"text\" size=\"12\" name=\"$studnum:comprehension\"></td>";


	# Fluency
	print "<td><select name=\"$studnum:fluency\"><option></option>";
	for my $i (0..3) { print "<option>$i</option>"; }
	print "</select></td>\n";

	# Writing about reading?
=head
	print "<tr><td class=\"bra\">Writing About Reading</td>\n<td class=\"la\">";
	print "<select name=\"$studnum:writeread\"><option></option>";
	for my $i (0..3) { print "<option>$i</option>"; }
	print "</select></td></tr>\n";
=cut

	# Fiction/NonFiction
	print qq{<td class="la"><input type="radio" name="$studnum:fictnonfict" value=\"fiction\">Fiction<br>\n};
	print qq{<input type="radio" name="$studnum:fictnonfict" value="nonfiction"> NF};
	print qq{</td>\n};

	# Recommended Placement
	print qq{<td class="la"><select name="$studnum:recplacement\"><option></option>};
	foreach my $letter ('A'..'Z'){ print "<option>$letter</option>"; }
	print "</select></td>\n";


	# Letter Id
	print qq{<td class="la"><input type="text" name="$studnum:letterid" maxlength="48" size="12"></td>\n};

	# Sounds
	print qq{<td class="la"><input type="text" name="$studnum:sounds" maxlength="255" size="8"></td>\n};

	# High Frequency Words
	print qq{<td class="la"><input type="text" name="$studnum:hfw" maxlength="48" size="16"></td>\n};


	# Comments
	print qq{<td class="la" style="padding:0;">};
	print qq{<textarea style="padding:0;margin:0;" name="$studnum:comment" rows="3" cols="20">};
	print qq{</textarea></td></tr>\n};
    

	print "<script type=\"text/javascript\">
         Calendar.setup({
         inputField     :    \"$idfield\", // id of the input field
         ifFormat       :    \"%Y-%m-%d\", // format of the input field
         button         :    \"$trigger\", // trigger for the calendar (button ID)
         singleClick    :    false,        // double-click mode
         step           :    1             // show all years in drop-down boxes 
        });
        </script>\n";

    } # Student Entry Loop

    print qq{</table>\n};
    print "<div style=\"text-align:left;\">";
    print "<input type=\"submit\" value=\"$lex{Save}\"></div>\n";
	
    print "</form></body></html>\n";

    exit;

}


#---------------
sub writeRecords {
#---------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    # exit;

    my $sth1 = $dbh->prepare("select lastname, firstname, grade from student where studnum = ?");

    # check for any missing values
    my @required = (); # qw(date level type ); # accuracy comprehension fluency fictnonfict);
    my $failflag;

    foreach my $key ( sort keys %arr ) {

	my $failvalue;

	my ( $studnum, $val ) = split(/:/, $key);
	if ( $val ne 'comment' ) { next; }
	# use this $studnum value to check for missing required fields 

	foreach my $field ( @required ) {
	    if ( not $arr{"$studnum:$field"} ) {
		if ( $field eq 'fluency' ) { next; } # zero problems we skip
		$failvalue .= "$field, ";
	    }
	}

	if ( $failvalue ) { # get name, and print error
	    $sth1->execute( $studnum );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    my ($lastname, $firstname, $grade ) = $sth1->fetchrow;
	    print "<div><b>Missing Values</b> for $firstname $lastname  <b>Fields</b>:$failvalue</div>\n";
	    $failflag = 1;
	}
    }


    if ( $failflag ) {
	print qq{</body></html>\n};
	exit;
    }


    # Setup to Write the record
    my $sth = $dbh->prepare("insert into read_test_fp ( studnum, tdate, tauthor, tgrade, tlevel,
     ttype, accuracy, comprehension, fluency, fictnonfict, tcomment, season, letterid, hfw, recplacement,sounds )
     values ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?) "); 
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }



    foreach my $key ( sort keys %arr ) {

	my ( $studnum, $val ) = split(/:/, $key);
	if ( $val ne 'comment' ) { next; }

	# Get Name, grade
	$sth1->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my ($lastname, $firstname, $grade ) = $sth1->fetchrow;
	

	$sth->execute( $studnum, $arr{"$studnum:date"}, $userid, $grade, 
		       $arr{"$studnum:level"},
		       $arr{"$studnum:type"},
		       $arr{"$studnum:accuracy"},
		       $arr{"$studnum:comprehension"},
		       $arr{"$studnum:fluency"},
		       $arr{"$studnum:fictnonfict"},
		       $arr{"$studnum:comment"},
		       $arr{"$studnum:season"},
		       $arr{"$studnum:letterid"},
		       $arr{"$studnum:hfw"},
		       $arr{"$studnum:recplacement"},
		       $arr{"$studnum:sounds"},

	    );

	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    
    }

    print "<h3>$lex{'Record(s) Stored'}</h3>\n";

    print "<p>[ <a href=\"$self\">$lex{Add} $lex{'Reading Tests'}</a> |\n";
    print "<a href=\"$tchpage\">$lex{Main}</a> ]</p>\n";
    print "</body></html>\n";

    exit;

}
