#!/usr/bin/perl
#  Copyright 2001-2016 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Edit Attendance' => 'Edit Attendance',
	   'Main' => 'Main',
	   'Student Number' => 'Student Number',
	   'Date' => 'Date',
	   'Absent' => 'Absent',
	   'Reason' => 'Reason',
	   'Period' => 'Period',
	   'Subject' => 'Subject',
	   'Section' => 'Section',
	   'Late' => 'Late',
	   'min' => 'min',
	   'Update Record' => 'Update Record',
	   'Record Updated' => 'Record Updated',
	   'Homeroom Attendance' => 'Homeroom Attendance',
	   'Subject Attendance' => 'Subject Attendance',
	   'Please Log In' => 'Please Log In',
	   'Error' => 'Error',
	   'Contact' => 'Contact',
	   'Missing Data' => 'Missing Data',
	   'Edit' => 'Edit',

	   );

$self = 'tatted.pl';

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;


# Setup Session
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

# Get Session Values (a defined userid means it was passed)
if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header( -charset, $charset );
    print "$doctype\n<html><head><title>". $lex{'Edit Attendance'}. "</title>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";
    print "$chartype\n</head><body>[ <a href=\"$tchpage\">$lex{Main}</a> ]\n";

    print "<h1>$lex{'Please Log In'}</h1>\n";
    print "</body></html>\n";
    exit;
}
# Ok, we have a login. Values below we have in environment.

my $userid = $session->param('userid');
my $duration = $session->param('duration');
if (not ($duration =~ m/\+/)) {
    $duration = '+'. $duration. 'm';
}
$session->expire('logged_in',$duration);
print $session->header( -charset, $charset );


print qq{$doctype\n<html><head><title>$lex{'Edit Attendance'}</title>\n};
print qq{<link rel="stylesheet" href="$tchcss" type="text/css">\n};
print qq{$chartype\n</head><body>\n};
print qq{[ <a href="$tchpage">$lex{Main}</a> ]\n};


if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    updateRecord();
}


$sth = $dbh->prepare("select * from attend where attid = ?"); 
$sth->execute( $arr{id} );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
@arr = $sth->fetchrow;

my $sth1 = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");
$sth1->execute( $arr[1] );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my ($lastname, $firstname) = $sth1->fetchrow;


print qq{<h1>$lex{'Edit Attendance'}</h1>\n};

print qq{<form action="$self" method="post">\n};
print qq{<input type="hidden" name="id" value="$arr[0]">\n};
print qq{<input type="hidden" name="writeflag" value="1">\n};


print qq{<table cellpadding="3" cellspacing="0" border="0">\n};
print qq{<caption><b>$firstname $lastname</b></caption>\n};

print qq{<tr><td></td><td class="la">};
print qq{<input type="submit" value="$lex{'Update Record'}"></td></tr>\n};

#print qq{<tr><td class="bra">$lex{'Student Number'}</td>\n"};
#print qq{<td><input type="text" name="studentid" size="8" value="$arr[1]"></td></tr>\n};

print qq{<tr><td class="bra">$lex{Date} $lex{Absent}</td>\n};
print qq{<td><input type="text" name="absdate" size="12" value="$arr[2]"></td></tr>\n};

print qq{<tr><td class="bra">$lex{Reason}</td>\n};
print qq{<td><select name="reason"><option>$arr[3]</option>\n};

foreach my $reason (@attend){
  print "<option>$reason</option>\n";
}

print qq{</select></td></tr>\n};

print qq{<tr><td class="bra">$lex{Period}</td>\n};
print qq{<td><input type="text" name="period" size="4" value="$arr[4]"></td></tr>\n};

print qq{<tr><td class="bra">$lex{Subject} $lex{Section}</td>\n};
print qq{<td><input type="text" Name="subjsec" size="8" value="$arr[5]"></td></tr>\n};

print qq{<tr><td class="bra">$lex{Late} ($lex{min})</td>\n};
print qq{<td><input type="text" name="late" size="6" value="$arr[6]"></td></tr>\n};

print qq{<tr><td></td><td class="la">};
print qq{<input type="submit" value="$lex{'Update Record'}"></td></tr>\n};

print qq{</table></form>\n};
print qq{</body></html>\n};




#---------------
sub updateRecord {
#---------------

    #foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    if ( not $arr{reason} or not $arr{absdate} or not $arr{period} or not $arr{subjsec} ) {
	print qq{<h3>$lex{Error}: $lex{'Missing Data'}</h3>\n};
	print qq{<div><b>$lex{Reason}</b>:$arr{reason} <b>$lex{Date}</b>:$arr{absdate} <b>$lex{Period}</b>:$arr{period} "};
	print qq{$lex{Subject}-$lex{Section}: $arr{subjsec}</div>\n};
	print qq{</body></html>\n};
	exit;
    }


    $sth = $dbh->prepare("update attend set absdate=?, reason=?, period=?, subjsec=?, late=?
     where attid = ?");
    $sth->execute( $arr{absdate}, $arr{reason}, 
      $arr{period}, $arr{subjsec}, $arr{late}, $arr{id} );

    if (not $DBI::errstr ) {
	print "<h3>$lex{'Record Updated'}</h3>";
    } else {
	print qq{<h3>$lex{Error}: $DBI::errstr<br>\n};
	print qq{$lex{'Contact'} $adminname <a href=\"mailto:$adminemail\">$adminemail</a>\n};

    }

    print qq{<p>[ <a href="tattdeled.pl">$lex{Edit} {'Homeroom Attendance'}</a> |\n};
    print qq{<a href="tattsubjed.pl">$lex{Edit} $lex{'Subject Attendance'}</a> ]</p>\n};
    print qq{</body></html>\n};

    exit;

} # End of updateRecord
