#!/usr/bin/perl
#  Copyright 2001-2015 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Discipline Records' => 'Discipline Records',
	   'Main' => 'Main',
	   'Discipline Record' => 'Discipline Record',
	   'Edit' => 'Edit',
	   'If Repeated' => 'If Repeated',
	   'Error' => 'Error',
	   'Parent' => 'Parent',
	   
	   );

use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = CGI->new;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
    $yday, $iddst) = localtime(time);
$year = $year + 1900;
$wday++;
$mon++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;


my $sth = $dbh->prepare("select count(*) from staff as s, staff_multi as sm
 where s.password = ? and s.userid = sm.userid and field_name = 'position' and
 field_value = ?");

$sth->execute( $arr{password}, 'Classroom Teacher' );
if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->fetchrow;
if ($rows < 1){

    # Print HTML Header
    print "$doctype\n<html><head><title>Student Infractions by Date</title>
    <link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
    $chartype\n</head><body>[ <a href=\"$tchpage\">Main</a> ]\n";
    print "<h1>Password not found or User not teacher.</h1>\n";
    print"<form><input type=\"button\" ";
    print"onclick=\"javascript:history.back()\" value=\"Back!\">";
    print"</form></center></body></html>";
    die;
}

# we have a password, do we also have a room number

if ($arr{homeroom}) {
    $sth = $dbh->prepare("select * from discipline,staff,student
     where (staff.userid = discipline.author
     or staff.userid =  (substr(author, instr(author,'(')+1, instr(author,')')- instr(author,'(')-1   ) )    
      ) 
     and staff.password = '$arr{password}'
     and discipline.userid = student.studnum
     and student.homeroom = '$arr{homeroom}'
     and (discipline.private <> 'Y' or discipline.private IS NULL)
     and discipline.date >= '$schoolstart'
     order by discipline.userid, discipline.date desc");

} else {

    $sth = $dbh->prepare("select * from discipline,staff
     where (staff.userid = discipline.author
      or staff.userid = (substr(author, instr(author,'(')+1, instr(author,')')- instr(author,'(')-1   ) )
      )
     and staff.password = ?
     and (discipline.private <> 'Y' or discipline.private IS NULL)
     and discipline.date >= '$schoolstart'
     order by discipline.userid, discipline.date desc");
}
 

$sth->execute( $arr{password} );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

my $title = "$lex{Edit} $lex{'Discipline Records'}";
print qq{$doctype\n<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="$tchcss" type="text/css">\n};
print qq{$chartype\n</head>\n};
print qq{<body>[ <a href="$tchpage">$lex{Main}</a> ]\n};

print qq{<h1>$title</h1><h3>$currdate</h3>\n};

print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{'Discipline Record'}. "</th><th>". $lex{Edit}. "</th></tr>\n";

while ( my @arr = $sth->fetchrow ) {

    $sth1 = $dbh->prepare("select * from studentall where studnum = ?");
    $sth1->execute( $arr[2] );
    my @student = $sth1->fetchrow;
  
    print "<tr><td> <i>$arr[1]:</i> $student[1] $student[2] - [<b>  $arr[3]</b> ] ";
    print "($arr[8]) $arr[4] $arr[5] <i>". $lex{'If Repeated'}. ",</i> $arr[6] <i>";
    print $lex{Parent}. ":</i> $arr[7]</td>\n";
    print "<td><a href=\"tdisced0.pl?id=$arr[0]\">". $lex{Edit}. "</a></td></tr>\n";

}

print "</table></center></body></html>\n";
