#!/usr/bin/perl
#  Copyright 2001-2017 Leslie Richardson

#  Export vars from confsystem into a file.

use DBI;


my ($password, $db, $file) = @ARGV;

if ( not $password ) {
    print "Usage: ./exportconfsystem.pl password dbase file\n";
    exit;
}


if ( not $db or not $file ) {
    print "Missing database name or filename\n";
    exit;
}

open(my $fh, ">", $file) or
    die("Cannot open $file: $!\n");

$user = 'root';
$dbtype = 'mysql';

my $dsn = "DBI:$dbtype:dbname=$db";
my $dbh = DBI->connect($dsn,$user,$password);

my $sth = $dbh->prepare("select * from conf_system order by filename, sectionname, sequenceval");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

while ( my $ref = $sth->fetchrow_hashref ) {
    my %r = %$ref;
    foreach my $key ( keys %r ) {
	$r{$key} = $dbh->quote( $r{$key} );
    }
    print $fh qq{insert into temp_conf_system (filename, sectionname, sequenceval, dataname, datatype, datavalue, version, description )\n values(};
    print $fh qq{$r{filename}, $r{sectionname}, $r{sequenceval}, $r{dataname}, $r{datatype}, $r{datavalue}, $r{version}, $r{description} ); \n};

}

close $fh;
